C------------------- ANGMAX ------------------------------
      FUNCTION ANGMAX(E,IXY,DSRP2,SIG)
C  MAXIMUM DISRUPTION ANGLE OF LOW ENERGY PARTICLES
C  THEORETICAL/EMPIRICAL
C  E=(LOW ENERGY PARTICLE ENERGY)/(INITIAL ENERGY)
C      E<0 FOR UNLIKE CHARGE
      DIMENSION DSRP2(2),SIG(3)
      DATA SQRT3/1.7320508E0/
      THETA0=DSRP2(IXY)*SIG(IXY)/SIG(3)
      IF(E.LE.0) GOTO 100
      ANGMAX=THETA0/E/SQRT(1+(0.75*DSRP2(IXY)/E)**(4./3.))
      RETURN
  100 E1=-E
      CL=MAX(LOG(4*SQRT3*DSRP2(1)/E1),1.0)
      ANGMAX=THETA0*SQRT(CL/(SQRT3*E1*DSRP2(1)))
      RETURN
      END
