C   24/06/87 807201628  MEMBER NAME  COULMB   *.FORT        FORTRAN77   0000
      SUBROUTINE COULMB(NP,DX,DY,NTS,MT,MT1,NT,LOS1,                    0000
     %    MAXPH,IRR,RMIN2,AA,ZMIN,ZMAX,NPZ,NPZ0,                        0000
     %    XY,XY0,FXY,XYTS,ZTS,ETS,ITTS,LTSRAD,XYPH,EPH)                 0000
C  SOLVE EQUATION OF MOTION USING COULOMB'S LAW.                        0000
      INTEGER NPZ(2),NPZ0(2),ITTS(NTS)                                  0000
      REAL*4 AA(2),ZMIN(2),ZMAX(2)                                      0000
      REAL*4 XY(NP,2,2),XY0(NP,2,2),FXY(NP,2,2),                        0000
     %   XYTS(0:MT,NTS,2),ZTS(NTS),ETS(0:MT,NTS),                       0000
     %   XYPH(MAXPH,4,2),EPH(MAXPH,2)                                   0000
      REAL*8 E1                                                         0000
C                                                                       0000
      NT1=NT+1                                                          0000
      DO 400 L=1,2                                                      0000
      L2=3-L                                                            0000
      DO 300 I1=NPZ0(L),NPZ(L)                                          0000
      DDX=0.0                                                           0000
      DDY=0.0                                                           0000
      DO 200 I2=NPZ0(L2),NPZ(L2)                                        0000
      DX1=XY0(I1,1,L)-XY0(I2,1,L2)                                      0000
      DY1=XY0(I1,2,L)-XY0(I2,2,L2)                                      0000
      DDD=MAX(RMIN2,(DX1*DX)**2+(DY1*DY)**2)                            0000
      DDX=DDX+DX1/DDD                                                   0000
      DDY=DDY+DY1/DDD                                                   0000
  200 CONTINUE                                                          0000
      FXY(I1,1,L)=DDX*AA(L2)                                            0000
      FXY(I1,2,L)=DDY*AA(L2)                                            0000
  300 CONTINUE                                                          0000
  400 CONTINUE                                                          0000
C                                                                       0000
      IF(NTS.EQ.0) GOTO 1400                                            0000
      L2=2                                                              0000
      DO 1340 I=1,NTS                                                   0000
      IF(NT.LT.ITTS(I)) GOTO 1340                                       0000
      IF(ZTS(I).LT.ZMIN(1).OR.ZTS(I).GE.ZMAX(1)) GOTO 1340              0000
      DDX=0.0                                                           0000
      DDY=0.0                                                           0000
      DO 1300 I2=NPZ0(L2),NPZ(L2)                                       0000
      DX1=XYTS(NT1-MT1,I,1)-XY0(I2,1,L2)                                0000
      DY1=XYTS(NT1-MT1,I,2)-XY0(I2,2,L2)                                0000
      DDD=MAX(RMIN2,(DX1*DX)**2+(DY1*DY)**2)                            0000
      DDX=DDX+DX1/DDD                                                   0000
      DDY=DDY+DY1/DDD                                                   0000
 1300 CONTINUE                                                          0000
      DDX=DDX*AA(L2)                                                    0000
      DDY=DDY*AA(L2)                                                    0000
      DD=(DX*DDX)**2+(DY*DDY)**2                                        0000
      DDX=DDX/ETS(NT1-MT1,I)                                            0000
      DDY=DDY/ETS(NT1-MT1,I)                                            0000
      XYTS(NT1-MT1+1,I,1)=XYTS(NT1-MT1+1,I,1)-DDX                       0000
      XYTS(NT1-MT1+1,I,2)=XYTS(NT1-MT1+1,I,2)-DDY                       0000
      IF(LTSRAD.NE.0) THEN                                              0000
          E1=ETS(NT1-MT1+1,I)                                           0000
          CALL RADLOS(DD,E1,LOS1,IRR,0,0,MAXPH,IDMM,EPH,XYPH,NP,XY,XY0, 0000
     %                DMM,IDMM,IDMM,IDMM,IDMM,IDMM,IDMM)                0000
          ETS(NT1-MT1+1,I)=E1                                           0000
        ENDIF                                                           0000
 1340 CONTINUE                                                          0000
 1400 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
