      SUBROUTINE EQMLEP(NOKICK,NLEP,MAXLEP,IDLE,LEOR,EELE,XYLE,
     %   NPZ0,NPZ,KFLD,NX,NY,IXM,IYM,BLEND,CENT,AA,
     %   DX,DY,DT,SIG,Q,QX,PHI,EX,EY)
C  MOTION OF LOW ENERGY PARTICLES
      PARAMETER (MQMXY=5)
      DIMENSION IDLE(NLEP),LEOR(NLEP),EELE(NLEP),XYLE(MAXLEP,2,2)
      DIMENSION BLEND(2),IXM(2,2),IYM(2,2),NPZ0(2),NPZ(2),AA(2)
      DIMENSION EX(0:NX,2),EY(NX,0:NY,2),SIG(3,2),CENT(2)
      REAL*8 Q(NX,NY,2),QX(NX,2),PHI(NX,NY,2)
      COMPLEX*8 QMXY(0:MQMXY),C1,C2,CSUM
C
CNOKICK
          IF(NOKICK.EQ.1) RETURN
CNOKICK
      IF(NLEP.LE.0) RETURN
      L1=1
      L2=3-L1
      NPZ1=NPZ0(L1)
      NPZ2=NPZ(L1)
      CFX=AA(L2)/DX**2
      CFY=AA(L2)/DY**2
      ALLOWX=0.3*SIG(1,L2)/DX
      ALLOWY=0.3*SIG(2,L2)/DY
      DIAG2=(NX*DX/2)**2+(NY*DY/2)**2
      NLEOUT=0
      DO 600 N=1,NLEP
      II=IDLE(N)
      IF(II.LT.NPZ1.OR.II.GT.NPZ2) GOTO 600
      E1=EELE(N)
      IF(LEOR(N).LT.0) E1=-E1
      X0=XYLE(N,1,1)
      XP0=XYLE(N,2,1)
      Y0=XYLE(N,1,2)
      YP0=XYLE(N,2,2)
CNEW
      IF( XP0.EQ.0.) THEN
             XP0SLP = XP0
        ELSE
            IF( ABS(COS(XP0*DX/DT)).LT.1.E-06 ) THEN
             PRINT *,'COS in EQMLEP =',COS(XP0*DX/DT)
             PRINT *,'XP0*DX/DT     =',    XP0*DX/DT
             XP0SLP = 1.E-06*DT/DX
              ELSE
            XP0SLP = TAN(XP0*DX/DT)*DT/DX
            ENDIF
      ENDIF
      IF( YP0.EQ.0.) THEN
             YP0SLP = YP0
        ELSE
            IF( ABS(COS(YP0*DY/DT)).LT.1.E-06 ) THEN
             PRINT *,'COS in EQMLEP =',COS(YP0*DY/DT)
             PRINT *,'YP0*DX/DT     =',    YP0*DY/DT
             YP0SLP = 1.E-06*DT/DY
              ELSE
            YP0SLP = TAN(YP0*DY/DT)*DT/DY
            ENDIF
      ENDIF
CNEW
      IREP=0
  200 IREP=IREP+1
CBETA       BETA = 1. - (XP0SLP*DX/DT)**2 - (YP0SLP*DY/DT)**2
CBETA       IF(BETA.GT.0.) THEN
CBETA       BETA = SQRT(BETA)
CBETA       ELSE
CBETA       BETA = 0.
CBETA       ENDIF
      X1=X0-BLEND(1)
      Y1=Y0-BLEND(2)
      IX1=NINT(X1)
      IY1=NINT(Y1)
      IF(KFLD.EQ.3) GOTO 300
      IF(IX1.LT.0.OR.IX1.GE.NX) GOTO 240
      IF(IY1.LT.0.OR.IY1.GE.NY) GOTO 240
C  2-DIM CASE (KFLD=0,1)
      IX=MAX(1,MIN(NX-2,IX1))
      IY=MAX(1,MIN(NY-2,IY1))
      PX1=X1-IX
      PY=Y1-IY
      IF(PY.GE.0) THEN
          QY=1.0-PY
          PHX1=QY*PHI(IX  ,IY+1,L2)+PY*PHI(IX  ,IY+2,L2)
          PHX2=QY*PHI(IX+1,IY+1,L2)+PY*PHI(IX+1,IY+2,L2)
          PHX3=QY*PHI(IX+2,IY+2,L2)+PY*PHI(IX+2,IY+2,L2)
        ELSE
          QY=1.0+PY
          PHX1=QY*PHI(IX  ,IY+1,L2)-PY*PHI(IX  ,IY,L2)
          PHX2=QY*PHI(IX+1,IY+1,L2)-PY*PHI(IX+1,IY,L2)
          PHX3=QY*PHI(IX+2,IY+1,L2)-PY*PHI(IX+2,IY,L2)
        ENDIF
      FX1=CFX*((0.5+PX1)*(PHX3-PHX2)+(0.5-PX1)*(PHX2-PHX1))
      IF(PX1.GE.0) THEN
          PX2=1.0-PX1
          PHY1=PX2*PHI(IX+1,IY  ,L2)+PX1*PHI(IX,IY  ,L2)
          PHY2=PX2*PHI(IX+1,IY+1,L2)+PX1*PHI(IX,IY+1,L2)
          PHY3=PX2*PHI(IX+1,IY+2,L2)+PX1*PHI(IX,IY+2,L2)
        ELSE
          PX2=1.0+PX1
          PHY1=PX2*PHI(IX+1,IY  ,L2)-PX1*PHI(IX,IY  ,L2)
          PHY2=PX2*PHI(IX+1,IY+1,L2)-PX1*PHI(IX,IY+1,L2)
          PHY3=PX2*PHI(IX+1,IY+2,L2)-PX1*PHI(IX,IY+2,L2)
        ENDIF
      FY1=CFY*((0.5+PY)*(PHY3-PHY2)+(0.5-PY)*(PHY2-PHY1))
      DIST=0
      GOTO 500
C  OUT OF MESH
  240 X2=X0-CENT(1)
      Y2=Y0-CENT(2)
      IF((X2*DX)**2+(Y2*DY)**2.GE.DIAG2) GOTO 260
      X3=X1+1
      Y3=Y1+1
      DDX=0
      DDY=0
      DIST=MAX(MIN(ABS(X3-IXM(1,L2)),ABS(X3-IXM(2,L2))),
     %         MIN(ABS(Y3-IYM(1,L2)),ABS(Y3-IYM(2,L2))))
      DO 250 IY=IYM(1,L2),IYM(2,L2)
      DO 250 IX=IXM(1,L2),IXM(2,L2)
      DX3=X3-IX
      DY3=Y3-IY
      DDD=(DX3*DX)**2+(DY3*DY)**2
      DDX=DDX+Q(IX,IY,L2)*DX3/DDD
      DDY=DDY+Q(IX,IY,L2)*DY3/DDD
  250 CONTINUE
      GOTO 290
  260 NLEOUT=NLEOUT+1
      SCALXY=1E-6
      IF(NLEOUT.EQ.1) CALL QMXYEX(MQMXY,QMXY,Q(1,1,L2),NX,NY,
     %     IXM(1,L2),IYM(1,L2),SCALXY,DX,DY)
      DIST=MAX(ABS(X2),ABS(Y2))
      C1=SCALXY/CMPLX(DX*X2,DY*Y2)
      C2=C1
      CSUM=QMXY(0)*C1
      DO 270 NM=1,MQMXY
      C2=C2*C1
  270 CSUM=CSUM+QMXY(NM)*C2
  280 DDX=REAL(CSUM)/(DX*SCALXY)
      DDY=-IMAG(CSUM)/(DY*SCALXY)
  290 FX1=-DDX*AA(L2)
      FY1=-DDY*AA(L2)
      GOTO 500
C  FLAT BEAM (KFLD=3)
  300 IF(IX1.LT.0.OR.IX1.GE.NX) GOTO 340
      IF(IY1.LT.0.OR.IY1.GE.NY) GOTO 340
      PX1=X1-IX1
      PY=Y1-IY1
      FX1=CFX*((0.5+PX1)*EX(IX1+1,L2)+(0.5-PX1)*EX(IX1,L2))
      FY1=CFY*((0.5+PY)*EY(IX1+1,IY1+1,L2)+(0.5-PY)*EY(IX1+1,IY1,L2))
      DIST=0
      GOTO 500
C  OUT OF MESH
  340 NLEOUT=NLEOUT+1
      DDX=0
      DDY=0
      X3=X1+1
      DY3=Y0-CENT(2)
      DIST=MAX(MIN(ABS(X3-IXM(1,L2)),ABS(X3-IXM(2,L2))),ABS(DY3))
      DDD2=(DY3*DY)**2
      DO 360 IX=IXM(1,L2),IXM(2,L2)
      DX3=X3-IX
      DDD=(DX3*DX)**2+DDD2
      DDX=DDX+QX(IX,L2)*DX3/DDD
      DDY=DDY+QX(IX,L2)*DY3/DDD
  360 CONTINUE
      FX1=-DDX*AA(L2)
      FY1=-DDY*AA(L2)
      GOTO 500
  500 FX1=FX1/E1
      FY1=FY1/E1
      ALX=ALLOWX+0.5*DIST
      ALY=ALLOWY+0.5*DIST
      IF(IREP.EQ.1) THEN
          DT1=1
CNEW
          IF(XP0.NE.0) DT1=MIN(DT1,(ALX/XP0SLP)**2)
          IF(YP0.NE.0) DT1=MIN(DT1,(ALY/YP0SLP)**2)
CNEW
C corrected in 12/12/91
          IF(FX1.NE.0) DT1=MIN(DT1,ABS(ALX/FX1)*2)
          IF(FY1.NE.0) DT1=MIN(DT1,ABS(ALY/FY1)*2)
C corrected in 12/12/91
          NREP=INT(1/SQRT(DT1)+1.0)
          DT1=1.0/NREP
          DT2=DT1**2/2
C           WRITE(6,998) LLLL,NREP,E1,XP0,YP0,FX1,FY1
C 998       FORMAT(1X,I1,'REP=',I5,' E1=',F9.6,' XP,YP=',1P2E9.2,
C    %             ' FXY=',1P2E9.2)
        ENDIF
CBETA       FX1 = FX1*BETA
CBETA       FY1 = FY1*BETA
CNEW
      X0=X0+XP0SLP*DT1+FX1*DT2
      Y0=Y0+YP0SLP*DT1+FY1*DT2
CNEW
C         XP0=XP0+FX1*DT1
C         YP0=YP0+FY1*DT1
      XP0SLP=XP0SLP + FX1*DT1
      YP0SLP=YP0SLP + FY1*DT1
CNEW
      IF(IREP.NE.NREP) GOTO 200
C corrected in 12/12/91
      XP0 = ATAN( XP0SLP*DX/DT )
      IF( XP0.LT. 0. ) XP0 = XP0 + 3.14159265
      YP0 = ATAN( YP0SLP*DY/DT )
      IF( YP0.LT. 0. ) YP0 = YP0 + 3.14159265
      XP0 = XP0/DX*DT
      YP0 = YP0/DY*DT
C corrected in 12/12/91
      XYLE(N,1,1)=X0
      XYLE(N,1,2)=Y0
      XYLE(N,2,1)=XP0
      XYLE(N,2,2)=YP0
C           WRITE(6,999)  E1,XP0,YP0,FX1,FY1
C 999       FORMAT(11X,' E1=',F9.6,' XP,YP=',1P2E9.2,
C    %             ' FXY=',1P2E9.2)
  600 CONTINUE
      RETURN
      END
