C   14/04/87 812161325  MEMBER NAME  FITES    *.FORT     M  FORTRAN77   0000
C******************** FITES ********************************************0000
      SUBROUTINE FITES(KK,NBIN,FBIN,EMIN,EMAX,IRTN,L)                   0000
C  FIT LOW ENERGY TAIL OF ELECTRON DISTRIBUTION DURING COLLISION.       0000
      INCLUDE '@FITCOM'
      REAL*4 FBIN(NBIN),B(3,3)                                          0000
      DIMENSION IW(3),W(3)                                              0000
      EXTERNAL HETE                                                     0000
      CHARACTER*8 LKPL(8)/8*' '/                                        0000
      DATA KPL/4/                                                       0000
      LKPL(KPL)='PLOTTED'                                               0000
C                                                                       0000
      IF(KK.EQ.2) GOTO 400                                              0000
      IRTN=0                                                            0000
      DO 140 I=1,NBIN                                                   0000
  140 IF(FBIN(I).NE.0) GOTO 150                                         0000
      GOTO 900                                                          0000
  150 I1=MAX(1,I-1)                                                     0000
      F00=FBIN(I)                                                       0000
      IF(NBIN-I1.LE.10) GOTO 900                                        0000
      DE=(EMAX-EMIN)/NBIN                                               0000
      FTOT=0                                                            0000
      DO 160 I=1,NBIN                                                   0000
  160 FTOT=FTOT+FBIN(I)                                                 0000
      DO 300 K0=1,8                                                     0000
      K=MOD(K0-1,4)+1                                                   0000
      I2=I1+NINT((NBIN-I1)*K/5.0)                                       0000
      E2ES(K0,L)=EMIN+I2*DE                                             0000
      DO 120 J=1,3                                                      0000
      AES(J,K0,L)=0                                                     0000
      DO 120 I=1,3                                                      0000
  120 B(I,J)=0                                                          0000
C     IF(K0.GE.5) AES(3,K0,L)=-2.0/3.0                                  0000
      IF(K0.GE.5) AES(3,K0,L)=0                                         0000
      DO 200 I=I1,I2                                                    0000
      F=FBIN(I)                                                         0000
      IF(F.LE.0) F=0.2*F00                                              0000
      E=EMIN+DE*(I-0.5)                                                 0000
      Y=1.0/E-1.0                                                       0000
      YL=LOG(Y)                                                         0000
      WT=SQRT(F)                                                        0000
      F=LOG(F)                                                          0000
      IF(K0.GE.5) F=F-AES(3,K0,L)*YL                                    0000
      B(1,1)=B(1,1)+WT                                                  0000
      B(1,2)=B(1,2)+WT*Y                                                0000
      B(2,2)=B(2,2)+WT*Y*Y                                              0000
      AES(1,K0,L)=AES(1,K0,L)+WT*F                                      0000
      AES(2,K0,L)=AES(2,K0,L)+WT*Y*F                                    0000
      IF(K0.GE.5) GOTO 200                                              0000
      B(1,3)=B(1,3)+WT*YL                                               0000
      B(2,3)=B(2,3)+WT*Y*YL                                             0000
      B(3,3)=B(3,3)+WT*YL*YL                                            0000
      AES(3,K0,L)=AES(3,K0,L)+WT*YL*F                                   0000
  200 CONTINUE                                                          0000
      NPAR=3                                                            0000
      IF(K0.GE.5) NPAR=2                                                0000
      DO 220 J=1,NPAR-1                                                 0000
      DO 220 I=J+1,NPAR                                                 0000
  220 B(I,J)=B(J,I)                                                     0000
      EPS=1E-6                                                          0000
      CALL RLINS3( B,3,NPAR,AES(1,K0,L),IW,W,IRTN1,EPS )                0000
      IF(K0.EQ.KPL) THEN                                                0000
          IRTN=IRTN1                                                    0000
          DO 240 I=1,3                                                  0000
  240     AKPL(I)=AES(I,KPL,L)                                          0000
        ENDIF                                                           0000
      AES(1,K0,L)=AES(1,K0,L)-LOG(DE*FTOT)                              0000
  300 CONTINUE                                                          0000
      RETURN                                                            0000
  400 IF(IRTN.NE.0) GOTO 440                                            0000
      WRITE(6,410) (E2ES(K,L),(AES(I,K,L),I=1,3),LKPL(K),K=1,8)         0000
  410 FORMAT(/,' ----- FIT OF ELECTRON ENERGY SPECTRUM DURING ',        0000
     % 'COLLISION.',/,                                                  0000
     % 10X,'DF/D(E/E0) = EXP(A+B*Y+C*LOG(Y))    Y=E0/E-1',/,            0000
     % 20X,'NORMALIZATION: INTEGRAL F*D(E/E0) = 1',/,                   0000
     % (15X,'FROM BINS E/E0<',0PF6.3,                                   0000
     %   '   A=',0PF10.5,'  B=',0PF10.5,'  C=',0PF10.5,3X,A8))          0000
      RETURN                                                            0000
  440 WRITE(6,450)                                                      0000
  450 FORMAT(/,' FAILED TO FIT THE SPECTRUM.')                          0000
      RETURN                                                            0000
  900 IRTN=1                                                            0000
      RETURN                                                            0000
      END                                                               0000
