C   14/04/87 812161326  MEMBER NAME  FITPE    *.FORT     M  FORTRAN77   0000
C******************** FITPE ********************************************0000
      SUBROUTINE FITPE(KB,MAXPH1,EPH)                                   0000
      INCLUDE '@PHOTCM'
      INCLUDE '@FITCOM'
      REAL*4 EPH(MAXPH1,2)                                              0000
      CHARACTER*256 TITLE                                               0000
      INTEGER HPNTR                                                     0000
      EXTERNAL HETP                                                     0000
C                                                                       0000
      L1=KB                                                             0000
      L2=KB                                                             0000
      IF(KB.EQ.3) L1=1                                                  0000
      IF(KB.EQ.3) L2=2                                                  0000
      HEL=MAX(ECRAV(1),ECRAV(2))                                        0000
      NHIGH=0                                                           0000
      DO 820 L=L1,L2                                                    0000
      IF(NPH(L).LE.0.OR.NPH(L).GT.MAXPH) GOTO 820                       0000
      DO 810 I=1,NPH(L)                                                 0000
  810 IF(EPH(I,L).GE.HEL) NHIGH=NHIGH+1                                 0000
  820 CONTINUE                                                          0000
      IF(NHIGH.LE.50) RETURN                                            0000
      WRITE(TITLE,830)                                                  0000
  830 FORMAT('HIGH ENERGY TAIL OF PHOTONS;EPH/E0@')                     0000
      NBIN=46                                                           0000
      HEW=(1.0-HEL)/(NBIN-1)                                            0000
      HEL1=HEL-0.5*HEW                                                  0000
      CALL HDEF1('HETP','I*2 ',NBIN,HEL,HEW,TITLE)                      0000
      CALL DOPT('YLOG',.TRUE.)                                          0000
      CALL HOPTN('FUNC',HETP,'HETP')                                    0000
      DO 850 L=L1,L2                                                    0000
      IF(NPH(L).LE.0.OR.NPH(L).GT.MAXPH) GOTO 850                       0000
      DO 840 I=1,NPH(L)                                                 0000
  840 IF(EPH(I,L).GE.HEL1) CALL HCUM1('HETP',EPH(I,L),1.0)              0000
  850 CONTINUE                                                          0000
      IF(HPNTR('HETP').EQ.0) STOP '?'                                   0000
      A11=0.0                                                           0000
      A12=0.0                                                           0000
      A13=0.0                                                           0000
      A22=0.0                                                           0000
      A23=0.0                                                           0000
      DO 860 N=2,NBIN-1                                                 0000
      COUNT=HY(N)                                                       0000
      IF(COUNT.EQ.0.0) GOTO 860                                         0000
      WT=SQRT(COUNT)                                                    0000
      A11=A11+WT                                                        0000
      XN=HX(N)                                                          0000
      YN=XN/(1.0-XN)                                                    0000
      A00=LOG(COUNT*SQRT(YN))                                           0000
      A12=A12+WT*YN                                                     0000
      A22=A22+WT*YN**2                                                  0000
      A13=A13+WT*A00                                                    0000
      A23=A23-WT*A00*YN                                                 0000
  860 CONTINUE                                                          0000
      DET=A11*A22-A12**2                                                0000
      PHNUM=EXP((A22*A13+A12*A23)/DET)                                  0000
      PHNUM0=PHNUM/HEW/THIN                                             0000
      IF(KB.EQ.3) PHNUM0=PHNUM0/2                                       0000
      XCRIT=DET/(A12*A13+A11*A23)                                       0000
      CALL HOUT('HETP')                                                 0000
      CALL DOPT('YLOG',.FALSE.)                                         0000
      CALL HOPTN('HNORM',1.0)                                           0000
      CALL DOPT('TISIZE',1)                                             0000
      WRITE(6,880) PHNUM0,XCRIT,HEL+0.5*HEW                             0000
  880 FORMAT(//10X,'FIT OF HIGH ENERGY PHOTON TAIL',/,                  0000
     %  20X,'DN/DX=C/SQRT(Y)*EXP(-Y/Y0)     Y=X/(1-X), X=EPH/E0',/,     0000
     %  20X,'WITH  C=',1PD9.3,' (PHOTONS/ELECTRON)',                    0000
     %  '  Y0=',0PF7.5,',  (',F7.5,'<X<1.)')                            0000
      CALL HDEL('HETP')                                                 0000
      RETURN                                                            0000
      END                                                               0000
