C   05/06/87 802031551  MEMBER NAME  KERNEL   *.FORT     M  FORTRAN77   0000
      SUBROUTINE KERNEL(CKER,N,MDIM,SCALE)                              0000
      IMPLICIT REAL*8 (A,B,D-H,O-Z)                                     0000
      IMPLICIT COMPLEX*16 (C)                                           0000
      PARAMETER (PI=3.141592653589793D0)                                0000
      DIMENSION CKER(MDIM,*)                                            0000
      F(X,Y)=-0.5D0*(X/DX)*(Y/DY)*(LOG((X**2+Y**2)/(DX*DY))-3D0         0000
     %        +(X/Y)*ATAN(Y/X)+(Y/X)*ATAN(X/Y))                         0000
      DX=1D0                                                            0000
      DY=SCALE                                                          0000
      N0=N/2                                                            0000
      DO 10 J=1,N-1                                                     0000
        DO 20 I=1,N-1                                                   0000
            CKER(I,J)=F((N0-I+0.5D0)*DX,(N0-J+0.5D0)*DY)                0000
     %               -F((N0-I-0.5D0)*DX,(N0-J+0.5D0)*DY)                0000
     %               -F((N0-I+0.5D0)*DX,(N0-J-0.5D0)*DY)                0000
     %               +F((N0-I-0.5D0)*DX,(N0-J-0.5D0)*DY)                0000
20      CONTINUE                                                        0000
10    CONTINUE                                                          0000
                                                                        0000
      DO 30 I=1,N                                                       0000
        CKER(I,N)=(0.D0,0.D0)                                           0000
        CKER(N,I)=(0.D0,0.D0)                                           0000
30    CONTINUE                                                          0000
      CALL CFTR2(CKER,N,MDIM,.TRUE.)                                    0000
      DP=(PI*(N-2))/N                                                   0000
      DO 110 J=1,N                                                      0000
        DO 120 I=1,N                                                    0000
          PHI1=(I+J-2)*DP                                               0000
          CKER(I,J)=CKER(I,J)*CMPLX(COS(PHI1),SIN(PHI1))/N**2           0000
120     CONTINUE                                                        0000
110   CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
