C   19/07/88 807201527  MEMBER NAME  LUMCOR   *.FORT        FORTRAN77   0000
C     DIMENSION SIG(3,2),GCUT(3,2),EMIT(2,2),ALPHA(2,2),                0000
C    %   OFFSET(2,2),SLOPE(2,2)                                         0000
C     KFLD=4                                                            0000
C     A=0.8                                                             0000
C     DO 100 L=1,2                                                      0000
C     SIG(3,L)=1E-3                                                     0000
C     DO 90 J=1,2                                                       0000
C     SIG(J,L)=1E-6                                                     0000
C     EMIT(J,L)=0                                                       0000
CC    EMIT(J,L)=SIG(J,L)**2/(SIG(3,L)/A)                                0000
CC    EMIT(J,L)=1E-10                                                   0000
C     ALPHA(J,L)=0                                                      0000
C     OFFSET(J,L)=0                                                     0000
C     SLOPE(J,L)=0                                                      0000
C     IF(J.EQ.2) SLOPE(J,L)=SIG(J,L)/SIG(3,L)                           0000
C  90 CONTINUE                                                          0000
C     DO 95 J=1,3                                                       0000
C  95 GCUT(J,L)=2.5                                                     0000
C 100 CONTINUE                                                          0000
C     CALL LUMCOR(KFLD,SIG,GCUT,EMIT,OFFSET,SLOPE,ALPHA,                0000
C    %   CORLM1,CORLM2,CORLM3)                                          0000
C     WRITE(6,200) CORLM1,CORLM2,CORLM3                                 0000
C 200 FORMAT(1X,3F15.10)                                                0000
C     STOP                                                              0000
C     END                                                               0000
      SUBROUTINE LUMCOR(KFLD,SIG,GCUT,EMIT,OFFSET,SLOPE,ALPHA,          0000
     %   CORLM1,CORLM2,CORLM3)                                          0000
C  COMPUTE GEOMETRIC CORRECTION FACTOR OF LUMINOSITY                    0000
C  CORLM1 INCLUDES GCUT.                                                0000
C  CORLM2 INCLUDES FINITE EMITTANCE, OFFSET, SLOPE AND ALPHA.           0000
C  CORLM3 INCLUDES ALL EFFECTS. (APPROX.FORMULA TEMPORARY)              0000
      REAL*8 SUM                                                        0000
      DIMENSION SIG(3,2),GCUT(3,2),EMIT(2,2),ALPHA(2,2),                0000
     %   OFFSET(2,2),SLOPE(2,2)                                         0000
      DIMENSION SIG20(2),SIG21(2),SIG22(2),SIG2(2),                     0000
     %          DIST0(2),DIST1(2),DIST(2)                               0000
      DATA PI/3.14159 26535 89793D0/                                    0000
C                                                                       0000
      CORLM1=1.0                                                        0000
      IF(KFLD.NE.4.AND.GCUT(1,1).GT.0) CORLM1=CORLM1                    0000
     %   *(1-ERFC(GCUT(1,1)))/(1-ERFC(GCUT(1,1)/SQRT(2.0)))**2          0000
      IF(GCUT(2,1).GT.0) CORLM1=CORLM1                                  0000
     %   *(1-ERFC(GCUT(2,1)))/(1-ERFC(GCUT(2,1)/SQRT(2.0)))**2          0000
C       ERFC(X)=2/SQRT(PI)*(INTEGRAL EXP(-Y**2) FROM X TO INFINITY)     0000
C                                                                       0000
      IXY0=1                                                            0000
      IF(KFLD.EQ.4) IXY0=2                                              0000
      SIG3=SQRT((SIG(3,1)**2+SIG(3,2)**2))                              0000
      DS0=0.03                                                          0000
      DS=DS0*SIG3                                                       0000
      NS=100                                                            0000
      DO 220 IXY=IXY0,2                                                 0000
      DIST0(IXY)=OFFSET(IXY,1)*SIG(IXY,1)-OFFSET(IXY,2)*SIG(IXY,2)      0000
      DIST1(IXY)=SLOPE(IXY,1)+SLOPE(IXY,2)                              0000
      SIG20(IXY)=SIG(IXY,1)**2+SIG(IXY,2)**2                            0000
      SIG21(IXY)=2*(ALPHA(IXY,2)*EMIT(IXY,2)-ALPHA(IXY,1)*EMIT(IXY,1))  0000
      SIG22(IXY)=(EMIT(IXY,1)/SIG(IXY,1))**2*(1+ALPHA(IXY,1)**2)        0000
     %          +(EMIT(IXY,2)/SIG(IXY,2))**2*(1+ALPHA(IXY,2)**2)        0000
  220 CONTINUE                                                          0000
      SUM=0                                                             0000
      DO 300 IS=-NS,NS                                                  0000
      S=IS*DS                                                           0000
      DO 260 IXY=IXY0,2                                                 0000
      DIST(IXY)=DIST0(IXY)+DIST1(IXY)*S                                 0000
      SIG2(IXY)=(SIG22(IXY)*S+SIG21(IXY))*S+SIG20(IXY)                  0000
  260 CONTINUE                                                          0000
      EX=2*(S/SIG3)**2+0.5*DIST(2)**2/SIG2(2)                           0000
      IF(KFLD.NE.4) EX=EX+0.5*DIST(1)**2/SIG2(1)                        0000
      IF(EX.GE.18) GOTO 300                                             0000
      FAC=SIG2(2)                                                       0000
      IF(KFLD.NE.4) FAC=FAC*SIG2(1)                                     0000
      SUM=SUM+EXP(-EX)/SQRT(FAC)                                        0000
  300 CONTINUE                                                          0000
      FAC=SIG20(2)                                                      0000
      IF(KFLD.NE.4) FAC=FAC*SIG20(1)                                    0000
      CORLM2=SUM*DS0*SQRT(2/PI)*SQRT(FAC)                               0000
      CORLM3=CORLM1*CORLM2                                              0000
      RETURN                                                            0000
      END                                                               0000
