C--- Updated ones
C UPSLOC       ----  adding pointers of  JUPSLN, JUPNUM, KUPENG
C Original 14/04/87 005011252  MEMBER NAME  AAMAIN   *.FORT     M  FORTRAN77
C********************** PROGRAM ABEL **********************************
C     ----- BEAM-BEAM INTERACTION IN LINEAR COLLIDER -----
C                               VERSION. April, 1995
C  The unix version was initially provided by T.Takahashi (Hiroshima university)
C     then,  fully debugged by T.Tauchi (KEK).
C**********************************************************************
      PARAMETER (MTS=20)
      PARAMETER (MMOM=2)
      INCLUDE '@WORKCM'
      INCLUDE '@DEBUG'
      INCLUDE '@PNTRCM'
      INCLUDE '@BBCOM'
        EQUIVALENCE (DXYZ(1),DX),(DXYZ(2),DY),(DXYZ(3),DZ)
      INCLUDE '@PHOTCM'
      INCLUDE '@PLTCOM'
        INTEGER LPLEL(20),LPLPH(20)
        EQUIVALENCE (LPLEP(1,1),LPLEL(1)),(LPLEP(1,2),LPLPH(1))
        EQUIVALENCE (NPLEP(1),NPLEL),(NPLEP(2),NPLPH)
      INCLUDE '@SHISCM'
      INCLUDE '@CHARCM'
        CHARACTER*1 DUMMY(2)
      INCLUDE '@TDCOM'
      DIMENSION ENGY(2),SIGX(2),SIGY(2),SIGZ(2),
     *  GCUTX(2),GCUTY(2),GCUTZ(2),
     *  BETA(2,2),BETAX(2),BETAY(2),EMITX(2),EMITY(2),
     *  ALPHAX(2),ALPHAY(2),OFFSTX(2),OFFSTY(2),SLOPEX(2),SLOPEY(2)
      DIMENSION SIG1(2,3),GCUT1(2,3),BETA1(2,2),EMIT1(2,2),ALPHA1(2,2),
     *          OFFST1(2,2),SLOPE1(2,2)
      EQUIVALENCE (BETA1(1,1),BETAX(1)),(BETA1(1,2),BETAY(1)),
     *  (SIG1(1,1),SIGX(1)),(SIG1(1,2),SIGY(1)),(SIG1(1,3),SIGZ(1)),
     *  (EMIT1(1,1),EMITX(1)),(EMIT1(1,2),EMITY(1)),
     *(GCUT1(1,1),GCUTX(1)),(GCUT1(1,2),GCUTY(1)),(GCUT1(1,3),GCUTZ(1)),
     *  (ALPHA1(1,1),ALPHAX(1)),(ALPHA1(1,2),ALPHAY(1)),
     *  (OFFST1(1,1),OFFSTX(1)),(OFFST1(1,2),OFFSTY(1)),
     *  (SLOPE1(1,1),SLOPEX(1)),(SLOPE1(1,2),SLOPEY(1))
      DIMENSION AA(2),DSRP(2,2)
      INTEGER NPZ(2),NPZ0(2),IXM(2,2),IYM(2,2),IRM(2),NOUT1(2),NOUT2(2)
      INTEGER IZMM(2,2),IZMM1(2,2),NOPH(2)
      REAL*4 ZMAX(2),ZMIN(2),ZZMM(2,2),CENT(2),BLEND(2)
      REAL*4 XTS0(MTS),YTS0(MTS),XPTS0(MTS),YPTS0(MTS),ZTS0(MTS),
     *       ETS0(MTS),TTS(MTS)
      INTEGER ITTS(MTS)
      INTEGER IFLOUT(0:10)
      REAL*4 THINLE(3)
        EQUIVALENCE (THINLE(1),THINBW),(THINLE(2),THINBH),
     *              (THINLE(3),THINLL)
      REAL*4 POLFIN(2),ZBSZ(21)
      INTEGER IZBSZ(2,21)
      INTEGER NCPSQ(2)
      REAL*4 CPLUM(2),SLANT(2)
CREAL8
      REAL*8 SCM(MMOM),SCM1(MMOM),CUMLN(MMOM),COMB1,ALUM1,ALUM2
      REAL*8 POLS(2),GZI0(2)
      REAL*8 ANGMIN,ANGLLA,ANGBHA,ANGBWA
      REAL*8 AVNPH(2,5),DEAV(2,5),DERMS(2,5),DSAV(2,5),DSRMS(2,5)
      real*8 gzi1,u0,u1,u2,uqrad,GAMR8
CREAL8
      INCLUDE '@NAMELIST'
      CHARACTER*12 LVERS
CC      DATA  LVERS/'JAN.02 1991 '/
      DATA  LVERS/'May.01 1995 '/
      CHARACTER*1 KEY
      CHARACTER*80 CHWORK
      CHARACTER*15 LKFLD(0:4)
      DATA LKFLD/'BAND MATRIX','FOURIER TRANS',
     *    'AXIAL SYMMETRY','FLAT APPROX.','1-DIM CALC.'/
      CHARACTER*40 LOSKIN(5)
      DATA LOSKIN/'NO RADIATION TAKEN INTO ACOUNT',
     *  'AVERAGE LOSS BY CLASSICAL THEORY',
     *  'AVERAGE LOSS BY QUANTUM THEORY',
     *  'STOCHASTIC LOSS BY CLASSICAL THEORY',
     *  'STOCHASTIC LOSS BY QUATUM THEORY'/
      CHARACTER*15 LFBCK(2)
      DATA         LFBCK/'NOT INCLUDED','INCLUDED'/
      CHARACTER*3 ONOFF(2)
      DATA        ONOFF/'ON ','OFF'/
      CHARACTER*8 TTL2(7)
      DATA        TTL2   /' X(MIC) ','XP(MILR)',' Y(MIC) ','YP(MILR)',
     *                    '  Z(MM) ','  E/E0  ','RP(MILR)'/
      CHARACTER*9 TTL3(5)
      DATA        TTL3   /' X(SIGX0)','XP(SX/SZ)',' Y(SIGY0)',
     *         'YP(SY/SZ)',' Z(SIGZ) '/
      REAL*4 UNIT(7)
      DATA   UNIT   /1E6,1E3,1E6,1E3,1E3,1E0,1E3/
      REAL*4 UNIT2(7,2)
      CHARACTER*20 JOBTIM
      DATA JOBTIM/' '/
      LOGICAL HANDPK
      LOGICAL CERN
      DATA EMASS/0.5110034D-3/,ELR/2.817938D-15/,CMPTN/3.86159D-13/,
     *   PI/3.14159 26535 89793D0/
      DATA IRG00/584287/,IRR00/123457/
C    STATEMENT FUNCTIONS FOR FIELDS
      Q(I,J,L)=R8(KPQ+I-1+NX*(J-1+NY*(L-1)))
      QE(I,J,L,K)=R8(KPQE+I-1+NX*(J-1+NY*(L-1+2*(K-1))))
      PHI(I,J,L)=R8(KPPHI+I-1+NX*(J-1+NY*(L-1)))
      AAA(I,J)=R8(KPAAA+I-1+(NX-2)*(J-1))
      PHIQ(I,J)=R8(KPPHIQ+I+NX*J)
      WK(I)=R8(KPAAA2+I-1)
      W(I)=R8(KPW+I-1)
      QR(I,L)=R8(KPQR+I-1+NR*(L-1))
      QRE(I,L,K)=R8(KPQRE+I-1+NR*(L-1+2*(K-1)))
      ER(I,L)=R8(KPER+I+(NR+1)*(L-1))
C    STATEMENT FUNCTIONS FOR ELECTRONS
      XY(N,IXY,L)=R4(JPXY+N-1+NP*(IXY-1+2*(L-1)))
      XY0(N,IXY,L)=R4(JPXY0+N-1+NP*(IXY-1+2*(L-1)))
      ZZ(N,L)=R4(JPZZ+N-1+NP*(L-1))
      ENG(N,L)=R8(KPENG+N-1+NP*(L-1))
      RP(N,L)=R4(JPRP+N-1+NP*(L-1))
      FXY(N,IXY,L)=R4(JPFXY+N-1+NP*(IXY-1+2*(L-1)))
      SPIN(N,IXYZ,L)=R4(JPSPIN+N-1+NP*(IXYZ-1+3*(L-1)))
      POLZ(I,J,L)=R4(JPPOLZ+I-1+NX*(J-1+NY*(L-1)))
      POLZR(I,L)=R4(JPPLZR+I-1+NR*(L-1))
C    STATEMENT FUNCTIONS FOR PHOTONS
      XYPH(N,IXY,L)=R4(JPXYPH+N-1+MAXPH*(IXY-1+2*(L-1)))
      EPH(N,L)=R4(JPEPH+N-1+MAXPH*(L-1))
C    STATEMENT FUNCTIONS FOR S-SPECTRUM
      SBIN2(I,J)=R4(JPSBN2+I-1+NSBIN*(J-1))
      SBIN(I)=R4(JPSBIN+I-1)
      SBIN1(I,L)=R4(JPSBN1+I-1+NSBIN*(L-1))
      SBINW(I)=R4(JPSBNW+I-1)
      ISQN(I,L)=I4(IPISQN+I-1+MSQ*(L-1))
      ISQK(I,L)=I4(IPISQK+I-1+MSQ*(L-1))
      ISC(I,J,L)=I4(IPISC+I-1+NX*(J-1+NY*(L-1)))
      ISCR(I,L)=I4(IPISCR+I-1+NR*(L-1))
C    STATEMENT FUNCTIONS FOR TEST PARTICLES
      XYTS(I,N,IXY)=R4(JPXYTS+I+(MT+1)*(N-1+NTS*(IXY-1)))
      ZTS(N)=R4(JPZTS+N-1)
      ETS(I,N)=R4(JPETS+I+(MT+1)*(N-1))
      NPIZ(IZ,L)=I4(IPNPIZ+IZ-IZMIN+(IZMAX-IZMIN+2)*(L-1))
      ENHT(NT)=R4(JPENHT+NT-MT1)
      ENHZ(IZ,L)=R4(JPENHZ+IZ-IZMIN+(IZMAX-IZMIN+2)*(L-1))
      IPHIZ(IZ,L)=I4(IPPHIZ+IZ-IZMIN+(IZMAX-IZMIN+2)*(L-1))
C
      CALL DATE1(JOBTIM)
      WRITE(6,70) LVERS,JOBTIM
   70 FORMAT(1H1,/,' ************ ABEL VERSION ',A12,' **********'
     *  ,A20,/)
      CALL PRTIME(-2,1,DUMMY)
      DEVNAM(1)='PRINTER '
      DEVNAM(2)='LASER   '
C        GRAPHIC DEVICE NAME. (LASER IN KEK, IMGN300 IN SLAC)
      CERN=.FALSE.
      LLINE=60
      FSC=1D0/137.03604D0      
C---
      GZI1=.22487935                                                     
      U0=UQRAD(0,GZI1)                                                  
      U1=UQRAD(1,GZI1)                                                  
      U2=UQRAD(2,GZI1)   
C----- SET DEFAULT ----
      TLMNS = 0.0D0
      TCRSLL= 0.0D0
      CONSLL= -0.
      CONSBH= -0.
      CONSBW= -0.
      NCSBH = 0
      NCSBW = 0
      NCSLL = 0
      NENGLL= 0
      NTITL = 0
      DO 80 I=0,10
   80 IFLOUT(I)=0
      LEQUAL=1
      FREP=180.
      DO 96 L=1,2
      ENGY(L)=50.
      AN(L)=5D10
      SIGX(L)=1D-6
      SIGY(L)=1D-6
      SIGZ(L)=1D-3
      GCUTX(L)=2.4
      GCUTY(L)=2.4
      GCUTZ(L)=2.4
      SLANT(L)=0.0
      DO 94 IXY=1,2
      BETA1(L,IXY)=0
      EMIT1(L,IXY)=0
      ALPHA1(L,IXY)=0
      SLOPE1(L,IXY)=0
      OFFST1(L,IXY)=0
   94 CONTINUE
   96 CONTINUE
C
      NP=5000
      DZ0=0.3D0
      MZT=4
      KFLD=0
        LEQM=1
        LHIGH=0
C         (ABOVE TWO ARE FOR PROGRAMMERS ONLY)
      LUPDWN=0
      DX0=0.3D0
      DY0=0.3D0
      DR0=0.04D0
      NX=20
      NY=20
      NR=100
      LOUT=0
      LPL0=0
      LPL1=0
      LBPRFL=0
      NBPRFL=0
      MBPRFL=0
      IPROFL=0
      LPROFL=1
      LENHZ=0
      LENHT=0
      NZBSZ=0
      NF   =0
      LZBSZ=0
      LAVY=0
      LRMSY=0
      NAVY=0
      LSHIST=0
      NSBIN=50
      SBMAX=1.0
      SBMIN=0
      EBMAX=1.0
      EBMIN=0
      CBMAX=1.0
      CBMIN=0
      LCMPTN=0
CZERO        CALL CLEAR(LPLEL,20)
CZERO        CALL CLEAR(LPLPH,20)
      CALL UVZERO(20,LPLEL)
      CALL UVZERO(20,LPLPH)
      LHP=0
      NODSRP=0
      LOS1=4
      LOS2=1
      THIN0=1.0
      MAXPH=NP
      ISPIN=0
      IFIELD=0
      ITRACE=0
      LTS=1
      NTS=0
      LTSRAD=0
      IFLTST=0
CZERO      CALL CLEAR(XTS0,MTS)
CZERO      CALL CLEAR(YTS0,MTS)
CZERO      CALL CLEAR(XPTS0,MTS)
CZERO      CALL CLEAR(YPTS0,MTS)
CZERO      CALL CLEAR(ZTS0,MTS)
      CALL UVZERO(MTS,XTS0)
      CALL UVZERO(MTS,YTS0)
      CALL UVZERO(MTS,XPTS0)
      CALL UVZERO(MTS,YPTS0)
      CALL UVZERO(MTS,ZTS0)
      DO 98 I=1,MTS
      ETS0(I)=1.0
   98 TTS(I)=-1E30
      LEP=0
      NBETA =0 
      KBETA =0 
      NTUNE =1
      MAXLEP=0
      ANGMIN=0
      LOCAL =0
      NBOOST=0
      NFLDEX=0
      NOCLMB=0
      NOKICK=0
      ELEMIN=0
      ELEMAX=0
      THINBW=0
      THINBH=0
      THINLL=0
      IRG=IRG00
      IRG0=IRG00
      IRR=IRR00
      IRR0=IRR00
      NSTEP=0
      TITLE=' '
      CPUT=0
      IFLTD=8
      NPLTTD=0
      NPLX=1
      NPLY=1
C----------------------------------------------------------------------
  110 CONTINUE
      THIN=THIN0
C-------READIN DATA------
  120 CONTINUE
CC    WRITE(6,130)
CC130 FORMAT(' ENTER  T(TERM) C(CHANGE PARAM) G(GO)')
      READ(5,140) KEY
  140 FORMAT(A1)
      IF(KEY.EQ.'T') GOTO 3000
      IF(KEY.EQ.'G') GOTO 145
      IF(KEY.NE.'C') GOTO 120
      READ(5,IN)
CC    WRITE(6,IN)
CLOCAL              LOCAL  = 1
CNOBOOST            NBOOST = 0
CNOFLDEX            NFLDEX = 1
CNOKICK             NOKICK = 1
C      READ(70,*) IRR
C      READ(70,*) IRG
C      IRR = 458178781
C      IRG = 962583053
C--- Define  -- ELEMIN,  ELEMAX
      IF(ELEMIN.LT.EMASS) ELEMIN =EMASS
      ELEMIN = ELEMIN/ENGY(1)
      ELEMAX = ELEMAX/ENGY(1)
      IF(ANGMIN.LT.0.) THEN
        GAMMA  = ENGY(1)/EMASS
        ANGMIN = 1./ELEMAX/GAMMA
        ANGBW  = 0.92D0
        ANGBH  = 0.92D0
        ANGLL  = 0.90D0
        ANGBWA = ANGMIN*ANGBW
        ANGBHA = ANGMIN*ANGBH
        ANGLLA = ANGMIN*ANGLL
        ELSE
        ANGBWA = ANGMIN
        ANGBHA = ANGMIN
        ANGLLA = ANGMIN
      ENDIF
C------ START NEW STEP OF RUN -------
  145 NSTEP=NSTEP+1
      CALL PRTIME(-1,1,DUMMY)
      CALL PRTIME(0,1,DUMMY)
C------
      NCTTL=0
      DO 146 I=1,80
  146 IF(TITLE(I:I).NE.' ') NCTTL=I
      IF(LEQUAL.NE.0) THEN
          ENGY(2)=ENGY(1)
          AN(2)=AN(1)
          DO 147 IXYZ=1,3
          SIG1(2,IXYZ)=SIG1(1,IXYZ)
  147     GCUT1(2,IXYZ)=GCUT1(1,IXYZ)
          DO 148 IXY=1,2
          BETA1(2,IXY)=BETA1(1,IXY)
          EMIT1(2,IXY)=EMIT1(1,IXY)
  148     ALPHA1(2,IXY)=ALPHA1(1,IXY)
        ENDIF
      LENHT=MAX(0,MIN(3,LENHT))
      DO 149 IEP=1,2
      NPLEP(IEP)=0
      DO 149 I=1,20
  149 IF(LPLEP(I,IEP).NE.0) NPLEP(IEP)=I
      HANDPK=NPLEL.GE.1.OR.NPLPH.GE.1.OR.LSHIST.GE.1.OR.IPROFL.GT.0
      HANDPK=HANDPK.AND..NOT.CERN
      IF(.NOT.HANDPK.OR.LHP.NE.0) GOTO 151
C------ INITIALIZE HANDYPAK -------
      LHP=LHP+1
      CALL HPK000(0,LLINE,NTITL)
C------ TOPDRAWER ------
  151 KPL=0
      IF(NPLX.LE.0) NPLX=1
      IF(NPLY.LE.0) NPLY=1
C------read data from the file if NTITL=1
      IF(NTITL.EQ.1) THEN
       LGPAIR = IFLOUT(0)
       OPEN(UNIT=LGPAIR,FILE='abel.pairs'
     %,POSITION='APPEND',STATUS='OLD')
       OPEN(UNIT=IFLTD,FILE='abel.tdr'
     %,POSITION='APPEND',STATUS='OLD')
        ELSE
       LGPAIR = IFLOUT(0)
       OPEN(UNIT=LGPAIR,FILE='abel.pairs')
       OPEN(UNIT=IFLTD,FILE='abel.tdr')
      ENDIF
      OPEN(UNIT=70,FILE='abel.random')
C--
      READ(70,*) IRR
      READ(70,*) IRG
      REWIND  70
C------
      GAM(1)=ENGY(1)/EMASS
      GAM(2)=ENGY(2)/EMASS
CC    IF(MOD(IRG,2).EQ.0) IRG=IRG0
CC    IF(MOD(IRR,2).EQ.0) IRR=IRR0
      IRGPR=IRG
      IRRPR=IRR
C---
      THIN0=THIN
      IF(THIN.LE.0.OR.LOS1.LE.2) MAXPH=0
      IF(ABS(ITRACE).GT.NP) ITRACE=0
      LSPIN(1)=0
      LSPIN(2)=0
      IF(ISPIN.GE.1) THEN
          IF(ISPIN.LE.2) THEN
              LSPIN(ISPIN)=1
            ELSE
              LSPIN(1)=1
              LSPIN(2)=2
            ENDIF
        ENDIF
      DO 156 L=1,2
      DO 154 IXYZ=1,3
      SIG(IXYZ,L)=SIG1(L,IXYZ)
  154 GCUT(IXYZ,L)=GCUT1(L,IXYZ)
      DO 155 IXY=1,2
      IF(BETA1(L,IXY).GT.0) THEN
          BETA(IXY,L)=BETA1(L,IXY)
          EMIT(IXY,L)=SIG(IXY,L)**2/BETA1(L,IXY)
        ELSE
          IF(EMIT1(L,IXY).GT.0) THEN
              EMIT(IXY,L)=EMIT1(L,IXY)
              BETA(IXY,L)=SIG(IXY,L)**2/EMIT1(L,IXY)
            ELSE
              BETA(IXY,L)=1E20
              EMIT(IXY,L)=0D0
            ENDIF
        ENDIF
      ALPHA(IXY,L)=ALPHA1(L,IXY)
      OFFSET(IXY,L)=OFFST1(L,IXY)
      SLOPE(IXY,L)=SLOPE1(L,IXY)
  155 CONTINUE
      UNIT2(1,L)=SIG(1,L)
      UNIT2(2,L)=SIG(1,L)/SIG(3,L)
      UNIT2(3,L)=SIG(2,L)
      UNIT2(4,L)=SIG(2,L)/SIG(3,L)
      UNIT2(5,L)=SIG(3,L)
  156 CONTINUE
C------ TRANSVERSE CELL
      IF(KFLD.LT.0.OR.KFLD.GE.5) THEN
          WRITE(6,160) KFLD
  160     FORMAT(' *** INVALID KFLD =',I5,'   STEP IGNORED. ***')
          GOTO 110
        ENDIF
      IF(KFLD.EQ.2) THEN
          DO 161 L=1,2
          IF(SIG(1,L).NE.SIG(2,L)) GOTO 162
          IF(EMIT(1,L).NE.EMIT(2,L)) GOTO 162
          IF(ALPHA(1,L).NE.ALPHA(2,L)) GOTO 162
          IF(OFFSET(1,L).NE.0.OR.OFFSET(2,L).NE.0) GOTO 162
          IF(SLOPE(1,L).NE.0.OR.SLOPE(2,L).NE.0) GOTO 162
  161     CONTINUE
          GOTO 164
  162     WRITE(6,163)
  163     FORMAT(' *** KFLD=2 SPECIFIED BUT NO AXIAL SYMMETRY.  ',
     *           'STEP IGNORED. ***')
          GOTO 110
        ENDIF
  164 IF(KFLD.EQ.1) THEN
          IF(NX.NE.NY) THEN
              WRITE(6,165) NX,NY
  165         FORMAT(' *** KFLD=1 SPECIFIED BUT NX.NE.NY.  YOU HAVE ',
     *         'NX=',I4,' NY=',I4,'. STEP IGNORED. ***')
              GOTO 110
            ENDIF
          NF=NINT(LOG(FLOAT(NX))/LOG(2.0))
          NF=2**NF
          IF(NF.NE.NX) THEN
              WRITE(6,166) NX,NF
  166         FORMAT(' *** KFLD=1 SPECIFIED BUT NX=',I4,'.NE.2**N. ',
     *            ' ASSUME NX=',I4)
              NX=NF
              NY=NF
            ENDIF
          NF=NF*2
        ENDIF
      DZ=DZ0*SIGZ(1)
      DX=DX0*SIGX(1)
      DY=DY0*SIGY(1)
      IF(KFLD.EQ.4) THEN
          IF(OFFSTX(1).NE.0.OR.OFFSTX(2).NE.0.OR.
     *      SLOPEX(1).NE.0.OR.SLOPEX(2).NE.0) THEN
              WRITE(6,167)
  167         FORMAT(' *** KFLD=4 BUT OFFSTX AND/OR SLOPEX SPECIFIED.',
     *               ' STEP IGNORED.')
              GOTO 110
            ENDIF
          NX=1
          WIDX=SQRT(12.0)*SIGX(1)
          DX=WIDX
        ENDIF
      IF(KFLD.NE.2) THEN
          IF(LUPDWN.NE.0.AND.(OFFSTY(1).NE.0.OR.OFFSTY(2).NE.0.OR.
     *      SLOPEY(1).NE.0.OR.SLOPEY(2).NE.0)) THEN
              WRITE(6,168)
  168         FORMAT(' *** OFFSTY AND/OR SLOPEY SPECIFIED IN SPITE ',
     *               'LUPDWN.NE.0.   STEP IGNORED.')
              GOTO 110
            ENDIF
        ENDIF
      IF(KFLD.EQ.2) THEN
          LUPDWN=0
          DR=DR0*SIGX(1)
          DX=DR
          DY=DR
        ENDIF
CIEND
C------ DISRUPTION PARAMETERS ------
      NODSRP=MAX(0,MIN(2,NODSRP))
      DO 170 L=1,2
      L2=3-L
      DO 170 IXY=1,2
      DSRP(L2,IXY)=2.*ELR*AN(L)*SIGZ(L)
     *         /(GAM(L2)*SIG1(L,IXY)*(SIGX(L)+SIGY(L)))
  170 CONTINUE
C------ CHOOSE TIME MESH SIZE ------
      IF(MZT.LE.1.OR.MOD(MZT,2).NE.0) THEN
          MZT=4
          WRITE(6,172) MZT
  172     FORMAT(' *** WARNING: MZT MUST BE POSITIVE AND EVEN. ',
     *    'MZT=',I2,' ADOPTED.')
        ENDIF
      RTZ=1D0/MZT
      DT=RTZ*DZ
C------ SOME PARAMETERS
      IF(KFLD.NE.4) THEN
          ALUM00=FREP*AN(1)*AN(2)/(2.0*PI*SQRT((SIGX(1)**2+SIGX(2)**2)
     *                             *(SIGY(1)**2+SIGY(2)**2)))
        ELSE
          ALUM00=FREP*AN(1)*AN(2)/(4.0*SQRT(PI*3.0)*SIGX(1)
     *                     *SQRT((SIGY(1)**2+SIGY(2)**2)/2))
        ENDIF
      CALL LUMCOR(KFLD,SIG,GCUT,EMIT,OFFSET,SLOPE,ALPHA,
     *            CORLM1,CORLM2,CORLM3)
      ALUM01=CORLM1*ALUM00
      ALUM02=CORLM2*ALUM00
      ALUM03=CORLM3*ALUM00
      DO 174 L=1,2
      CLOS1(L)=(2.0/3.0)*ELR*(GAM(L)/DT)**3
      CLOS2(L)=1.5*CMPTN*GAM(L)**2/DT**2
C     CLOS3(L)=1.0532818E-2*GAM(L)/DT
      CLOS3(L)=5.0/(2.0*SQRT(3.0))*FSC*GAM(L)/DT
  174 AA(L)=AN(L)/NP*4.0*ELR*(DT**2/DZ)/GAM(3-L)
CIEND
C------ MACRO PARTICLE SIZE
      RMIN2=0.25*DX*DY
C      RMIN2 = SQUARE RADIUS OF SUPER PARTICLES FOR DIRECT
C              COULOMB FORCE CALCULATION.
      C0=4.0
C       C1=N1*N2/(NX*NY) (N1,N2=# OF SUP.PART. IN THE RELEVANT Z-BIN)
C       IF C1>C0, FORCES ARE CALCULATED BY SOLVING LAPLACE EQUATION.
C       IF C1<C0, BY DIRECT COULOMB'S LAW.
C  (  CLC IS USED NORMALLY, BUT DIRECT COULOMB'S LAW IS APPLIED      )
C  (  IF THE TOTAL NUMBER OF PARTICLES IN A Z-BIN IS TOO SMALL.      )
C  (  IN SUCH A CASE, COULOMB FORCE BETWEEN PARTICLES TOO CLOSE TO   )
C  (  EACH OTHER IS IGNORED IN ORDER TO SUPPRESS COMPUTATION NOISE.  )
C----- NUMBER OF TIME STEPS
      IF(JPXY.EQ.0) THEN
        JPXY = 1
        JPXY0= 1
        JPZZ = 1
        KPENG= 1
        JPSPIN=1
      ENDIF
      CALL INIT1(0,KFLD,IRG,IRTN,ZZMM,NP,
     *   R4(JPXY),R4(JPXY0),R4(JPZZ),R8(KPENG),
     *   SIG,GCUT,EMIT,ALPHA,SLOPE,OFFSET,LSPIN,ISPIN,R4(JPSPIN)
     *,  SLANT)
CDEBUG
CDBG  PRINT *,'!!!ENG(INIT1-1)=',(R8(I),I=KPENG,KPENG+4)
CDEBUG
      DO 175 L=1,2
      DO 175 I=1,2
      IZMM(I,L)=INT(ZZMM(I,L)/DT)
  175 IF(ZZMM(I,L).LT.0.0) IZMM(I,L)=IZMM(I,L)-1
      IZMIN=MIN(IZMM(1,1),IZMM(1,2))
      IZMAX=MAX(IZMM(2,1),IZMM(2,2))
      IZMINA=-((-IZMIN-1)/MZT+1)
      IZMAXA=IZMAX/MZT
      MT1=-(IZMM(2,1)+IZMM(2,2)+2)/2-1
      MT2=-(IZMM(1,1)+IZMM(1,2)+1)/2+1
      MT=MT2-MT1+2
      IF(LAVY.GE.1.OR.LRMSY.GE.1) THEN
          IF(NAVY.LE.0) NAVY=MAX(1,MT/10)
          MTAVY1=MT1/NAVY
          MTAVY2=MT2/NAVY
          NTAVY=MTAVY2-MTAVY1+1
          NIZAVY=IZMAXA-IZMINA+1
        ENDIF
C-----
      KBPRFL=MAX(1,MIN(4,LBPRFL/10))
      LBPRFL=MAX(0,MIN(3,MOD(LBPRFL,10)))
      IF(LBPRFL.GE.1.AND.NBPRFL.EQ.0) NBPRFL=MAX(1,MT/5)
      IF(LBPRFL.GE.1.AND.MBPRFL.LE.0) MBPRFL=MAX(1,NP/2000)
C-----
      IF(NZBSZ.LE.0) LZBSZ=0
      IF(LZBSZ.LE.0) GOTO 190
      LZBSZ1=MAX(0,MIN(3,MOD(LZBSZ,10)))
      LZBSZ2=LZBSZ/10
      LZBSZ=LZBSZ2*10+LZBSZ1
      IF((KFLD.EQ.2.AND.LZBSZ1.LE.2).OR.(KFLD.EQ.3.AND.LZBSZ1.EQ.3).
     *  OR.(KFLD.EQ.4.AND.LZBSZ1.NE.2)) THEN
          WRITE(6,176) KFLD,LZBSZ
  176     FORMAT(' *** WARNING: INVALID COMBINATION OF KFLD=',I1,
     *           ' AND LZBSZ=',I2,'. BEAMSIZE PLOT IGNORED.')
          LZBSZ=0
          GOTO 190
        ENDIF
      IF(LZBSZ1.EQ.1) N=NX
      IF(LZBSZ1.EQ.1) D1=DX/SIGX(1)
      IF(LZBSZ1.EQ.2) N=NY
      IF(LZBSZ1.EQ.2) D1=DY/SIGY(1)
      IF(LZBSZ1.EQ.3) N=NR
      IF(LZBSZ1.EQ.3) D1=DR/SIGX(1)
      IF(LZBSZ1.EQ.3.AND.KFLD.LE.1) THEN
          IF(NX*DX.GE.NY*DY) THEN
              N=NX
              D1=DX/SIGX(1)
            ELSE
              N=NY
              D1=DY/SIGY(1)
            ENDIF
        ENDIF
      N1=1
      IF(KFLD.LE.1.OR.(KFLD.EQ.3.AND.LZBSZ1.EQ.1)) N1=4
      NBBSZ=N*N1
      DBBSZ=D1/N1
      DBBSZ0=1.0/FLOAT(N1)
C        BINSIZE FOR BEAMSIZE COMPUTATION DETERMINED.
      NZBSZ=MIN(21,NZBSZ)
      DO 180 I=1,NZBSZ
      ZBSZ1=ZBSZ(I)*SIGZ(1)/DT
      IZBSZ1=NINT(ZBSZ1)
      FRACZ=ZBSZ1-IZBSZ1
      IF(ABS(FRACZ).LE.0.25) THEN
          IZBSZ(1,I)=IZBSZ1-(MZT/2)
          IZBSZ(2,I)=IZBSZ1+(MZT/2)-1
        ELSE
          IF(FRACZ.LE.0.0) IZBSZ1=IZBSZ1-1
          IZBSZ(1,I)=IZBSZ1-(MZT/2)
          IZBSZ(2,I)=IZBSZ1+(MZT/2)
        ENDIF
      IF(IZBSZ(1,I).LT.IZMM(1,1).OR.IZBSZ(2,I).GT.IZMM(2,1)) THEN
          WRITE(6,179) I,ZBSZ(I)
  179     FORMAT(' *** WARNING: ZBSZ(',I1,')=',F6.3,' IS OUT OF ',
     *           'RANGE. ZBSZ IGONRED.')
          LZBSZ=0
          GOTO 190
        ENDIF
      ZBSZ(I)=(IZBSZ(1,I)+IZBSZ(2,I)+1)/2.0*DT/SIGZ(1)
  180 CONTINUE
C-----
  190 IF(NTS.LE.0) LTS=0
      IF(LTS.LE.0) NTS=0
      LNTS=LTS/10
      LTS=LTS-10*LNTS
      IF(NTS.GT.MTS) THEN
          NTS=0
          WRITE(6,192) MTS
  192     FORMAT(' *** TOO MANY TEST PARTICLES. ALLOWED UP TO',I3,
     *             '. IGNORE THEM.')
       ENDIF
      IF(IFLTST.GE.1) THEN
          DO 193 I=1,NTS
          READ(5,*) XTS0(I),XPTS0(I),YTS0(I),YPTS0(I),
     *                   ZTS0(I),ETS0(I),TTS(I)
  193     CONTINUE
          WRITE(6,194)  NTS
  194     FORMAT(' *** READ DATA OF',I4,' TEST PARTICLES FROM FILE ',
     *           'FT05F001.')
        ENDIF
C-----
      IF(LSHIST.GE.1) THEN
          IF(SBMAX.LE.SBMIN) THEN
              SBMAX=1.0
              SBMIN=0.0
            ENDIF
          IF(EBMAX.LE.EBMIN) THEN
              EBMAX=1.0
              EBMIN=0.0
            ENDIF
          IF(NSBIN.LE.9) NSBIN=50
          MSQ=NP/2
        ENDIF
      IF(LCMPTN.GE.1) THEN
          IF(MAXPH.EQ.0.OR.LSHIST.LE.0) THEN
              WRITE(6,196)
  196         FORMAT(' *** LCMPTN SPECIFIED BUT MAXPH=0 OR LSHIST<=0.',
     *        ' OR THIN=0. COMPTON IGNORED.')
              LCMPTN=0
            ELSE
              IF(THIN.GT.1.0) WRITE(6,197)
  197         FORMAT(' ***WARNING. COMPTON MAY SUFFER FROM SYSTEMATIC',
     *        ' ERRORS DUE TO THIN>1.')
            ENDIF
          IF(CBMAX.LE.CBMIN) THEN
              CBMAX=1.0
              CBMIN=0.0
            ENDIF
          CSBMIN=CBMIN*EBMIN
          CSBMAX=CBMAX*EBMAX
          GSBMIN=CBMIN*CBMIN
          GSBMAX=CBMAX*CBMAX
          MCPSQ=MAXPH/2
        ENDIF
C---- LOW ENERGY PARTICLES ---
      IF((THINBW.LE.0.AND.THINBH.LE.0.AND.THINLL.LE.0)
     *  .OR.(ELEMIN.LE.0.OR.ELEMAX.GT.1.OR.ELEMAX.LE.ELEMIN)
     *  .OR.MAXLEP.LE.0.OR.KFLD.EQ.2.OR.KFLD.EQ.4) THEN
          IF(LEP.GT.0) WRITE(6,198)
  198     FORMAT(' *** CAUTION  ''LEP'' IGNORED.')
          LEP=0
        ENDIF
      IF(LEP.LE.0) THEN
          MAXLEP=0
          THINBW=0
          THINBH=0
          THINLL=0
        ENDIF
      NLEP=0
CIEND
CNEWNEW
C--New Constants by T.Tauchi. Jan. 1991
CMINANG       MINANG = 1
CMINANG       ANGMIN = 2./GAM(1)*SQRT(1./ELEMIN)
      DL    = 2.*DT/(DX*DY*DZ)*(AN(1)/NP)*(AN(2)/NP)
CMINANG       IF(MINANG.EQ.1) THEN
CMINANG       CONSBW = DL/GAM(1)/GAM(2)*PI*ELR**2*0.5
CMINANG       CONSBH = DL*28./9.*FSC*ELR**2*2.
CMINANG       ALOGAM = ALOG( 4.*GAM(1)*GAM(2) )
CMINANG       CONSLL =28./27.*ALOGAM**3-6.59*ALOGAM**2-11.8*ALOGAM+104.
CMINANG       CONSLL = DL*(FSC*ELR)**2/PI*CONSLL
CMINANG       ELSE
CC    COSMIN= COS(ANGMIN)
CC    SNMIN2= 1.-COSMIN**2
CC    CSLOG = ALOG( (1.+COSMIN)/(1.-COSMIN) )
      CSLGBW= -2.*DLOG( 0.5D0*ANGBWA )
      CONSBW=DL/GAM(1)/GAM(2)*PI*ELR**2*CSLGBW
      CONSBH=DL/GAM(1)/GAM(2)*FSC*ELR**2*4.
C--FOR LL
      SNMIN2= ANGLLA**2
      COSMIN= 1. - 0.5*SNMIN2
      CSINV = 1./SNMIN2
      ENGLOG= ALOG( ELEMIN*0.5 ) + 1.
      CSLOG = -2.*DLOG( 0.5D0*ANGLLA )
      CONSLL=DL/GAM(1)/GAM(2)*(FSC*ELR)**2*8./PI/ELEMIN/ELEMIN*(
     *   ENGLOG*( ENGLOG+0.5 )*( COSMIN*CSINV+0.5*CSLOG )
     * + ENGLOG*(  COSMIN*CSINV*( ALOG(SNMIN2)+1. )
     *           -( 48.*COSMIN+COSMIN**3 )/36.
     *           +( ALOG( 2.*SNMIN2 )-0.5 )*CSLOG       )
     * + COSMIN*(ALOG(SNMIN2)-1.)*CSINV/4. +CSLOG*ALOG(4.*SNMIN2)/8.
     * - (48.*COSMIN+COSMIN**3)/144.
     * + 2.*CSINV*( COSMIN*ALOG(SNMIN2)+CSLOG ) - CSLOG*ALOG(SNMIN2)
     * + 2.*(ALOG(2.)-1.)*CSLOG  - (48.*COSMIN+COSMIN**3)/18.         )

      CONSL0=DL/GAM(1)/GAM(2)*(FSC*ELR)**2*8./PI/ELEMIN/ELEMIN*(
     *   ENGLOG*( ENGLOG+0.5 )*( COSMIN*CSINV+0.5*CSLOG )
     * + ENGLOG*(  COSMIN*CSINV*( ALOG(SNMIN2)+1. ) )  )

      CONSNN = 0.1517
      CONSL2 = 2.*COSMIN*CSINV - 2./3./ELEMIN*(1.-CONSNN)*
     * ( (-2.*CSLOG+4.*CSINV*COSMIN+2.*COSMIN)*ALOG(ELEMIN*0.5)
     * +ALOG(SNMIN2)*CSLOG
     * -CSINV*(CSLOG+COSMIN*ALOG(SNMIN2)) + 0.5*(1.+COSMIN**2)*CSLOG
     * + COSMIN*(ALOG(SNMIN2)-1.) )
     * - ELEMIN/16.*(4.*COSMIN*CSINV-CSLOG)
     * - ELEMIN**2/216.*(8.*COSMIN*CSINV-4.*CSLOG+2.*COSMIN)
     * + CONSNN*2./3./ELEMIN*(2.*CSLOG+4.*COSMIN*CSINV+2.*COSMIN)
      CONSL2 = DL/GAM(1)/GAM(2)*(FSC*ELR)**2*4./PI*CONSL2
CCC      CONSLL = CONSLL + CONSL2
CCC
      IF(NTUNE.GE.1) THEN
      CONSLL = CONSL0  - 4.5*(CONSL0-CONSLL)
      print *,'!!!! total LL cross section was tuned to soften in HE.'
      ENDIF
CCC
C---                                                                            
ccc      GAMR8 = GAM(1)
ccc      CRSLN  = DLOG(4.D0*GAMR8**2)                                                  
      CRSLN  = ALOG(4.0*GAM(1)**2)                                                  
      TOTLL = DL/PI*FSC**2*ELR**2                                      
     * *(28.D0/27.D0*CRSLN**3-6.59D0*CRSLN**2-11.8D0*CRSLN+104.D0 )               
      IF(NBETA.EQ.1) THEN
       CONSLL = TOTLL
       KBETA  = NBETA
      ENDIF
C---
CMINANG       ENDIF
CIEND
CNEWNEW
      PRINT *,'********************************************************'
      PRINT *,' ELEMIN=',ELEMIN,'(',ELEMIN*ENGY(1)*1000.,' MeV )'
     *,' ELEMAX=',ELEMAX,'(',ELEMAX*ENGY(1)*1000.,' MeV )'
      PRINT *,' ANGMIN=',ANGMIN,' COSMIN=',COSMIN,' SNMIN2=',SNMIN2
      PRINT *,' ANGBWA =',ANGBWA,' ANGBHA=',ANGBHA,' ANGLLA=',ANGLLA
      PRINT *,' DX    =',DX
      PRINT *,' DY    =',DY
      PRINT *,' DZ    =',DZ
      PRINT *,' DT    =',DT
      PRINT *,' DL    =',DL
CIEND
      PRINT *,' CONSBW=',CONSBW,' /DL=',DBLE(CONSBW)/DBLE(DL)
      PRINT *,' CONSBH=',CONSBH,' /DL=',DBLE(CONSBH)/DBLE(DL)
      PRINT *,' CONSLL=',CONSLL,' /DL=',DBLE(CONSLL)/DBLE(DL)
      PRINT *,' CONSL0=',CONSL0,' CONSL0/CONSLL=',CONSL0/CONSLL
      PRINT *,' CONSL2=',CONSL2
      PRINT *,'  TOTLL=',TOTLL,' NTUNE =',NTUNE,' NBETA =',NBETA
ccc      CONSLL = TOTLL
CIEND
      IF(LOCAL.EQ.1) THEN
      PRINT *,' LOCAL =',LOCAL,
     *'; Pairs are produced in the same interaction points.'
      ELSE
      PRINT *,' LOCAL =',LOCAL,
     *'; Non local nature of pair creation is taken account.'
      ENDIF
      IF(NBOOST.EQ.1) THEN
      PRINT *,' NBOOST=',NBOOST,'; Angles are boosted.'
      ELSE
      PRINT *,' NBOOST=',NBOOST,'; No angle boost.'
      ENDIF
      IF(NFLDEX.EQ.1) THEN
      PRINT *,' NFLDEX=',NFLDEX,
     *'; Ignore the effect of the external fields.'
      ELSE
      PRINT *,' NFLDEX=',NFLDEX,
     *'; Take account of the external field.'
      ENDIF
      IF(NOKICK.EQ.1) THEN
      PRINT *,' NOKICK=',NOKICK,
     *'; No deflection due to the comming beam.'
      ELSE
      PRINT *,' NOKICK=',NOKICK,
     *'; Take account of the deflection by the comming beam.'
      ENDIF
      IF(NOCLMB.EQ.1) THEN
      PRINT *,' NOCLMB=',NOCLMB,
     *'; No direct calculation of potential from Coulomb F.'
      ENDIF
      PRINT *,' CONSLL=',CONSLL,' /DL=',DBLE(CONSLL)/DBLE(DL)
      PRINT *,' CONSL0=',CONSL0,' CONSL0/CONSLL=',CONSL0/CONSLL
CDBG
CIEND
C----- SET POINTERS -----
      CALL SETPNT(NP,MAXPH,KFLD,NX,NY,NF,NR,LBPRFL,NTS,MT,MAXLEP,
     * LENHZ,IZMAX-IZMIN+2,LZBSZ,NZBSZ,NBBSZ,LSHIST,NSBIN,MSQ,ISPIN,
     * LCMPTN,MCPSQ,MMOM,LAVY,LRMSY,NTAVY,NIZAVY,MW,IRTN)
CDEBUG
CDBG  PRINT *,'!SETPNT--JUPSLN, JUPNUM, KUPENG=',JUPSLN, JUPNUM,KUPENG
CDEBUG
      IF(IRTN.NE.0) GOTO 110
C----- SET INITIAL CONDITIONS -----
      CALL INIT1(1,KFLD,IRG,IRTN,ZZMM,NP,
     *   R4(JPXY),R4(JPXY0),R4(JPZZ),R8(KPENG),
     *   SIG,GCUT,EMIT,ALPHA,SLOPE,OFFSET,LSPIN,ISPIN,R4(JPSPIN)
     *,  SLANT)
CDEBUG
CDBG  PRINT *,'!!!ENG(INIT1-2)=',(R8(I),I=KPENG,KPENG+4)
CDEBUG
      IF(IRTN.NE.0) GOTO 110
      CALL INIT2(KFLD,XYMM,NP,R4(JPXY),R4(JPXY0),R4(JPZZ),R8(KPENG),
     *           I4(JPRP),I4(IPNPIZ),IZMIN,IZMAX,DXYZ,DT,RTZ,MT1)
CDEBUG
CDBG  PRINT *,'!!!ENG(INIT1-2)=',(R8(I),I=KPENG,KPENG+4)
CDEBUG
C------ INITIAL CONDITIONS OF THE TEST PARTICLES -------
      IF(NTS.GE.1) THEN
          IF(LOS1.EQ.0) LTSRAD=0
          CALL INITTS(NTS,XTS0,YTS0,XPTS0,YPTS0,ZTS0,ETS0,
     *     MT,MT1,R4(JPXYTS),R4(JPETS),R4(JPZTS),SIG,DXYZ,DT)
          DO 199 I=1,NTS
  199    ITTS(I)=NINT(MAX(FLOAT(MT1),MIN(FLOAT(MT2),TTS(I)*SIGZ(1)/DT)))
        ENDIF
CIENDEND
C------ PRINT PARAMETERS ------
      WRITE(6,200) LVERS,NSTEP,JOBTIM
  200 FORMAT(1H1,/,' ************ ABEL VERSION ',A12,' **********'
     *  ,'   STEP',I3,' ********** ',A20,/)
      IF(NCTTL.NE.0) WRITE(6,202) TITLE
  202 FORMAT(3X,A80,/)
      WRITE(6,205) FREP
  205 FORMAT(' ********** PHYSICAL PARAMETERS **********',/,
     *  T5,'Repetition Frequency',T35,0P,F12.3,'(Hz)')
      WRITE(6,210) (L,L=1,2),ENGY(1),ENGY(2),AN(1),AN(2),
     *  (SIGZ(L)*UNIT(5),GCUT(3,L),L=1,2)
  210 FORMAT(/,T35,2(11X,'BEAM #',I1,8X),/,
     *  T5,'Beam Energy (GEV)',T35,0P,2F26.3,/,
     *  3X,'Number of Particlles per Bunch',T35,2(2X,1P,E12.3,12X),/,
     *  3X,'SIGZ(mm) AND GCUT',T35,2(2X,0P,F12.6,0P,F12.3))
      IF(KFLD.NE.4) WRITE(6,212)
     *  ((SIG(IXY,L)*UNIT(2*IXY-1),IXY=1,2),L=1,2),
     *  ((GCUT(IXY,L),IXY=1,2),L=1,2),
     *  (EMIT(1,L),EMIT(2,L),L=1,2),(BETA(1,L),BETA(2,L),L=1,2),
     *  (SIG(3,L)/BETA(1,L),SIG(3,L)/BETA(2,L),L=1,2),
     *  ((ALPHA(IXY,L),IXY=1,2),L=1,2),((OFFSET(IXY,L),IXY=1,2),L=1,2),
     *  ((SLOPE(IXY,L),IXY=1,2),L=1,2),
     *  (DSRP(L,1),DSRP(L,2),L=1,2)
     *, (SLANT(L),L=1,2)
  212 FORMAT(T35,2('   X(Gaussian) Y(Gaussian)'),/,
     *  3X,'SIGXY(micron)',T35,2(2X,0P,2F12.6),/,
     *  3X,'  GCUT OF SIGXY',T35,2(2X,0P,2F12.3),/,
     *  3X,'Emittance (rad.meter)',T35,2(2X,1P,2E12.3),/,
     *  3X,'BETA (m)',T35,2(2X,0P,2F12.6),/,
     *  3X,'SIGZ/BETA',T35,2(2X,0P,2F12.8),/,
     *  3X,'ALPHA',T35,2(2X,0P,2F12.5),/,
     *  3X,'Offset in units of SIGXY',T35,2(2X,0P,2F12.5),/,
     *  3X,'Slope (Radian)',T35,2(2X,0P,2F12.6),/,
     *  3X,'Disruption Parameter',T35,2(2X,0P2F12.6),/,
     *  3X,'Rotation angle in XY',T35,2(2X,0PF12.5,12X) )
      IF(KFLD.EQ.4) WRITE(6,214)
     *  ((SIG(IXY,L)*UNIT(2*IXY-1),IXY=1,2),L=1,2),(WIDX*UNIT(1),L=1,2),
     *  (GCUT(2,L),L=1,2),
     *  (EMIT(2,L),L=1,2),(BETA(2,L),L=1,2),
     *  (SIG(3,L)/BETA(2,L),L=1,2),
     *  (ALPHA(2,L),L=1,2),(OFFSET(2,L),L=1,2),
     *  (SLOPE(2,L),L=1,2),
     *  (DSRP(L,1),DSRP(L,2),L=1,2)
     *, (SLANT(L),L=1,2)
  214 FORMAT(T35,2('   X(Uniform)  Y(Gaussian)'),/,
     *  3X,'SIGXY(micron)',T35,2(2X,0P,2F12.6),/,
     *  3X,'Horizontal Width (micron)',T35,2(2X,0P,F12.6,12X),/,
     *  3X,'  GCUT of SIGY',T35,2(14X,0P,F12.3),/,
     *  3X,'Emittance (rad.meter)',T35,2(14X,1P,E12.3),/,
     *  3X,'BETA (m)',T35,2(14X,0P,F12.6),/,
     *  3X,'SIGZ/BETA',T35,2(14X,0P,F12.8),/,
     *  3X,'ALPHA',T35,2(14X,0P,F12.5),/,
     *  3X,'Offset in units of SIGY',T35,2(14X,0P,F12.5),/,
     *  3X,'Slope (radian)',T35,2(14X,0P,F12.6),/,
     *  3X,'Disruption Parameter',T35,2(2X,0P2F12.6),/,
     *  3X,'Rotation angle in XY',T35,2(2X,0PF12.5,12X) )
      WRITE(6,216) ALUM00*1E-4,ALUM01*1E-4,ALUM02*1E-4,ALUM03*1E-4
  216 FORMAT(/,T5,'Luminosity   (Hz/cm**2)  ',/,
     * T10,'L00: head-on, no beam size variation',T50,1P,D10.3,/,
     * T10,'L01: with Gaussian cutoff corrected',T50,1P,D10.3,/,
     * T10,'L02: with finite emittance,offset,slope',T50,1P,D10.3,/,
     * T10,'L03: with both',T50,1P,D10.3)
      WRITE(6,220) NP,DZ*1D3,DZ/SIG(3,1),GCUTZ(1),GCUTZ(2),
     *     DT*1D3,DT/SIG(3,1),RTZ,MT1,MT2
  220 FORMAT(//,' ********** COMPUTATION PARAMETERS **********',/,
     *  T5,'# of super particles per beam',T50,I6,/,
     *  T5,'Width of Z-slice',T50,F9.5,'(mm)=',F9.5,'*SIGZ1',/,
     *  T5,'Total Range of Z-slice(beam12)',T50,'+-',2F10.5,'*SIGZ1',/,
     *  T5,'Time step interval',T50,F9.5,'(mm)=',F9.5,'*SIGZ1 =',
     *     F9.5,'*DZ',/,
     *  T5,'# of time steps',T50,I5,' TO ',I5)
      CHWORK='not assumed'
      IF(LUPDWN.NE.0) CHWORK='assumed'
      IF(KFLD.LE.1.OR.KFLD.EQ.3) WRITE(6,222) LKFLD(KFLD),CHWORK,
     *  LEQM,LHIGH,NX,NY,DX*1D6,DY*1D6,DX/SIG(1,1),DY/SIG(2,1),LOUT
  222 FORMAT(T5,'Integration method',T50,A15,/,
     *  T5,'        Up-down symmetry',T50,A11,/,
     *  T5,'              LEQM,LHIGH',T50,2I5,/,
     *  T5,'# of cells in transverse plane (X,Y)',T50,2(7X,I5),/,
     *  T5,'     Cell size (micron)',T50,0P,2F12.5,/,
     *  T5,'       in units of SIGX1,SIGY1',T50,0P,2F12.6,/,
     *  T5,'Particles out of cell range: LOUT=',T50,I4)
      IF(KFLD.EQ.4) WRITE(6,224) LKFLD(KFLD),CHWORK(1:11),
     *  NY,DY*1D6,DY/SIG(2,1)
  224 FORMAT(T5,'Integration method',T50,A15,/,
     *  T5,'        Up-down symmetry',T50,A11,/,
     *  T5,'# of cells in vertical',T50,19X,I5,/,
     *  T5,'     Cell size (micron)',T50,12X,0P,F12.5,/,
     *  T5,'       in units of SIGY1',T50,12X,0P,F12.6)
      IF(KFLD.EQ.2) WRITE(6,230) LKFLD(2),NR,DR*1D6
  230 FORMAT(T5,'Integration method',T50,A15,/,
     *  T5,'# of radial mesh',T50,I12,/,
     *  T5,'Radial mesh size (micron)',T50,0P,F12.5)
      WRITE(6,240) ONOFF(MIN(1,NODSRP)+1),ONOFF(MAX(NODSRP,1)),
     *  LOSKIN(LOS1+1),LFBCK(LOS2+1),THIN,IRGPR,IRRPR
  240 FORMAT(/,T10,'DISRUPTION EFFECT TURNED ----',T70,A3,/,
     * T10,'ENERGY CHANGE EFFECT ON RADIATION ----',T70,A3,/,
     * T10,'BEAMSTRAHLUNG LOSS ----',T35,A40,/,
     * T10,'ENERGY CHANGE EFFECT ON PARTICLE MOTION ----',T60,A15,/,
     * T10,'INITIAL THINNING FACTOR OF PHOTON EMISSION',T60,F12.4,/,
     * T10,'INITIAL RANDOM NUMBER FOR INITIAL DISTRIBUTION',T60,I12,/,
     * T10,'INITIAL RANDOM NUMBER FOR RADIATION',T60,I12)
      WRITE(6,300)
  300 FORMAT(/,' ***  INITIAL CONDITIONS BY RANDOM NUMBERS ***',/,
     *  29X,'BEAM#1',37X,'BEAM#2',
     *  /,9X,2('       MIN       MAX      MEAN       RMS   '))
      WRITE(6,320) (TTL2(J),((XYMM(I,J,L,1)*UNIT(J),I=1,4),L=1,2),
     *         J=1,6)
  320 FORMAT((1X,A9,2(3X,4F10.5)))
      CALL PRTIME(20,22,'INITIAL CONDITION SET.')
C------
      IF(LSHIST.GE.1) THEN
CZERO           CALL CLEAR(R4(JPSBIN),NSBIN)
CZERO           CALL CLEAR(R4(JPSBN2),NSBIN**2)
          CALL UVZERO(NSBIN,R4(JPSBIN))
          CALL UVZERO(NSBIN**2,R4(JPSBN2))
        ENDIF
      IF(LCMPTN.GE.1) THEN
          DO 330 L=1,2
          DO 330 IZ=IZMIN,IZMAX+1
  330     I4(IPPHIZ+IZ-IZMIN+(IZMAX-IZMIN+2)*(L-1))=1
CZERO           CALL CLEAR(R4(JPCPBN),NSBIN*2)
CZERO           CALL CLEAR(R4(JPCPB2),NSBIN**2*2)
CZERO           CALL CLEAR(R4(JPGGBN),NSBIN)
CZERO           CALL CLEAR(R4(JPGGB2),NSBIN**2)
          CALL UVZERO(NSBIN*2,R4(JPCPBN))
          CALL UVZERO(NSBIN**2*2,R4(JPCPB2))
          CALL UVZERO(NSBIN,R4(JPGGBN))
          CALL UVZERO(NSBIN**2,R4(JPGGB2))
        ENDIF
C----- PREPARE POTENTIAL MATRIX -----
      IF(KFLD.EQ.0) THEN
          CALL POTMAT(NX,NY,DX,DY,R8(KPPHIQ),R8(KPAAA),R8(KPAAA2))
        ENDIF
      IF(KFLD.EQ.1) THEN
          CALL KERNEL(R8(KPFKER),NF,NF+1,DY/DX)
        ENDIF
      CALL PRTIME(1,1,DUMMY)
      CALL PRTIME(20,26,'POTENTIAL MATRIX COMPUTED.')
C-------------- START TRACKING ---------------
      ALUM1=0D0
      ALUM2=0D0
      DO 590 II=1,MMOM
  590 SCM(II)=0.0
      NPLT=0
      ITERM=0
      NCAL1=0
      NCAL2=0
      IF(CPUT.GT.0) CALL CPUTRM(-100000,CPU,CPUT0,IDUMMY,*2100)
      DO 592 L=1,2
      POLS(L)=0D0
      NPH0(L)=0
      NPH(L)=0
      AVEPH(L)=0.0
      ECRAV(L)=0.0
  592 ECRMX(L)=0.0
      NOUT=0
CZERO       CALL CLEAR(R4(JPENHT),MT)
      CALL UVZERO(MT,R4(JPENHT))
CZERO       IF(LENHZ.GE.1) CALL CLEAR(R4(JPENHZ),2*(IZMAX-IZMIN+2))
CZERO       IF(KFLD.EQ.4) CALL CLEAR(R4(JPFXY),NP*2*2)
      IF(LENHZ.GE.1) CALL UVZERO(2*(IZMAX-IZMIN+2),R4(JPENHZ))
      IF(KFLD.EQ.4) CALL UVZERO(NP*2*2,R4(JPFXY))
      CALL PRTIME(20,20,'TRACKING NOW STARTS.')
      IF(ITRACE.NE.0) THEN
          LTRACE=1
          IF(ITRACE.LT.0) LTRACE=2
          WRITE(6,596) ABS(ITRACE),LTRACE,
     *                 ZZ(ABS(ITRACE),LTRACE)*DZ/SIG(3,1)
  596     FORMAT(' --',I8,'-TH PARTICLE IN BEAM#',I1,' AT Z=',
     *           F10.5,'SIGMA WILL BE TRACED.')
        ENDIF
C---------------------------------------------------------------------
      DO 2000 NT=MT1,MT2
C---------------------------------------------------------------------
CDBGDBG       PRINT *,' NT =',NT
      NT1=NT+1
      IF(IPROFL.GE.1.AND.MOD(NT,IPROFL).EQ.0)
     *    CALL PROFIL(LPROFL,R4(JPXY0),R4(JPZZ),NP,NT,SIG,DXYZ,DT,
     *         R4(JPRP),R4(JPRP+NP))
      IF(LBPRFL.GE.1) CALL BPRFL(LBPRFL,NBPRFL,KBPRFL,MBPRFL,
     *   NT,MT,MT1,MT2,DT,DXYZ,RTZ,SIG,NX,NY,NP,NTS,
     *   R4(JPXY),R4(JPZZ),R4(JPXYTS),ZTS0,I2(I2PIQX),I2(I2PIQY))
      IF(ITERM.NE.0) GOTO 110
      IF(LZBSZ.GE.1)
     *  CALL PLZBSZ(0,NT,MT1,MT,LZBSZ,DBBSZ,DBBSZ0,DT/SIG(3,1),
     *    ZBSZ,NZBSZ,R4(JPBSZ),IZBSZ,I4(IPNPIZ),IZMIN,IZMAX,
     *    R4(JPXY0),NP,I4(IPIXY),R4(JPQBSZ),NBBSZ)
      IF(LAVY.GE.1.OR.LRMSY.GE.1) THEN
          IF(MOD(NT,NAVY).EQ.0)
     *     CALL PLAVY(1,NAVY,LAVY,LRMSY,R4(JPXY0),NP,NT,
     *       DXYZ,DT,MZT,SIG,R4(JPAVY),R4(JPRMSY),MTAVY1,MTAVY2,
     *       I4(IPNPIZ),IZMIN,IZMAX,IZMINA,IZMAXA)
        ENDIF
C----- DRIFT -----
      CALL PRTIME(0,1,DUMMY)
      CALL DRIFT(KFLD,NP,R4(JPXY),R4(JPXY0),NTS,MT,NT,MT1,
     *             R4(JPXYTS),R4(JPETS))
      CALL PRTIME(7,1,DUMMY)
C*************** INTERACTION ***************
      KS11=IZMM(1,1)-(MZT/2-1)+NT
      KS12=-(IZMM(2,2)+MZT/2+NT)
      KS1=MAX(KS11,KS12)
      KS21=IZMM(2,1)+MZT/2+NT
      KS22=-(IZMM(1,2)-(MZT/2-1)+NT)
      KS2=MIN(KS21,KS22)
      KS1=-((-KS1+100000*MZT)/MZT-100000)
      KS2=(KS2+100000*MZT)/MZT-100000
      IF(KS1.GT.KS2) GOTO 2000
      NOUT2(1)=0
      NOUT2(2)=0
C-----
C*******************************************************************
      DO 1400 KS=KS1,KS2
CDBGDBG       PRINT *,' KS=',KS
C*******************************************************************
C------CHARGE DISTRIBUTION
      DO 640 L=1,2
      ISIG1=3-2*L
      IZMM1(1,L)=MAX(IZMM(1,L),ISIG1*MZT*KS-NT-MZT/2)
      IZMM1(2,L)=MIN(IZMM(2,L),ISIG1*MZT*KS-NT+MZT/2-1)
      NPZ0(L)=NPIZ(IZMM1(1,L),L)
      NPZ(L)=NPIZ(IZMM1(2,L)+1,L)-1
      IF(NPZ0(L).GT.NPZ(L)) GOTO 1400
      ZMIN(L)=IZMM1(1,L)*RTZ
      ZMAX(L)=(IZMM1(2,L)+1)*RTZ
  640 CONTINUE
C
      IF(KFLD.EQ.2) GOTO 1200
      DO 690 IXY=1,2
      IF(IXY.EQ.1.OR.LUPDWN.NE.0) THEN
          SUMXY1=0.0
        ELSE
         SUMXY1=(AVR4(R4(JPXY0+NPZ0(1)-1+NP*(IXY-1)),NPZ(1)-NPZ0(1)+1)+
     *        AVR4(R4(JPXY0+NPZ0(2)-1+NP*(IXY+1)),NPZ(2)-NPZ0(2)+1))/2.
        ENDIF
      CENT(IXY)=NINT(SUMXY1)
      IF(IXY.EQ.1) THEN
          BLEND(IXY)=CENT(IXY)-0.5*(NX-1)
        ELSE
          BLEND(IXY)=CENT(IXY)-0.5*(NY-1)
        ENDIF
  690 CONTINUE
      CALL PRTIME(0,1,DUMMY)
      CALL DISTRI(KFLD,NP,NX,NY,MMOM,LSHIST,MSQ,NOUT1,LUPDWN,
     *   NPZ,NPZ0,BLEND,I4(IPIXY),IXM,IYM,
     *   R4(JPXY0),R8(KPQ),R8(KPQE),R8(KPENG),
     *   NSQ,I4(IPISQN),I4(IPISQK),I4(IPISC),
     *   LSPIN,R4(JPSPIN),R4(JPPOLZ))
CDEBUG
CDBG  PRINT *,'!!!ENG(INIT1-2)=',(R8(I),I=KPENG,KPENG+4)
CDEBUG
      NOUT2(1)=NOUT2(1)+NOUT1(1)
      NOUT2(2)=NOUT2(2)+NOUT1(2)
      IF(LCMPTN.GE.1) CALL DSTRIP(KFLD,NP,NX,NY,BLEND,NT,RTZ,R4(JPZZ),
     *    MAXPH,I4(IPIXYP),R4(JPXYPH),I4(IPPHEL),
     *    LCMPTN,MCPSQ,NCPSQ,I4(IPCPQN),I4(IPCPQK),I4(IPCPC),
     *    IZMM1,IZMIN,IZMAX,I4(IPPHIZ),I4(IPIDPH))
      CALL PRTIME(2,1,DUMMY)
      CALL LUMINT(KFLD,R8(KPQ),R8(KPQE),IXM,IYM,NX,NY,ALUM1,ALUM2,
     * R4(JPENHT+NT-MT1),LENHZ,R4(JPENHZ),IZMIN,IZMAX,IZMM1,I4(IPNPIZ),
     *   LSHIST,SCM,SCM1,MMOM,LSPIN,POLS,R4(JPPOLZ))
      IF(LSHIST.GE.1) CALL SHIST2(KFLD,R8(KPENG),IXM,IYM,NP,NX,NY,
     *       NSBIN,MSQ,R4(JPSBN2),R4(JPSBIN),R4(JPSBNW),
     *       I4(IPISQN),I4(IPISQK),I4(IPISC))
      IF(LCMPTN.GE.1) CALL CMPTN2(KFLD,R8(KPENG),IXM,IYM,NP,NX,NY,
     *     NSBIN,MSQ,R4(JPSBNW),I4(IPISQN),I4(IPISQK),I4(IPISC),
     *     MCPSQ,NCPSQ,R4(JPCPB2),R4(JPCPBN),R4(JPGGB2),R4(JPGGBN),
     *     I4(IPCPQN),I4(IPCPQK),I4(IPCPC),
     *     MAXPH,R4(JPEPH),I4(IPIDPH),THIN)
      CALL PRTIME(3,1,DUMMY)
C----- FIELD CALCULATION -----
      IF(NOCLMB.EQ.1) THEN
      C1=C0 + 100.
      ELSE
      C1=FLOAT(NPZ(1)-NPZ0(1))*FLOAT(NPZ(2)-NPZ0(2))/FLOAT(NX*NY)
      ENDIF
      IF(KFLD.NE.4.AND.C1.LE.C0) GOTO 800
      CALL PRTIME(0,1,DUMMY)
      IF(KFLD.EQ.0) CALL POISSN(NX,NY,DX,DY,IXM,IYM,R8(KPQ),
     *       R8(KPPHIQ),R8(KPPHI),R8(KPAAA),R8(KPAAA2),R8(KPW))
      IF(KFLD.EQ.1) CALL POISNF(NF,R8(KPQ),R8(KPPHI),R8(KPQF),
     *       R8(KPPHIF),R8(KPFKER))
      IF(KFLD.EQ.3) CALL POISFL(NX,NY,DX,DY,R8(KPQ),R8(KPQX),
     *       R4(JPEX),R4(JPEY))
      IF(KFLD.EQ.4) CALL POIS1D(NY,WIDX,DY,R8(KPQ),R4(JPEY))
      NCAL1=NCAL1+1
      IF(IFIELD.NE.0.AND.KS.EQ.0) THEN
          IF(MOD(ABS(NT),ABS(IFIELD)).EQ.0) THEN
              L=1
              IF(IFIELD.LT.0) L=2
           CALL PRFLD(KFLD,NT,L,NPZ(L)-NPZ0(L)+1,AA,NX,NY,R8(KPQ),
     *        R8(KPPHI),R4(JPEX),R4(JPEY))
            ENDIF
        ENDIF
      CALL PRTIME(4,1,DUMMY)
C----- FORCE ON EACH PARTICLE -----
      IF(KFLD.EQ.3)
     *   CALL EQMFL(NP,NX,NY,DX,DY,NTS,MT,MT1,NT,LOS1,MAXPH,
     *       IRR,BLEND,AA,ZMIN,ZMAX,IXM,IYM,NPZ,NPZ0,NOUT1,
     *       R4(JPXY),R4(JPXY0),R4(JPFXY),I4(IPIXY),
     *       R4(JPXYTS),R4(JPZTS),R4(JPETS),ITTS,LTSRAD,
     *       R4(JPXYPH),R4(JPEPH),R8(KPQ),R4(JPEX),R4(JPEY),LOUT)
      IF(KFLD.EQ.4)
     *   CALL EQM1D(NP,NY,DY,NTS,MT,MT1,NT,LOS1,MAXPH,
     *       IRR,BLEND,AA,ZMIN,ZMAX,NPZ,NPZ0,
     *       R4(JPXY),R4(JPXY0),R4(JPFXY),I4(IPIXY),
     *       R4(JPXYTS),R4(JPZTS),R4(JPETS),ITTS,LTSRAD,
     *       R4(JPXYPH),R4(JPEPH),R4(JPEY))
      IF(KFLD.LE.1.AND.LEQM.EQ.0)
     *   CALL EQM(NP,NX,NY,DX,DY,NTS,MT,MT1,NT,LOS1,MAXPH,
     *       IRR,BLEND,AA,ZMIN,ZMAX,IXM,IYM,NPZ,NPZ0,NOUT1,
     *       R4(JPXY),R4(JPXY0),R4(JPFXY),I4(IPIXY),
     *       R4(JPXYTS),R4(JPZTS),R4(JPETS),ITTS,LTSRAD,
     *       R4(JPXYPH),R4(JPEPH),R8(KPQ),R8(KPPHI),LOUT)
      IF(KFLD.LE.1.AND.LEQM.NE.0)
     *   CALL EQMX(NP,NX,NY,DX,DY,NTS,MT,MT1,NT,LOS1,MAXPH,
     *       IRR,BLEND,AA,ZMIN,ZMAX,IXM,IYM,NPZ,NPZ0,NOUT1,
     *       R4(JPXY),R4(JPXY0),R4(JPFXY),I4(IPIXY),
     *       R4(JPXYTS),R4(JPZTS),R4(JPETS),ITTS,LTSRAD,
     *       R4(JPXYPH),R4(JPEPH),R8(KPQ),R8(KPPHI),R4(JPW),LOUT,LHIGH)
      CALL PRTIME(5,1,DUMMY)
C---
       IF(MAXLEP.GT.0) THEN
         GO TO 1310
          ELSE
         GO TO 1300
       ENDIF
C-------   DIRECT CALCULATION BY COULOMB'S LAW
  800 CALL PRTIME(0,1,DUMMY)
      CALL COULMB(NP,DX,DY,NTS,MT,MT1,NT,LOS1,MAXPH,
     *    IRR,RMIN2,AA,ZMIN,ZMAX,NPZ,NPZ0,
     *    R4(JPXY),R4(JPXY0),R4(JPFXY),
     *    R4(JPXYTS),R4(JPZTS),R4(JPETS),ITTS,LTSRAD,
     *    R4(JPXYPH),R4(JPEPH))
      NCAL2=NCAL2+1
      CALL PRTIME(6,1,DUMMY)
      GOTO 1300
C----- AXIALLY SYMMETRIC FIELD -----
 1200 CALL PRTIME(0,1,DUMMY)
      CALL DISTRR(NP,NR,MMOM,LSHIST,MSQ,NOUT1,
     *                  NPZ,NPZ0,I4(IPIXY),IRM,
     *  R4(JPXY0),R4(JPRP),R8(KPQR),R8(KPQRE),R8(KPER),R8(KPENG),
     *  NSQ,I4(IPISQN),I4(IPISQK),I4(IPISCR),
     *  LSPIN,R4(JPSPIN),R4(JPPLZR))
      IF(LCMPTN.GE.1) CALL DSTRRP(NP,NR,NT,RTZ,R4(JPZZ),
     *    MAXPH,I4(IPIXYP),R4(JPXYPH),R4(JPRPPH),I4(IPPHEL),
     *    LCMPTN,MCPSQ,NCPSQ,I4(IPCPQN),I4(IPCPQK),I4(IPCPCR),
     *    IZMM1,IZMIN,IZMAX,I4(IPPHIZ),I4(IPIDPH))
      CALL PRTIME(2,1,DUMMY)
      CALL LUMINR(R8(KPQR),R8(KPQRE),IRM,NR,ALUM1,ALUM2,
     * R4(JPENHT+NT-MT1),LENHZ,R4(JPENHZ),IZMIN,IZMAX,IZMM1,I4(IPNPIZ),
     *   LSHIST,SCM,SCM1,MMOM,LSPIN,POLS,R4(JPPLZR))
      IF(LSHIST.GE.1) CALL SHIS2R(R8(KPENG),IRM,NP,NR,NSBIN,MSQ,
     *             R4(JPSBN2),R4(JPSBIN),R4(JPSBNW),
     *             I4(IPISQN),I4(IPISQK),I4(IPISCR))
      IF(LCMPTN.GE.1) CALL CMPT2R(R8(KPENG),IRM,NP,NR,NSBIN,MSQ,
     *     R4(JPSBNW),I4(IPISQN),I4(IPISQK),I4(IPISCR),
     *     MCPSQ,NCPSQ,R4(JPCPB2),R4(JPCPBN),R4(JPGGB2),R4(JPGGBN),
     *     I4(IPCPQN),I4(IPCPQK),I4(IPCPCR),
     *     MAXPH,R4(JPEPH),I4(IPIDPH),THIN)
      CALL PRTIME(3,1,DUMMY)
      CALL EQMR(NP,NR,DR,NTS,MT,MT1,NT,LOS1,MAXPH,
     *    IRR,AA,ZMIN,ZMAX,NPZ,NPZ0,
     *    R4(JPXY),R4(JPXY0),R4(JPRP),R4(JPFXY),I4(IPIXY),
     *    R4(JPXYTS),R4(JPZTS),R4(JPETS),ITTS,LTSRAD,
     *    R4(JPXYPH),R4(JPEPH),R8(KPER))
      CALL PRTIME(5,1,DUMMY)
      GO TO 1300
C------------------
C----ALL LOW ENERGY PAIR PARTICLES HERE
1310  CONTINUE
CDEBUG
CDBG  PRINT *,'--JUPSLN, JUPNUM, KUPENG=',JUPSLN, JUPNUM,KUPENG
CDBG  PRINT *,'--KPENG,  JPFXY,   IPIXY=',KPENG, JPFXY, IPIXY
CDBG  PRINT *,'!!!ENG(INIT1-2)=',(R8(I),I=KPENG,KPENG+4)
CDBG  PRINT *,'!!!UPS(INIT1-2)=',(R4(I),I=JUPSLN,JUPSLN+4)
CDBG  PRINT *,'!!!NUM(INIT1-2)=',(R4(I),I=JUPNUM,JUPNUM+4)
CDBG  PRINT *,'!!!UPE(INIT1-2)=',(R8(I),I=KUPENG,KUPENG+4)
CDBG  PRINT *,'!!!FXY(INIT1-2)=',(R4(I),I=JPFXY ,JPFXY +4)
CDBG  PRINT *,'!!!IXY(INIT1-2)=',(R4(I),I=IPIXY ,IPIXY +4)
CDEBUG
      CALL UPSLOC(R4(JUPSLN),R4(JUPNUM),R8(KUPENG),CLOS2,NX,NY,NP,DX,DY
     *    ,NPZ,NPZ0,R8(KPENG),R4(JPFXY),I4(IPIXY) )
C---
      IF(NT.EQ.0) THEN
        DO 1311 IUP=1,NX*NY
         IF(R4(JUPSLN+IUP-1).GT.0.) THEN
         CALL HCUM1('UPSL',R4(JUPSLN+IUP-1),1.)
         ENDIF
1311    CONTINUE
      ENDIF
C---
CDEBUG
CDBG  PRINT *,'************** AFTER ****************************'
CDBG  PRINT *,'!!!ENG(INIT1-2)=',(R8(I),I=KPENG,KPENG+4)
CDBG  PRINT *,'!!!UPS(INIT1-2)=',(R4(I),I=JUPSLN,JUPSLN+4)
CDBG  PRINT *,'!!!NUM(INIT1-2)=',(R4(I),I=JUPNUM,JUPNUM+4)
CDBG  PRINT *,'!!!UPE(INIT1-2)=',(R8(I),I=KUPENG,KUPENG+4)
CDBG  PRINT *,'!!!FXY(INIT1-2)=',(R4(I),I=JPFXY ,JPFXY +4)
CDBG  PRINT *,'!!!IXY(INIT1-2)=',(R4(I),I=IPIXY ,IPIXY +4)
CDEBUG
CNEWNEW
      IF(THINBW.GT.0) CALL PAIRBW(NBOOST,NX,NY,NT,
     *    RTZ,R4(JPZZ),NP,R8(KPQ),
     *    MAXPH,NPH,I4(IPIXYP),R4(JPEPH),R4(JPXYPH),I4(IPPHEL),
     *    IZMM1,IZMIN,IZMAX,I4(IPPHIZ),I4(IPIDPH),THIN,
     *    MAXLEP,NLEP,I4(IPIDLE),I4(IPLEOR),R4(JPEELE),R4(JPXYLE),
     *    ELEMIN,ELEMAX,THINLE,CONSBW,ENGY,GAM,ANGBWA,DXYZ,DT,IRR)
CDBGDBG       PRINT *,' NLEP(PAIRBW)=',NLEP
      IF(THINLL.GT.0) 
     *    CALL PAIRLL(NTUNE,NBOOST,LOCAL,NFLDEX,NP,I4(IPIXY),
     *    R4(JPXY0),R4(JPXY),R8(KPENG),NX,NY,R8(KPQ),NPZ0,NPZ,ENGY,
     *    NLEP,MAXLEP,ELEMIN,ELEMAX,THINLE,
     *    I4(IPIDLE),I4(IPLEOR),R4(JPEELE),
     *    R4(JPXYLE),CONSLL,GAM,ANGLLA,DXYZ,DT,BLEND,R4(JUPSLN),IRR)
CDBGDBG       PRINT *,' NLEP(PAIRLL)=',NLEP
      IF(THINBH.GT.0) CALL PAIRBH(NTUNE,NBOOST,LOCAL,NFLDEX,
     *  NX,NY,NT,RTZ,R4(JPZZ),NP,R8(KPQ),
     *  MAXPH,NPH,I4(IPIXYP),R4(JPEPH),R4(JPXYPH),I4(IPPHEL),
     *  IZMM1,IZMIN,IZMAX,I4(IPPHIZ),I4(IPIDPH),THIN,
     *  MAXLEP,NLEP,I4(IPIDLE),I4(IPLEOR),R4(JPEELE),R4(JPXYLE),
     *  ELEMIN,ELEMAX,THINLE,CONSBH,ENGY,GAM,
     *  ANGBHA,DXYZ,DT,BLEND,R4(JUPSLN),IRR)
CDBGDBG       PRINT *,' NLEP(PAIRBH)=',NLEP
      CALL PRTIME(8,1,DUMMY)
CNEWNEW
      IF(LEP.GT.0)
     *  CALL EQMLEP(NOKICK,NLEP,MAXLEP,I4(IPIDLE),I4(IPLEOR),
     *  R4(JPEELE),R4(JPXYLE),
     *    NPZ0,NPZ,KFLD,NX,NY,IXM,IYM,BLEND,CENT,AA,DX,DY,DT,SIG,
     *    R8(KPQ),R8(KPQX),R8(KPPHI),R4(JPEX),R4(JPEY))
      CALL PRTIME(9,1,DUMMY)
C------ KICK
 1300 CALL KICK(KFLD,NP,DX,DY,DZ,DT,NT,LOS1,LOS2,MAXPH,
     *    IRR,NODSRP,ITRACE,NPZ,NPZ0,IZMM1,I4(IPNPIZ),IZMIN,IZMAX,
     *    R4(JPXY),R4(JPXY0),R4(JPZZ),R8(KPENG),R4(JPFXY),
     *    I4(IPPHEL),R4(JPXYPH),R4(JPEPH),
     *    GAM,LSPIN,R4(JPSPIN),
     *    LCMPTN,I4(IPPHIZ),I4(IPIDPH))
      CALL PRTIME(7,1,DUMMY)
C*******************************************************************
 1400 CONTINUE
C*******************************************************************
      NOUT=MAX(NOUT,NOUT2(1)+NOUT2(2))
 1900 IF(CPUT.GT.0) CALL CPUTRM(NT,CPUT,CPUT0,KS2-KS1+1,*2100)
C-------------------------------------------------------------------
 2000 CONTINUE
C----- END OF TRACKING -----
C-------------------------------------------------------------------
 2100 CALL PRTIME(20,18,'TRACKING FINISHED.')
      WRITE(6,2110) NCAL1,NCAL2
 2110 FORMAT(35X,'SUBR.POISSN/POISNF CALLED',I6,' TIMES.',/,
     *       35X,'SUBR.COULMB        CALLED',I6,' TIMES.')
C---
      PRINT *,'################################################'
      PRINT *,'### IRRPR =',IRRPR,' for initial random number '
      PRINT *,'### IRGPR =',IRGPR,' for initial random number '
      PRINT *,'### IRR   =',IRR,' for random number '
      PRINT *,'### IRG   =',IRG,' for random number(INIT1 only)'
      PRINT *,'################################################'
      WRITE(70,700) IRR
      WRITE(70,700) IRG
700   FORMAT(I16)      
C---
      CALL BACK(NP,DXYZ,DT,NT1,
     *    R4(JPXY),R4(JPXY0),R4(JPZZ),R8(KPENG),R4(JPRP),
     *    MAXPH,NPH,I4(IPPHEL),R4(JPXYPH),R4(JPEPH),R4(JPRPPH),XYMM,
     *    MAXLEP,NLEP,I4(IPIDLE),R4(JPXYLE))
      IF(ISPIN.GE.1) THEN
          POLS(1)=POLS(1)/ALUM1
          POLS(2)=POLS(2)/ALUM1
        ENDIF
        
      DO 2140 L=1,2
      DO 2140 LL=1,5
      AVNPH(L,LL)=0.
      DEAV(L,LL)=0.
      DERMS(L,LL)=0.
      DSAV(L,LL)=0.
 2140 DSRMS(L,LL)=0.
 
      IF(LSHIST.GE.0) THEN
          DO 2180 II=1,MMOM
 2180     SCM(II)=SCM(II)/ALUM1
          SCM2=SQRT(MAX(0D0,SCM(2)-SCM(1)**2))
          DSAV(1,1)=1D0-SCM(1)
          DSRMS(1,1)=SCM2
        ENDIF
      IF(KFLD.EQ.2) THEN
          FACLUM=FREP*AN(1)*AN(2)/(PI*DR**2*DFLOAT(NP)**2)*(2D0*RTZ)
          ALUM2=ALUM1+ALUM2/6.0
        ELSE
          IF(KFLD.EQ.4) THEN
              FACLUM=FREP*AN(1)*AN(2)/(WIDX*DY*DFLOAT(NP)**2)*(2D0*RTZ)
            ELSE
              FACLUM=FREP*AN(1)*AN(2)/(DX*DY*DFLOAT(NP)**2)*(2D0*RTZ)
            ENDIF
          ALUM2=ALUM1+ALUM2/48.0
        ENDIF
      FACLM1=FACLUM/CORLM1*ALUM2/ALUM1
      ALUM1=FACLUM*ALUM1
      ALUM2=FACLUM*ALUM2
      PINCH1=ALUM1/ALUM00
      PINCH2=ALUM2/ALUM00
      FACLM2=FACLUM/ALUM01
      DO 2200 NT=MT1,MT2
 2200 R4(JPENHT+NT-MT1)=ENHT(NT)*FACLM2
      IF(LENHZ.GE.1) THEN
          DO 2220 L=1,2
          DO 2210 IZ=IZMIN,IZMAX
 2210     R4(JPENHZ+IZ-IZMIN+(IZMAX-IZMIN+2)*(L-1))=ENHZ(IZ,L)*FACLM2
 2220     CONTINUE
        ENDIF
      DO 2260 L=1,2
      DEAV1=0D0
      DERMS1=0D0
      DO 2230 I=1,NP
      DEAV1=DEAV1+(1D0-ENG(I,L))
 2230 DERMS1=DERMS1+(1D0-ENG(I,L))**2
      DEAV(L,1)=DEAV1/NP
      DERMS(L,1)=SQRT(DERMS1/NP-DEAV(L,1)**2)
      NOPH(L)=0
      IF(LOS1.GE.3) THEN
          DO 2250 I=1,NP
 2250     IF(ENG(I,L).EQ.1D0) NOPH(L)=NOPH(L)+1
        ENDIF
 2260 CONTINUE
C------ THEORETICAL PREDICTIONS ------
       CALL THEORY(AN,SIG,GAM,GZI0,AVNPH,DEAV,DERMS,DSAV,DSRMS)
C------ BASIC PRINTOUTS
      WRITE(6,2300) ALUM1*1D-4,ALUM2*1D-4,
     *   ALUM1*1D-4/CORLM1,ALUM2*1D-4/CORLM1,
     *   PINCH1,PINCH2,
     *   PINCH1/CORLM1,PINCH2/CORLM1,
     *   (L,L=1,2),(DEAV(L,1),L=1,2),(DERMS(L,1),L=1,2)
 2300 FORMAT(1H1,/,' ********** TRACKING RESULTS **********',/,
     *  T35,'   NORMAL MESH     FINE MESH    ',/,
     *  T5,'LUMINOSITY(HZ/CM**2)',T35,2(2X,' ',1PD10.3,' '),/,
     *  T5,'  (TAIL CORRECTED)',T35,2(2X,' ',1PD10.3,' '),/,
     *  T5,'ENHANCEMENT FACTOR  L/L00',T35,2(3X,0PF10.4,1X),/,
     *  T5,'  (TAIL CORRECTED)  L/L01',T35,2(2X,'(',0PF10.4,')'),/,
     *  T40,2('    BEAM #',I1,4X),/,
     *  T5,'AVERAGE ENERGY LOSS (/E0)',T40,2F15.7,/,
     *  T5,'FINAL RMS ENERGY SPREAD (/E0)',T40,2F15.7)
      IF(LOS1.GE.3) WRITE(6,2305)
     *            (NOPH(L),L=1,2),(FLOAT(NOPH(L))/NP,L=1,2)
 2305 FORMAT(T5,'# OF PARTICLES OF NO RADIATION',T40,2I15,/,
     *       T5,'                     FRACTION',T40,0P,2F15.6)
      IF(LSHIST.GE.0) WRITE(6,2310) SCM(1),SCM2
 2310 FORMAT(T5,'MEAN S/S0   (S0=4*E10*E20)',T35,F9.6,/,
     *  T5,'R.M.S. S /S0',T35,F9.6)
      WRITE(6,2320) NOUT,NOUT/FLOAT(2*NP)*100.0
 2320 FORMAT(T5,'MAXIMUM # OF SUPER PARTICLES OUT OF MESH IN ',
     *      'ONE TIME STEP =',I5,3X,F7.3,' %')
      IF(LOUT.EQ.0.AND.(KFLD.NE.2.AND.KFLD.NE.4)) THEN
          WRITE(6,2330)
 2330     FORMAT(10X,'(FORCES ON THEM AND THEIR CONTRIBUTIONS TO ',
     *      'THE FIELD ARE IGNORED.)')
        ELSE
          WRITE(6,2340)
 2340     FORMAT(10X,'(THEIR CONTRIBUTIONS TO FIELDS ARE IGNORED.)')
        ENDIF
      WRITE(6,2350)
 2350 FORMAT(//,'**** FINAL ELECTRON ****',/,
     *  10X,'X,Y: INTERCEPT OF FINAL TRAJECTORY ON S=0 PLANE.',/,
     *  29X,'BEAM#1',37X,'BEAM#2',
     *  /,9X,2('       MIN       MAX      MEAN       RMS   '))
      WRITE(6,2360) (TTL2(J),((XYMM(I,J,L,1)*UNIT(J),I=1,4),L=1,2),
     *         J=1,7)
 2360 FORMAT((1X,A9,2(3X,4F10.5)))
      WRITE(6,2370)
 2370 FORMAT('          ---- NORMALIZED VALUES ----')
      WRITE(6,2360) (TTL3(J),((XYMM(I,J,L,1)/UNIT2(J,L),I=1,4),L=1,2),
     *         J=1,5)
C----TEMPORARY
      WRITE(6,2380) DSRP(1,2),SIG(3,1)/BETA(2,1),
     *  OFFSET(2,1)-OFFSET(2,2),PINCH2/CORLM1,
     *  (XYMM(1,4,2,1)-XYMM(2,4,1,1))/2/UNIT2(4,1),
     *  (XYMM(2,4,2,1)-XYMM(1,4,1,1))/2/UNIT2(4,1),
     *  (XYMM(3,4,2,1)-XYMM(3,4,1,1))/2/UNIT2(4,1),
     *  (XYMM(4,4,2,1)+XYMM(4,4,1,1))/2/UNIT2(4,1)
 2380 FORMAT('&',F5.1,F5.2,F5.1,F9.3,4F10.4)
C----
      ENHANC=PINCH2/CORLM1
      IF(LENHT.GE.1) CALL PLENHT(LENHT,ENHANC,R4(JPENHT),
     *      MT1,MT2,DT/SIG(3,1))
      IF(LENHZ.GE.1) CALL PLENHZ(LENHZ,ENHANC,R4(JPENHZ),
     *      I4(IPNPIZ),IZMIN,IZMAX,DT/SIG(3,1),NP)
C----------
      IF(LAVY.GE.1.OR.LRMSY.GE.1)
     *     CALL PLAVY(2,NAVY,LAVY,LRMSY,R4(JPXY0),NP,NT,
     *       DXYZ,DT,MZT,SIG,R4(JPAVY),R4(JPRMSY),MTAVY1,MTAVY2,
     *       I4(IPNPIZ),IZMIN,IZMAX,IZMINA,IZMAXA)
C----------
      IF(LZBSZ.GE.1)
     *  CALL PLZBSZ(1,NT,MT1,MT,LZBSZ,DBBSZ,DBBSZ0,DT/SIG(3,1),
     *    ZBSZ,NZBSZ,R4(JPBSZ),IZBSZ,I4(IPNPIZ),IZMIN,IZMAX,
     *    R4(JPXY0),NP,I4(IPIXY),R4(JPQBSZ),NBBSZ)
C----------
      IF(MAXPH.LE.0) GOTO 2450
      DO 2400 L=1,2
      AVNPH(L,1)=NPH0(L)/FLOAT(NP)
      AVEPH(L)=AVEPH(L)/NPH0(L)
      ECRAV(L)=ECRAV(L)/NPH0(L)
 2400 CONTINUE
      WRITE(6,2410) (NPH0(L),L=1,2),(AVNPH(L,1),L=1,2),(AVEPH(L),L=1,2),
     *  (ECRAV(L),L=1,2),(ECRMX(L),L=1,2),(NPH(L),L=1,2),THIN
 2410 FORMAT(//,T5,'# OF EMITTED MACRO-PHOTONS',T35,2I20,/,
     *  T5,'# OF PHOTONS PAR ELECTRON',T35,1P,2D20.4,/,
     *  T5,'AVERAGE PHOTON ENERGY /E0',T35,1P,2D20.4,/,
     *  T5,'AVERAGE CRITICAL ENERGY /E0',T35,1P,2D20.4,/,
     *  T5,'MAXIMUM CRITICAL ENERGY /E0',T35,1P,2D20.4,/,
     *  T5,'# OF STORED MACRO-PHOTONS',T35,2I20,/,
     *  T5,'THINNING FACTOR',T35,0P,F20.5)
      IF(THIN.LE.0) GOTO 2450
      WRITE(6,2420)
 2420 FORMAT(//,'**** FINAL PHOTON ****',/,
     *  10X,'X,Y: INTERCEPT OF TRAJECTORY ON S=0 PLANE.',/,
     *  10X,'Z  : Z OF SOURCE ELECTRON/POSITRON.',/,
     *  27X,'FROM BEAM#1',32X,'FROM BEAM#2',
     *  /,9X,2('       MIN       MAX      MEAN       RMS   '))
      WRITE(6,2430)
     *    (TTL2(J),((XYMM(I,J,L,2)*UNIT(J),I=1,4),L=1,2),J=1,7)
 2430 FORMAT((1X,A8,2(3X,4F10.5)))
 2450 WRITE(6,2460)
 2460 FORMAT(//,' **** BEAMSTRAHLUNG ****',/,
     * ' ----- COMPARISON WITH THEORETICAL PREDICTIONS -----',
     * /,T15,'EQUAL GAUSSIAN BEAM. NO PINCH EFFECT ASSUMED.',/,
     * T15,'IN KY (KEK PREPRINT 85-53)',/,
     * T15,' ASPECT RATIO FACTOR FOR CYLINDRICAL BEAM IS USED,',/,
     * T56,'BEAM 1',42X,'BEAM 2',/,
     % T31,2(' SIMUL.    BESSETTI SEMI-CLAS. EXTR.QUANT INTERPOL') )
      WRITE(6,2470) (GZI0(L),L=1,2),((AVNPH(L,LL),LL=1,5),L=1,2),
     % ((DEAV(L,LL),LL=1,5),L=1,2),((DERMS(L,LL),LL=1,5),L=1,2),
     % (DSAV(1,LL),LL=1,5),(DSRMS(1,LL),LL=1,5)
 2470 FORMAT(T5,'CRITICAL PARAMETER GZI0',T31,2(40X,1P,E10.3),/,
     %  T5,'# OF PHOTONS / ELECTRON',T31,1P,10E10.3,/,
     %  T5,'AVER. DE/E0',T31,1P,10E10.3,/,
     %  T5,'RMS DE/E0',T31,1P,10E10.3,/,
     %  T5,'AVER. DS/S0  (S=4*E1*E2)',T31,1P,5E10.3,/,
     %  T5,'RMS DS /S0',T31,1P,5E10.3)
      CALL THEOR2(GZI0,AVNPH(1,5))
C
      IF(LSHIST.LT.0) GOTO 2600
      CUMLN(1)=SCM(1)
      DO 2520 II=2,MMOM
      COMB1=1.0
      CUMLN(II)=SCM(II)
      DO 2510 IJ=1,II-1
      CUMLN(II)=CUMLN(II)-SCM(II-IJ)*CUMLN(IJ)*COMB1
 2510 COMB1=COMB1*FLOAT(II-IJ)/FLOAT(IJ)
 2520 CONTINUE
      WRITE(6,2530) (II,SCM(II),CUMLN(II),II=1,MMOM)
 2530 FORMAT(//,' **** CENTER-OF-MASS ENERGY ****',/,
     %   10X,'--- MOMENTS OF S/S0 AND CUMULANT EXPANSION ---',/,
     %  15X,'LOG(1+S1*T+S2*T**2/2!+S3*T**3/3!+...) = ',
     %  'K1*T+K2*T**2/2!+K3*T**3/3!+....,   SM=(S/S0)**M',/,
     %   5X,'M        <(S/S0)**M>          K(M)',/,
     %   (1X,I5,5X,2D15.6))
      IF(LSHIST.GE.1) CALL SHIST3(1,FACLM1,LPL0,NSTEP,NSBIN,
     %                  R4(JPSBN2),R4(JPSBN1),R4(JPSBIN),R4(JPSBNW))
      IF(LCMPTN.GE.1) THEN
          CALL CMPTN3(1,FACLM1,LPL0,NSTEP,NSBIN,CPLUM,GGLUM,
     %         R4(JPCPB2),R4(JPCPBN),R4(JPGGB2),R4(JPGGBN))
          WRITE(6,2550) CSBMIN,CSBMAX,(3-L,L,CPLUM(L),L=1,2)
 2550     FORMAT(' **** COMPTON SCATTERING LUMINOSITY ****',/,
     %      15X,'RANGE OF CM-ENERGY:',F8.3,' < S/S0 <',F8.3,/,
     %      (10X,'PHOTONS FROM BEAM#',I1,' ON E+-(BEAM#',I1,')',
     %       T55,1PE12.4,'( /CM**2/SEC)'))
          WRITE(6,2560) GSBMIN,GSBMAX,GGLUM
 2560     FORMAT(' **** GAMMA-GAMMA SCATTERING LUMINOSITY ****',/,
     %      15X,'RANGE OF CM-ENERGY:',F8.3,' < S/S0 <',F8.3,/,
     %       10X,'PHOTONS ON PHOTONS',T55,1PE12.4,'( /CM**2/SEC)')
        ENDIF
      IF(LSHIST.GE.1.AND..NOT.CERN)
     %    CALL SHIST3(2,FACLM1,LPL0,NSTEP,NSBIN,
     %          R4(JPSBN2),R4(JPSBN1),R4(JPSBIN),R4(JPSBNW))
      IF(LCMPTN.GE.1.AND..NOT.CERN)
     %    CALL CMPTN3(2,FACLM1,LPL0,NSTEP,NSBIN,CPLUM,
     %          GGLUM,R4(JPCPB2),R4(JPCPBN),R4(JPGGB2),R4(JPGGBN))
C----- POLARIZATION
 2600 IF(ISPIN.GE.1) CALL PRPOL(LSPIN,NP,POLS,POLFIN,R4(JPSPIN))
C---- TRAJECTORY OF TEST PARTICLES
      IF(NTS.NE.0) THEN
          CALL TSTRAJ(MT,MTS,NTS,LTS,XTS0,YTS0,
     %          XPTS0,YPTS0,ZTS0,ETS0,R4(JPXYTS),ITTS)
          IF(LTS.GE.2) CALL TSTPLT(MT,MTS,NTS,LNTS,KFLD,DSRP,
     %          ZTS0,ETS0,R4(JPXYTS),ITTS)
        ENDIF
C---- LOW ENERGY PARTICLES ---
      IF(LEP.GE.1) CALL PRLEP(NLEP,MAXLEP,THINLE,
     %    ELEMIN,ELEMAX,I4(IPLEOR),R4(JPEELE),R4(JPXYLE),
     %    R4(JPWKLE),ENGY,DSRP,SIG)
C---- PLOT
      IF(NPLEL.GE.1.OR.NPLPH.GE.1) THEN
          CALL PLTHPK(LOS1,NSTEP,NP,MAXPH,NPH,AN,SLOPE,LPL0,
     %        XYMM,LPLEP,NPLEP,
     %        R4(JPXY),R4(JPXY0),R4(JPZZ),R8(KPENG),R4(JPRP),
     %        I4(IPPHEL),R4(JPEPH),R4(JPXYPH),R4(JPRPPH))
        ENDIF
      CALL PRTIME(10,1,DUMMY)
      CALL PRTIME(30,1,DUMMY)
C---Printout the event loops.
      PRINT *,'********************************************************'
      PRINT *,'** PAIRBH **:# of events exceeded loop#(Angular boost) ='
     *,NCSBH
      PRINT *,'** PAIRBW **:# of events exceeded loop#(Angular boost) ='
     *,NCSBW
      PRINT *,'** PAIRLL **:# of events exceeded loop#(Angular boost) ='
     *,NCSLL
      PRINT *,'** PAIRLL **:# of events exceeded loop#(Energy-photon) ='
     *,NENGLL
      PRINT *,'********************************************************'
      PRINT *,'-- Luminosity =',TLMNS*DL*1.D-4,' cm-2/bunch in pairll.f'
      PRINT *,'-- Generated  =',CONSLL*TLMNS,' pairs'
      PRINT *,'-- Total pairs=',TCRSLL,' /bunch in pairll.f'
      PRINT *,'********************************************************'
C---
C***** END OF STEP *****
C
      IF(IFLOUT(0).GE.1.AND.IFLOUT(0).LE.99)
     %  CALL FLOUT(NTITL,IFLOUT,ENGY,AN,
     %   NP,R8(KPENG),R4(JPXY),R4(JPXY0),R4(JPZZ),
     %   MAXPH,NPH,I4(IPPHEL),R4(JPEPH),R4(JPXYPH),THIN,
     %   MAXLEP,NLEP,I4(IPLEOR),I4(IPIDLE),R4(JPEELE),R4(JPXYLE),
     %   THINLE)
C---
      IF(CERN) CALL VARLST(ENGY,SIG,DSRP,ALUM00*1E-4,
     %  ALUM2*1D-4/CORLM1,
     %  NP,R4(JPXY),R4(JPXY0),R4(JPZZ),R8(KPENG),R4(JPRP),
     %  MAXPH,THIN,NPH,I4(IPPHEL),R4(JPXYPH),R4(JPEPH),R4(JPRPPH),
     %  LSHIST,NSBIN,R4(JPSBN2),R4(JPSBIN),SBMIN,SBMAX,EBMIN,EBMAX,
     %  LCMPTN,CPLUM,R4(JPCPB2),R4(JPCPBN),CSBMIN,CSBMAX,CBMIN,CBMAX,
     %         GGLUM,R4(JPGGB2),R4(JPGGBN),GSBMIN,GSBMAX,
     %  NLEP,MAXLEP,THINLE,ELEMIN,ELEMAX,I4(IPLEOR),R4(JPEELE),
     %    R4(JPXYLE))
      GOTO 110
 3000 IF(LHP.NE.0) CALL HPK000(1,IDUMMY,NTITL)
C---
      CALL HISTDO
      
C---CC OUTPUT THE ALL HISTOGRAMS                                                    
         CALL HPRINT(0)
         CALL HROUT(0, ICYCLE, ' ')
         CALL HREND('ABEL')
         CLOSE(50)   

      STOP
C---------------------------------------------------------------------
C   AT '***** END OF STEP *****'  THE VARIABLES CONTAIN THE
C   FOLLOWING INFORMATIONS
C GAM(L)        INITIAL BEAM ENERGY / MC**2
C AN(L)         NUMBER OF ELECTRONS(L=1) AND POSITRONS(L=2).
C NP            NUMBER OF SUPER PARTICLES PER BEAM.
C XY(N,IXY,L)   X(IXY=1) AND Y(IXY=2) COORDINATE OF N-TH PARTICLE
C               IN L-TH BEAM IN UNITS OF METER. FINAL VALUE BUT
C               EXTRAPOLATED BACK TO THE INTERACTION POINT.
C XY0(N,IXY,L)  SLOPE IN RADIAN. (XY,XY0) MAKE PHASE SPACE.
C ZZ(N,L)       Z-COORDINATE OF N-TH PARTICLE IN L-TH BEAM. UNIT=METER
C               Z DOES NOT CHANGE THROUGH THE INTERACTION.
C               Z=0:BUNCH CENTER, Z>0:BUNCH HEAD.
C          CAUTION: MEANING OF XY,XY0 AND ZZ HAS CHANGED AFTER TRACKING.
C ENG(N,L)      FINAL ENERGY OF N-TH PARTICLE IN L-TH BUNCH IN THE
C               UNIT OF THE INITIAL ENERGY.
C NPH(L)        NUMBER OF SUPER PHOTONS STORED IN THE MEMORY
C               EMITTED BY THE L-TH BEAM. TO ESTIMATE THE NUMBER
C               OF REAL PHOTONS PER ELECTRON, MULTIPLY BY 1/NP/THIN.
C EPH(J,L)      ENERGY OF J-TH PHOTON EMITTED BY L-TH BEAM IN THE
C               UNIT OF INITIAL BEAM ENERGY. ( 1<J<NPH(L) )
C XYPH(J,IXY,L) X(IXY=1) OR DX/DT(IXY=2) OR Y(IXY=3) OR
C               DY/DT OF J-TH PHOTON EMITTED BY L-TH BEAM.
C               UNIT: X,Y METER, X',Y' RADIAN.  (CHANGED AT 2012)
C------ ERROR MESSAGES -------
      END
