C--- Updated ones
      SUBROUTINE PAIRBW(NBOOST,NX,NY,NT,RTZ,ZZ,NP,Q,
     %    MAXPH,NPH,IXYP,EPH,XYPH,IPHEL,
     %    IZMM1,IZMIN,IZMAX,IPHIZ,IDPH,THIN,
     %    MAXLEP,NLEP,IDLE,LEOR,EELE,XYLE,
     %    ELEMIN,ELEMAX,THINLE,CONSBW,ENGY,GAM,ANGMIN,DXYZ,DT,IRR)
      INCLUDE '@DEBUG'
C PAIR CREATION BY BREIT-WHEELER PROCESS
C  CROSS SECTION FORMULA
C              ds   1  pai*re**2     1       1
C             ----=--*-----------*------*-------
C              dc   4  gamma**2  y1*y2   1-c**2
C         y1,y2 = incident photon energies normalized by beam energy
C
      REAL*4 ZZ(NP,2),EPH(MAXPH,2),XYPH(MAXPH,4,2),ENGY(2),GAM(2)
      INTEGER IPHEL(MAXPH,2),IXYP(MAXPH,2),NPH(2)
      INTEGER IZMM1(2,2),IPHIZ(IZMIN:IZMAX+1,2),IDPH(MAXPH,2)
      REAL*8 Q(NX*NY,2)
      INTEGER IDLE(MAXLEP),LEOR(MAXLEP)
      REAL*4 EELE(MAXLEP),XYLE(MAXLEP,2,2),THINLE(3),DXYZ(3)
      DATA PI2/6.28319/
      DATA EMASS/0.5110034D-3/,NCHKMX/1000/
      DATA NBSTMX/100000/
       DATA INIT/0/
       real*4 ccs,yyg1,yyg2,dum1
CREAL8
      REAL*8 CSPAIR,CS,COSMIN,YM,YP,YB,YG1,YG2,ANGMIN
      REAL*8 SN,ANGCUT
CREAL8
C---
      IF(INIT.EQ.0) THEN
CCC   YMMIN  = 0.5*ELEMIN*(1.-COSMIN)
      SMIN   = (EMASS/ENGY(1))**2
      COSMIN = 1. - 0.5*ANGMIN**2
      YMMIN  = 0.25*ELEMIN*ANGMIN**2
      IF(SMIN.GT.YMMIN)  YMMIN=SMIN
      INIT=1
      ENDIF
C---
      S0=NT
      L1=1
      L2=3-L1
      IF(NPH(L1).LE.0.OR.NPH(L2).LE.0) RETURN
      N11=IPHIZ(IZMM1(1,L1),L1)
      N12=IPHIZ(IZMM1(2,L1)+1,L1)-1
      IF(N12.LT.N11) RETURN
      N21=IPHIZ(IZMM1(1,L2),L2)
      N22=IPHIZ(IZMM1(2,L2)+1,L2)-1
      IF(N22.LT.N21) RETURN
C---
c      write(6,*) 'starting nn1 loop'
      DO 300 NN1=N11,N12
c         if(nn1.eq. 589) then
c           write(6,*) nn1
c         end if
         
      IXYP1=IXYP(NN1,L1)
      IF(IXYP1.LE.0.OR.IXYP1.GT.NX*NY) GOTO 300
      N1 =IDPH(NN1,L1)
      YG1=EPH(N1,L1)
      IF( YG1.LT.SMIN  ) GO TO 300
         DO 310 NN2=N21,N22
         IXYP2=IXYP(NN2,L2)
         IF(IXYP2.LE.0.OR.IXYP2.GT.NX*NY) GOTO 310
C----
         IF(IXYP2.NE.IXYP1) GO TO 310
C----
      N2    = IDPH(NN2,L2)
      YG2   = EPH(N2,L2)
      IF( YG1*YG2.LE.SMIN  ) GO TO 310
      IF(YG1.LT.YMMIN.OR.YG2.LT.YMMIN) GO TO 310
      SL = CONSBW*THINLE(1)/THIN/THIN/YG1/YG2
      if(thinle(1).gt.0.) wgtlep = 1./thinle(1)
CNEW
      M  = IFIX(SL)
      DM = SL - M
      RANNUM = RAN(IRR)
      IF(  DM.GT.RANNUM   ) M = M + 1
      IF(M.LE.0) GO TO 310
CPRT       PRINT *,'**PAIRBW-- NLEP,M=',NLEP,M
CNEW
      NREP=0
  120 NREP=NREP+1
      IF(NLEP+2*M.LE.MAXLEP) GOTO 140
c         if(nn1.eq. 589) then
c           write(6,*) '111'
c         end if
      CALL CPRSLE(NLEP,MAXLEP,LEOR,EELE,XYLE,THINLE,IRR)
      IF(NREP.LE.2) GOTO 120
      WRITE(6,130)
  130 FORMAT(' (SUBR.PAIRBW)   ##### PROGRAM ERROR #####')
      STOP
C---
  140 CONTINUE
C---
      DO 260 I =1, 2*M
CANGCHK       IANCHK = 1
CANGCHK       IF(IANCHK.EQ.1) GO TO 1919
c         if(nn1.eq. 589) then
c           write(6,*) '112'
c         end if

      CS = CSPAIR(IRR,COSMIN)
CCBOOST
      IF(NBOOST.EQ.1) THEN
           CALL CSBOOT(IRR,CS,YG1,YG2,IRTN)
           IF( IRTN.NE.0) GO TO 260
      ENDIF
CCBOOST
C---
       YP = 0.5*ELEMIN*(1.+CS)
       YM = 0.5*ELEMIN*(1.-CS)
       YB = YG2*YP/(YG2-YM)
C-- CHECK  boundaries of photon energies
       IF(YG2.LT.YM.OR.YG1.LT.YB) THEN
       GO TO 260
       ENDIF
C-- CHECK  CM energy
       ENGLE    = 2.*YG1*YG2/( YG1*(1.-CS)+YG2*(1.+CS) )
       IF(ENGLE.LT.ELEMIN.OR.ENGLE.GE.ELEMAX) GO TO 260
CDBG        IF( ENGLE.LT.ELEMIN ) THEN
CDBG        PRINT *,'!!!! ENGLE<ELEMIN IN PAIRBW !!! =',ENGLE,ELEMIN
CDBG        GO TO 260
CDBG        ENDIF
C----
C--minimum angle cut  due to electron mass.
c         if(nn1.eq. 589) then
c           write(6,*) '113'
c         end if

      SN   = 1. - CS**2
      SN   = SQRT( SN )
ccc      ANGCUT = 0.5/GAM(1)/ENGLE
      ANGCUT = ANGBW/GAM(1)/ENGLE
      IF( SN.LE.ANGCUT ) GO TO 260
CPRT       PRINT *,'     M,CS,YG1,YG2=',I,CS,YG1,YG2
C----
C---NOTE !!!!! because  angular distribution should be symmetrical.
      CS = ABS( CS )
CANGCHK 1919  CONTINUE
CANGCHK       ENGLE= ELEMIN + (ELEMAX-ELEMIN)*RAN(IRR)
CANGCHK       CS   = 1.0
CANG100                  CS = 0.995
CANG70                   CS = 0.99755
CANG50                   CS = 0.99875
CANG60                   CS = 0.99820
CANG40                   CS = 0.99920
CANG20                   CS = 0.99980
CANGCHK       IF(ENGLE.LE.0.) THEN
CANGCHK        PRINT *,'!!PAIRBW!!, ELEMIN,ELEMAX,ENGLE=',ELEMIN,ELEMAX,ELEN
CANGCHK       ENDIF
C---
      ccs = cs
      CALL HCUM1('ANBW',CCS,wgtlep)
      dum1 = LOG10(ENGLE)
      CALL HCUM1('EPBW',dum1,wgtlep)
      CALL HCUM1('EPTT',dum1,wgtlep)
      yyg1 = LOG10(yg1)
      yyg2 = LOG10(yg2)
      CALL HCUM2('EGBW',YYG1,YYG2,wgtlep)
C---
c         if(nn1.eq. 589) then
c           write(6,*) '114'
c         end if

      IF(CS.LT.1.) THEN
      SN = SQRT(1.-CS**2)
      PHI= PI2*RAN(IRR)
      XNEW          = ATAN2(SN*COS(PHI),CS)*DT/DXYZ(1)
      YNEW          = ATAN2(SN*SIN(PHI),CS)*DT/DXYZ(2)
      ELSE
      XNEW          = 0.
      YNEW          = 0.
      ENDIF
      NLEP=NLEP+1
      LEOR(NLEP)=1
      IF(I.GT.M) LEOR(NLEP)=-1
      EELE(NLEP)= ENGLE
ccc
      WGTLE(NLEP) = wgtlep
ccc
CPRTST            PRINT *,'!! PAIRBW,  NLEP,ENGLE,SN=',NLEP,ENGLE,SN
      IDLE(NLEP)= IPHEL(N1,L1)
      Z=ZZ(IPHEL(N1,L1),L1)/RTZ+S0
      XYLE(NLEP,1,1)=XYPH(N1,1,L1)+XYPH(N1,2,L1)*Z
      XYLE(NLEP,2,1)=XYPH(N1,2,L1) + XNEW
      XYLE(NLEP,1,2)=XYPH(N1,3,L1)+XYPH(N1,4,L1)*Z
      XYLE(NLEP,2,2)=XYPH(N1,4,L1) + YNEW
CNOKICK               XYLE(NLEP,2,1)= XNEW
CNOKICK               XYLE(NLEP,2,2)= YNEW
CTEST                 XYLE(NLEP,2,1)= XOLD
CTEST                 XYLE(NLEP,2,2)= YOLD
CDBG
ccc       PRINT *,' XNEW,YNEW:PAIRBW    =',XYLE(NLEP,2,1),XYLE(NLEP,2,2)
CDBG
  260 CONTINUE
C---
  310 CONTINUE
  300 CONTINUE
      RETURN
      END











