C   24/06/87 802171135  MEMBER NAME  POIS1D   *.FORT        FORTRAN77   0000
      SUBROUTINE POIS1D(NY,WIDX,DY,Q,EY)                                0000
C  SOLVE 1-DIM POISSON EQUATION                                         0000
C   - LAPLACIAN PHI(Y)= 2*PI*RHO(Y)                                     0000
C     EY(J)=DPHI/DY   AT Y=(J+1/2)*DY    0<=J<=NY.                      0000
C                                                                       0000
      REAL*8 Q(NY,2)                                                    0000
      REAL*4 EY(0:NY,2)                                                 0000
      DATA PI/3.14159 26535 8979E0/                                     0000
C                                                                       0000
      FAC1=2.0*PI*DY/WIDX                                               0000
      DO 300 L=1,2                                                      0000
      EY(0,L)=0                                                         0000
      DO 220 J=1,NY                                                     0000
  220 EY(J,L)=EY(J-1,L)+Q(J,L)                                          0000
      QH=0.5*EY(NY,L)                                                   0000
      DO 240 J=0,NY                                                     0000
  240 EY(J,L)=FAC1*(QH-EY(J,L))                                         0000
  300 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
