C   26/06/87 807191404  MEMBER NAME  PRCESS   *.FORT     M  FORTRAN77   0000
      SUBROUTINE PRCESS(L,NP,NPZ1,NPZ2,SPIN,GAM,ENG,FXY,DX,DY,DT)       0000
C   CLASSICAL SPIN PRECESSION.                                          0000
      REAL*4 SPIN(NP,3),FXY(NP,2),GAM(2)                                0000
      REAL*8 ENG(NP)                                                    0000
      DATA ANOM/1.15965221E-3/                                          0000
      GA0=GAM(L)*ANOM                                                   0000
      IF(L.EQ.2) GA0=-GA0                                               0000
      DXDT=DX/DT                                                        0000
      DYDT=DY/DT                                                        0000
      DO 300 N=NPZ1,NPZ2                                                0000
      GA=GA0*ENG(N)                                                     0000
      TY=-GA*FXY(N,1)*DXDT                                              0000
      TX=+GA*FXY(N,2)*DYDT                                              0000
      TX2=TX**2                                                         0000
      TY2=TY**2                                                         0000
      T2=TX2+TY2                                                        0000
      IF(T2.LE.1E-20) GOTO 300                                          0000
      TH=0.5*SQRT(T2)                                                   0000
      STH=SIN(TH)                                                       0000
      CTH=COS(TH)                                                       0000
      STH1=STH/TH                                                       0000
      STH2=0.5*STH1**2                                                  0000
      R11=1.0-TY2*STH2                                                  0000
      R22=1.0-TX2*STH2                                                  0000
      R13=TY*CTH*STH1                                                   0000
      R32=TX*CTH*STH1                                                   0000
      R21=TX*TY*STH2                                                    0000
      R33=1.0-2.0*STH**2                                                0000
      SX1=R11*SPIN(N,1)-R21*SPIN(N,2)+R13*SPIN(N,3)                     0000
      SY1=R21*SPIN(N,1)+R22*SPIN(N,2)-R32*SPIN(N,3)                     0000
      SPIN(N,3)=-R13*SPIN(N,1)+R32*SPIN(N,2)+R33*SPIN(N,3)              0000
      SPIN(N,1)=SX1                                                     0000
      SPIN(N,2)=SY1                                                     0000
  300 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
