C   02/09/87 808251615  MEMBER NAME  PROFIL   *.FORT        FORTRAN77   0000
      SUBROUTINE PROFIL(LPROFL,XY,ZZ,NP,NT,SIG,DXYZ,DT,IR,IZ)           0000
      PARAMETER (MR=100,MZ=20)                                          0000
      INCLUDE '@CHARCM'
      DIMENSION RHO(MR,MZ),R(MR),Z(MZ)                                  0000
      DIMENSION XY(NP,2),ZZ(NP),IR(NP),IZ(NP),SIG(3),DXYZ(3)            0000
      DIMENSION SCAL(14)                                                0000
      CHARACTER*100 TTL                                                 0000
      CHARACTER*1 LXY(2)/'X','Y'/                                       0000
      CHARACTER*4 IDPL                                                  0000
      DATA PI/3.14159 26535 89793E0/                                    0000
C                                                                       0000
      CALL DPSLCT(DEVNAM(2))                                            0000
      IF(LPROFL.GE.1) GOTO 500                                          0000
      RMAX=2.5                                                          0000
      DRA=RMAX/MR                                                       0000
      ZMAX=2.5                                                          0000
      DZA=2*ZMAX/MZ                                                     0000
      DX1=DXYZ(1)/SIG(1)/DRA                                            0000
      DY1=DXYZ(2)/SIG(2)/DRA                                            0000
      DZ1=DXYZ(3)/SIG(3)/DZA                                            0000
      Z0=-0.5*(MZ-1)*DZA                                                0000
      Z00=-0.5*(MZ-1)/DZ1                                               0000
C       Z0=CENTER OF THE LOWEST BIN                                     0000
      DO 200 N=1,NP                                                     0000
      IR(N)=INT(SQRT((XY(N,1)*DX1)**2+(XY(N,2)*DY1)**2))+1              0000
  200 IZ(N)=NINT((ZZ(N)-Z00)*DZ1)                                       0000
      CALL CLEAR(RHO,MR*MZ)                                             0000
      DO 240 I=1,MR                                                     0000
  240 R(I)=(I-0.5)*DRA                                                  0000
      DO 260 J=1,MZ                                                     0000
  260 Z(J)=Z0+(J-1)*DZA                                                 0000
      NP1=0                                                             0000
      DO 280 N=1,NP                                                     0000
      IF(IR(N).GT.MR.OR.IZ(N).LE.0.OR.IZ(N).GT.MZ) GOTO 280             0000
      RHO(IR(N),IZ(N))=RHO(IR(N),IZ(N))+1.0                             0000
      NP1=NP1+1                                                         0000
  280 CONTINUE                                                          0000
      FAC=1.0/(2.0*PI*NP*DRA**2*DZA)                                    0000
      DO 300 I=1,MR                                                     0000
      FAC1=FAC/(I-0.5)                                                  0000
      DO 300 J=1,MZ                                                     0000
  300 RHO(I,J)=FAC1*RHO(I,J)                                            0000
      WRITE(TTL,320) NT*DT/SIG(3)                                       0000
  320 FORMAT('PARTICLE DENSITY AT T=',F6.3,';R/SIGX;Z/SIGZ@')           0000
      CALL DOPT('XAUTO',0)                                              0000
      CALL DOPT('Y2AUTO',0)                                             0000
      CALL DOPT('ZAUTO',1)                                              0000
      CALL DOPT('ERROR',0)                                              0000
      SCAL(1)=0                                                         0000
      SCAL(2)=0.5                                                       0000
      SCAL(3)=5                                                         0000
      SCAL(4)=0                                                         0000
      SCAL(5)=-2.5                                                      0000
      SCAL(6)=1.0                                                       0000
      SCAL(7)=5                                                         0000
      SCAL(8)=0                                                         0000
      CALL DUT2A(R,Z,RHO,DUMMY,MR,MZ,TTL,SCAL)                          0000
      CALL DOPT('XAUTO',1)                                              0000
      CALL DOPT('Y2AUTO',1)                                             0000
      WRITE(6,360) NT,NP1                                               0000
  360 FORMAT(20X,'(SUBR.PROFIL) PROFILE DRAWN AT NT=',I5,' # OF ',      0000
     %  'PARTICLES =',I6)                                               0000
      RETURN                                                            0000
  500 IXY=1                                                             0000
      IF(LPROFL.GE.2) IXY=2                                             0000
      XMAX=2.5                                                          0000
      XMIN=-XMAX                                                        0000
      NNX=40                                                            0000
      ZMAX=2.5                                                          0000
      ZMIN=-ZMAX                                                        0000
      NNZ=20                                                            0000
      XW=(XMAX-XMIN)/NNX                                                0000
      ZW=(ZMAX-ZMIN)/NNZ                                                0000
      WRITE(TTL,520) LXY(IXY),NT*DT/SIG(3),LXY(IXY),LXY(IXY)            0000
  520 FORMAT('PROJECTION ONTO ',A1,'-PLANE AT T=',F6.3,';Z/SIGZ;',A1,   0000
     %  '/SIG',A1,'@')                                                  0000
      IDPL='PRFL'                                                       0000
      CALL HDEF2(IDPL,'E*4S',NNZ,NNX,ZMIN,XMIN,ZW,XW,TTL)               0000
      FACX=DXYZ(IXY)/SIG(IXY)                                           0000
      FACZ=DXYZ(3)/SIG(3)                                               0000
      DO 600 N=1,NP                                                     0000
      X1=XY(N,IXY)*FACX                                                 0000
      IF(X1.LE.XMIN.OR.X1.GE.XMAX) GOTO 600                             0000
      Z1=Z(N)*FACZ                                                      0000
      IF(Z1.LE.ZMIN.OR.Z1.GE.ZMAX) GOTO 600                             0000
      CALL HCUM2(IDPL,Z1,X1,1.0)                                        0000
  600 CONTINUE                                                          0000
C        ISOMETRIC PLOT (2-DIM HISTOGRAM)                               0000
          CALL HOPTN('ISOMETRIC',1,IDPL)                                0000
          CALL DOPT('ROTANG',-40.0)                                     0000
          CALL DOPT('ELVANG',40.0)                                      0000
          CALL HOUT(IDPL)                                               0000
          CALL HOPTN('ISOMETRIC',0,IDPL)                                0000
          CALL DOPT('RES,ROTANG')                                       0000
          CALL DOPT('RES,ELVANG')                                       0000
      CALL HDEL(IDPL)                                                   0000
      RETURN                                                            0000
      END                                                               0000
