C   07/08/87 807191424  MEMBER NAME  THEORY   *.FORT        FORTRAN77   0000
      SUBROUTINE THEORY(AN,SIG,GAM,GZI0,AVNPH,DEAV,DERMS,DSAV,DSRMS)    0000
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 AN(2),SIG(3,2),GAM(2)
      REAL*8 AVNPH(2,5),DEAV(2,5),DERMS(2,5),DSAV(2,5),DSRMS(2,5)                      
      REAL*8 UQRAD,GZI1,GZI0(2)                                              
      DATA ELR/2.817938E-15/,PI/3.14159 26535 8979E0/                   0000
C------ THEORETICAL PREDICTIONS ------                                  0000
      FSC=1.0/137.03604E0                                               0000
      DO 300 L=1,2                                                      0000
C  BESSETTI'S FORMULA                                                   0000
      L2=3-L                                                            0000
      RATIO=SIG(1,L2)/SIG(2,L2)                                         0000
      IF(SIG(1,L2).LT.SIG(2,L2)) RATIO=1.0/RATIO                        0000
      PBAS=3.0/RATIO**4-10.0/RATIO**2+3.0                               0000
      QBAS=3.0/RATIO**2+8.0/RATIO+3.0                                   0000
      FBAS=SQRT(ABS(PBAS))/QBAS                                         0000
      IF(PBAS.GE.0.0) FBAS=2.0*ATAN(FBAS)                               0000
      IF(PBAS.LT.0.0) FBAS=LOG((1.0+FBAS)/(1.0-FBAS))                   0000
      FBAS=4.0/(RATIO*SQRT(PI*ABS(PBAS)))*FBAS                          0000
      FAC=2.0/3.0*ELR**3*GAM(L)*FBAS/(SIG(1,L2)*SIG(2,L2)*SIG(3,L2))    0000
      DEAV(L,2)=FAC*AN(L2)**2                                           0000
C (KY, KEK PREPRINT 85-53)                                              0000
C       (USE ELLIPTIC CYLINDER FORM FACTOR FOR GAUSSIAN BEAM)           0000
      FMFC=2.0*SQRT(RATIO)/(1.0+RATIO)                                  0000
      SIGXY=SQRT(SIG(1,L2)*SIG(2,L2))                                   0000
C   SEMICLASSICAL                                                       0000
      FACA=FMFC*FSC*ELR*AN(L2)/SIGXY                                    0000
      FACB=FMFC**2*ELR**3*AN(L2)**2*GAM(L)/(SIGXY**2*SIG(3,L2))         0000
      FACC=FACB**2/FACA                                                 0000
      AVNPH(L,3)=1.0597*FACA                                            0000
      DEAV(L,3)=0.2164*FACB                                             0000
      DERMS(L,3)=SQRT(0.007675*FACB**2+0.2267*FACC)                     0000
      DSAV(L,3)=2.0*0.08860*FACB                                        0000
      DSRMS(L,3)=2.0*SQRT(0.004635*FACB**2+0.04390*FACC)                0000
C   EXTREME QUANTUM                                                     0000
      FACQ=FMFC**2*FSC**4*ELR*AN(L2)**2*SIG(3,L2)/(GAM(L)*SIGXY**2)     0000
      FACQ3=FACQ**(1.0/3.0)                                             0000
      GZI0(L)=2.0/3.0*ELR**2*GAM(L)*AN(L2)*FMFC/(FSC*SIG(3,L2)*SIGXY)   0000
      AVNPH(L,4)=1.554*FACQ3                                            0000
      DEAV(L,4)=0.395*FACQ3                                             0000
      DERMS(L,4)=SQRT(0.00582*FACQ3**2+0.243*FACQ3)                     0000
      DSAV(L,4)=2.0*0.181*FACQ3                                         0000
      DSRMS(L,4)=2.0*SQRT(0.00656*FACQ3**2+0.0556*FACQ3)                0000
C   INTERPOLATION FORMULA                                               0000
      GZI1=GZI0(L)                                                      0000
      U0=UQRAD(0,GZI1)                                                  0000
      U1=UQRAD(1,GZI1)                                                  0000
      U2=UQRAD(2,GZI1)                                                  0000
      FACA=FACA*U0                                                      0000
      FACB=FACB*U1                                                      0000
      FACC=FACC*U2 
      AVNPH(L,5)=1.0597*FACA                                            0000
      DEAV(L,5)=0.2164*FACB                                             0000
      DERMS(L,5)=SQRT(0.007675*FACB**2+0.2267*FACC)                     0000
      DSAV(L,5)=2.0*0.08860*FACB                                        0000
      DSRMS(L,5)=2.0*SQRT(0.004635*FACB**2+0.04390*FACC)                0000
  300 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
