F77	      = f90
FC	      = f90
#F77FLAGS      = +ppu -K -g -C +T +E1 +FPVZOUID
#F77FLAGS      = -O  -K +ppu +E1
#F77FLAGS	= -g -K +ppu +E1

LD	      =  f90

#LDFLAGS	      = +ppu -K -g -C +T +E1 +FPVZOUID 
#LDFLAGS       = -O  -K +ppu +E1
#LDFLAGS       = -lU77

UT1DIR         = /cern/pro/lib
#UT1DIR         = /cern/95a/lib
#UT1DIR         = /net/kiwifs/public/hpux10/cern/pro/lib
UT1LIB	       = -L$(UT1DIR) \
		 -lpawlib -lgraflib -lgrafX11  -lpacklib -lkernlib -lmathlib\
                 -lpacklib 
# -lgenlib 

USRDIR 	= -L/lib/pa1.1
USRLIB  = -lm
#USRDIR 	= 

LIBS	      = $(UT1LIB)

OBJS	      = angmax.o \
		avr4.o \
		avrg4.o \
		avrg8.o \
		avsq4.o \
		back.o \
		bprfl.o \
		brems.o \
		cbrt.o \
		cftr2.o \
		cftrv.o \
		chpack.o \
		clear.o \
		clear8.o \
		clock.o \
		clock1.o \
		cmpt2r.o \
		cmptn1.o \
		cmptn2.o \
		cmptn3.o \
		cmptx1.o \
		cmptx2.o \
		cmptx3.o \
		cmpty1.o \
		cmptz1.o \
		coulmb.o \
		cprsle.o \
		cprsph.o \
		cputrm.o \
		csboot.o \
		cspair.o \
		cwerf.o \
		date.o \
		date1.o \
		distri.o \
		distrr.o \
		dlb2m.o \
		dopt.o \
		dpclos.o \
		dpslct.o \
		drift.o \
		dsort2.o \
		dstrip.o \
		dstrrp.o \
		dut1.o \
		dut2.o \
		dut2a.o \
		egvrtl.o \
		eqm.o \
		eqm1d.o \
		eqmfl.o \
		eqmlep.o \
		eqmr.o \
		eqmx.o \
		fespec.o \
		fitee.o \
		fites.o \
		fitpe.o \
		flout.o \
		fncvrt.o \
		fourie.o \
		fxygau.o \
		gaussn.o \
		hcum1.o \
		hcum2.o \
		hdef1.o \
		hdef2.o \
		hdel.o \
		hete.o \
		hetp.o \
		hget.o \
		hinit.o \
		hoptn.o \
		hout.o \
		hpk000.o \
		hpntr.o \
		hx.o \
		hy.o \
		init1.o \
		init2.o \
		initts.o \
		kernel.o \
		kick.o \
		lumcor.o \
		luminr.o \
		lumint.o \
		main.ccjlc.o \
		pairbh.o \
		pairbw.o \
		pairll.o \
		phider.o \
		plavy.o \
		plenht.o \
		plenhz.o \
		pllean.o \
		plthpk.o \
		plzbsz.o \
		pntfil.o \
		pois1d.o \
		poisfl.o \
		poisnf.o \
		poissn.o \
		potmat.o \
		prcess.o \
		prfld.o \
		prlep.o \
		profil.o \
		prpol.o \
		prtime.o \
		qmxyex.o \
		qtvrtl.o \
		radlos.o \
		ran.o \
		rlins3.o \
		round.o \
		rptail.o \
		rsort2.o \
		setpnt.o \
		shis2r.o \
		shist1.o \
		shist2.o \
		shist3.o \
		shisx1.o \
		shisx2.o \
		shisy1.o \
		shisz1.o \
		subpos.o \
		tdhead.o \
		tdmult.o \
		tdsctp.o \
		theor2.o \
		theory.o \
		tstplt.o \
		tstraj.o \
		tstxxx.o \
		ugfont.o \
		upsloc.o \
		uqrad.o \
		uvzero.o \
		varlst.o \
		secnds.o

PRINT	      = pr

PROGRAM       = abel.exe

SHELL	      = /bin/sh

SRCS	      = angmax.f \
		avr4.f \
		avrg4.f \
		avrg8.f \
		avsq4.f \
		back.f \
		bprfl.f \
		brems.f \
		cbrt.f \
		cftr2.f \
		cftrv.f \
		chpack.f \
		clear.f \
		clear8.f \
		clock.f \
		clock1.f \
		cmpt2r.f \
		cmptn1.f \
		cmptn2.f \
		cmptn3.f \
		cmptx1.f \
		cmptx2.f \
		cmptx3.f \
		cmpty1.f \
		cmptz1.f \
		coulmb.f \
		cprsle.f \
		cprsph.f \
		cputrm.f \
		csboot.f \
		cspair.f \
		cwerf.f \
		date.f \
		date1.f \
		distri.f \
		distrr.f \
		dlb2m.f \
		dopt.f \
		dpclos.f \
		dpslct.f \
		drift.f \
		dsort2.f \
		dstrip.f \
		dstrrp.f \
		dut1.f \
		dut2.f \
		dut2a.f \
		egvrtl.f \
		eqm.f \
		eqm1d.f \
		eqmfl.f \
		eqmlep.f \
		eqmr.f \
		eqmx.f \
		fespec.f \
		fitee.f \
		fites.f \
		fitpe.f \
		flout.f \
		fncvrt.f \
		fourie.f \
		fxygau.f \
		gaussn.f \
		hcum1.f \
		hcum2.f \
		hdef1.f \
		hdef2.f \
		hdel.f \
		hete.f \
		hetp.f \
		hget.f \
		hinit.f \
		hoptn.f \
		hout.f \
		hpk000.f \
		hpntr.f \
		hx.f \
		hy.f \
		init1.f \
		init2.f \
		initts.f \
		kernel.f \
		kick.f \
		lumcor.f \
		luminr.f \
		lumint.f \
		main.ccjlc.f \
		pairbh.f \
		pairbw.f \
		pairll.f \
		phider.f \
		plavy.f \
		plenht.f \
		plenhz.f \
		pllean.f \
		plthpk.f \
		plzbsz.f \
		pntfil.f \
		pois1d.f \
		poisfl.f \
		poisnf.f \
		poissn.f \
		potmat.f \
		prcess.f \
		prfld.f \
		prlep.f \
		profil.f \
		prpol.f \
		prtime.f \
		qmxyex.f \
		qtvrtl.f \
		radlos.f \
		ran.f \
		rlins3.f \
		round.f \
		rptail.f \
		rsort2.f \
		setpnt.f \
		shis2r.f \
		shist1.f \
		shist2.f \
		shist3.f \
		shisx1.f \
		shisx2.f \
		shisy1.f \
		shisz1.f \
		subpos.f \
		tdhead.f \
		tdmult.f \
		tdsctp.f \
		theor2.f \
		theory.f \
		tstplt.f \
		tstraj.f \
		tstxxx.f \
		ugfont.f \
		upsloc.f \
		uqrad.f \
		uvzero.f \
		varlst.f \
		secnds.c


SYSHDRS	      =

#.f.o:
#	$(F77) -c $(F77FLAGS) $<

all:		$(PROGRAM)

$(PROGRAM):     $(OBJS)
		@echo "Linking $(PROGRAM) ..."
		$(F77) $(LDFLAGS) $(OBJS) -Wl,$(LIBS) -Wl,$(USRDIR) -lm -o $(PROGRAM)
		@echo "done"

clean:;		@rm -f $(OBJS) core

clobber:;	@rm -f $(OBJS) $(PROGRAM) core tags

depend:;	@mkmf -f $(MAKEFILE) ROOT=$(ROOT)

echo:;		@echo $(HDRS) $(SRCS)

index:;		@ctags -wx $(HDRS) $(SRCS)

install:	$(PROGRAM)
		@echo Installing $(PROGRAM) in $(DEST)
		@-strip $(PROGRAM)
		@if [ $(DEST) != . ]; then \
		(rm -f $(DEST)/$(PROGRAM); $(INSTALL) -f $(DEST) $(PROGRAM)); fi

print:;		@$(PRINT) $(HDRS) $(SRCS)

tags:           $(HDRS) $(SRCS); @ctags $(HDRS) $(SRCS)

update:		$(DEST)/$(PROGRAM)

$(DEST)/$(PROGRAM): $(SRCS) $(LIBS) $(HDRS) $(EXTHDRS)
		@$(MAKE) -f $(MAKEFILE) ROOT=$(ROOT) DEST=$(DEST) install
###
bprfl.o: @TDCOM
cmpt2r.o: @SHISCM
cmptn2.o: @SHISCM
cmptn3.o: @SHISCM @CHARCM
cmptx1.o: @SHISCM
cmptx2.o: @SHISCM
cmptx3.o: @SHISCM
cmpty1.o: @WORKCM @PNTRCM @SHISCM
cmptz1.o: @WORKCM @PNTRCM @SHISCM
cprsph.o: @PHOTCM
fitee.o: @FITCOM
fites.o: @FITCOM
fitpe.o: @PHOTCM @FITCOM
flout.o: @CHARCM @DEBUG
hcum1.o: @HISTID
hcum2.o: @HISTID
hdef1.o: @HISTID
hdef2.o: @HISTID
hdel.o: @HISTID
hete.o: @FITCOM
hetp.o: @FITCOM
hout.o: @HISTID
hpk000.o: @HCOM
hpntr.o: @HISTID
main.ccjlc.o: @WORKCM @DEBUG @PNTRCM @BBCOM @PHOTCM @PLTCOM @SHISCM @CHARCM @TDCOM \
	@NAMELIST
pairbh.o: @DEBUG
pairbw.o: @DEBUG
pairll.o: @DEBUG
plavy.o: @TDCOM
plenht.o: @TDCOM
plenhz.o: @TDCOM
plthpk.o: @CHARCM
plzbsz.o: @CHARCM @TDCOM
prfld.o: @BBCOM
prlep.o: @TDCOM
profil.o: @CHARCM
radlos.o: @BBCOM @PHOTCM
shis2r.o: @SHISCM
shist2.o: @SHISCM
shist3.o: @SHISCM @CHARCM
shisx1.o: @SHISCM
shisx2.o: @SHISCM
shisy1.o: @WORKCM @PNTRCM @SHISCM
shisz1.o: @WORKCM @PNTRCM @SHISCM
tdhead.o: @CHARCM @TDCOM
tdmult.o: @TDCOM
tstplt.o: @BBCOM @TDCOM
tstraj.o: @BBCOM
tstxxx.o: @CHARCM
