C   14/04/87 708041839  MEMBER NAME  AVRG4    *.FORT        FORTRAN77   
C******************** AVRG4 ********************************************
      SUBROUTINE AVRG4(X,N,A)                                           
C CALCULATE THE MINIMUM, MAXIMUM, AVERAGE AND RMS OF REAL*4 ARRAY       
C (X(I),I=1,N) AND STORE THEM IN A.                                     
C TO AVOID THE LOSS OF DIGITS, REAL*8 VARIABLES ARE USED INTERNALLY.    
      IMPLICIT REAL*8 ( A-H, O-Z)
      REAL*4 X(N),A(4)                                                  
      REAL*16 A3,A4                                                      
      IF(N.LE.0) RETURN                                                 
      A1=X(1)                                                           
      A2=X(1)                                                           
      A3=0                                                              
      A4=0                                                              
      DO 120 I=1,N
      XX = X(I)                                                      
      A1=MIN(A1,XX)                                                   
      A2=MAX(A2,XX)                                                   
      A3=A3+X(I)                                                        
  120 A4=A4+X(I)**2                                                     
      A3=A3/N                                                           
      A4=A4/N                                                           
      A(1)=A1                                                           
      A(2)=A2                                                           
      A(3)=A3
      AA43=A4-A3**2                                                         
      A(4)=SQRT(MAX(0.D0,AA43))                                      
cc      A(4)=SQRT(MAX(0D0,A4-A3**2))                                      
      RETURN                                                            
      END                                                               
