C   24/06/87 910030929  MEMBER NAME  DISTRI   *.FORT        FORTRAN77   0000
      SUBROUTINE DISTRI(KFLD,NP,NX,NY,MMOM,LSHIST,MSQ,NOUT1,LUPDWN,     0000
     %                  NPZ,NPZ0,BLEND,IXY,IXM,IYM,                     0000
     %                  XY0,Q,QE,ENG,NSQ,ISQN,ISQK,ISC,                 0000
     %                  LSPIN,SPIN,POLZ)                                0000
C CHARGE DISTRIBUTION IN RECTANGULAR CELLS.                             0000
C  THE CELLS ARE SPECIFIED BY (I,J)  (1<=I<=NX, 1<=J<=NY).              0000
C  (BLEND(1),BLEND(2)) IS THE COORDINATE OF THE CENTER OF THE           0000
C  CELL AT BOTTOM-LEFT CORNER (1,1).  THE CENTER OF THE (I,J)-TH        0000
C  CELL IS  X=BLEND(1)+(I-1), Y=BLEND(2)+(J-1).                         0000
C  1-DIM INDEX OF CELLS:  IXY=I+NX*(J-1)                                0000
C                                                                       0000
      INTEGER NPZ(2),NPZ0(2),IXM(2,2),IYM(2,2),LSPIN(2),NOUT1(2)        0000
      REAL*4 BLEND(2)                                                   0000
      REAL*4 XY0(NP,2,2),SPIN(NP,3,*),POLZ(NX*NY,*)                     0000
      INTEGER IXY(NP,2)                                                 0000
      INTEGER ISQN(MSQ,2),ISQK(MSQ,2),ISC(NX*NY,2),NSQ(2)               0000
      REAL*8 Q(NX*NY,2),QE(NX*NY,2,MMOM),ENG(NP,2),E1                   0000
C                                                                       0000
C--- CLEAR                                                              0000
      NOUT1(1)=0                                                        0000
      NOUT1(2)=0                                                        0000
CZERO       CALL CLEAR(Q,NX*NY*2*2)                                     0000
      CALL UVZERO(NX*NY*2*2,Q)                                          0000
CZERO       IF(LSHIST.GE.0) CALL CLEAR(QE,NX*NY*2*MMOM*2)
      IF(LSHIST.GE.0) CALL UVZERO(NX*NY*2*MMOM*2,QE)                    0000
      IF(LSHIST.GE.1) THEN                                              0000
          NSQ(1)=0                                                      0000
          NSQ(2)=0                                                      0000
CZERO           CALL CLEAR(ISQN,MSQ*2)
CZERO           CALL CLEAR(ISQK,MSQ*2)
CZERO           CALL CLEAR(ISC,NX*NY*2)
          CALL UVZERO(MSQ*2,ISQN)                                       0000
          CALL UVZERO(MSQ*2,ISQK)                                       0000
          CALL UVZERO(NX*NY*2,ISC)                                      0000
        ENDIF                                                           0000
C---PIC:PARTICLES IN CELLS                                              0000
      DO 400 L=1,2                                                      0000
      IF(KFLD.EQ.4) GOTO 230                                            0000
*VOPTION VEC(NOFVAL)                                                    0000
      DO 220 N=NPZ0(L),NPZ(L)                                           0000
      IX=NINT(XY0(N,1,L)-BLEND(1))                                      0000
      IY=NINT(XY0(N,2,L)-BLEND(2))                                      0000
      IF(IX.LT.0.OR.IX.GE.NX) THEN                                      0000
          IXY(N,L)=0                                                    0000
        ELSE                                                            0000
          IXY(N,L)=IX+1+NX*IY                                           0000
          IF(IY.LT.0) IXY(N,L)=-(IX+1)                                  0000
          IF(IY.GE.NY) IXY(N,L)=-(IX+1+NX*NY)                           0000
C              PARTICLES OUT OF VERTICAL MESH CAN BE TREATED IN A       0000
C              DIFFERENT WAY IF KFLD=3.                                 0000
        ENDIF                                                           0000
  220 CONTINUE                                                          0000
      GOTO 260                                                          0000
*VOPTION VEC(NOFVAL)                                                    0000
  230 DO 240 N=NPZ0(L),NPZ(L)                                           0000
      IY=NINT(XY0(N,2,L)-BLEND(2))                                      0000
      IXY(N,L)=IY+1                                                     0000
      IF(IY.LT.0) IXY(N,L)=-1                                           0000
      IF(IY.GE.NY) IXY(N,L)=-(1+NY)                                     0000
  240 CONTINUE                                                          0000
  260 DO 270 N=NPZ0(L),NPZ(L)                                           0000
      II=IXY(N,L)                                                       0000
      IF(II.GT.0) THEN                                                  0000
          Q(II,L)=Q(II,L)+1D0                                           0000
        ELSE                                                            0000
          NOUT1(L)=NOUT1(L)+1                                           0000
        ENDIF                                                           0000
  270 CONTINUE                                                          0000
      IF(LUPDWN.NE.0) THEN                                              0000
          DO 286 I=1,NX                                                 0000
          I2=2*I+NX*NY-NX                                               0000
          IJ2=I+NX*(NY/2-1)                                             0000
          DO 282 IJ=I,IJ2,NX                                            0000
          IJ1=I2-IJ                                                     0000
          Q(IJ,L)=0.5D0*(Q(IJ,L)+Q(IJ1,L))                              0000
  282     Q(IJ1,L)=Q(IJ,L)                                              0000
  286     CONTINUE                                                      0000
        ENDIF                                                           0000
      IF(LSHIST.GE.0) THEN                                              0000
          DO 300 N=NPZ0(L),NPZ(L)                                       0000
          II=IXY(N,L)                                                   0000
          IF(II.LE.0) GOTO 300                                          0000
          E1=1D0                                                        0000
*VOPTION NOVEC                                                          0000
          DO 290 IM=1,MMOM                                              0000
          E1=E1*ENG(N,L)                                                0000
  290     QE(II,L,IM)=QE(II,L,IM)+E1                                    0000
  300     CONTINUE                                                      0000
        ENDIF                                                           0000
      LS=LSPIN(L)                                                       0000
      IF(LS.NE.0) THEN                                                  0000
CZERO           CALL CLEAR(POLZ(1,LS),NX*NY)
                CALL UVZERO(NX*NY,POLZ(1,LS))
          DO 320 N=NPZ0(L),NPZ(L)                                       0000
          II=IXY(N,L)                                                   0000
  320     IF(II.GT.0) POLZ(II,LS)=POLZ(II,LS)+SPIN(N,3,LS)              0000
        ENDIF                                                           0000
      IF(LSHIST.GE.1) CALL SHIST1(IXY(1,L),NPZ0(L),NPZ(L),NSQ(L),       0000
     %     MSQ,ISQN(1,L),ISQK(1,L),NX*NY,ISC(1,L),LSHIST)               0000
  400 CONTINUE                                                          0000
C--- FIND NON-EMPTY CELL RANGE                                          0001
      IF(KFLD.EQ.4) GOTO 700                                            0001
      DO 600 L=1,2                                                      0001
      DO 510 I=1,NX                                                     0001
      DO 510 J=1,NY                                                     0001
  510 IF(Q(I+NX*(J-1),L).GT.0) GOTO 520                                 0001
      I=NX                                                              0001
  520 IXM(1,L)=I                                                        0001
      DO 530 I=NX,1,-1                                                  0001
      DO 530 J=1,NY                                                     0001
  530 IF(Q(I+NX*(J-1),L).GT.0) GOTO 540                                 0001
      I=1                                                               0001
  540 IXM(2,L)=I                                                        0001
      DO 550 J=1,NY                                                     0001
      DO 550 I=1,NX                                                     0001
  550 IF(Q(I+NX*(J-1),L).GT.0) GOTO 560                                 0001
      J=NY                                                              0001
  560 IYM(1,L)=J                                                        0001
      DO 570 J=NY,1,-1                                                  0001
      DO 570 I=1,NX                                                     0001
  570 IF(Q(I+NX*(J-1),L).GT.0) GOTO 580                                 0001
      J=1                                                               0001
  580 IYM(2,L)=J                                                        0001
  600 CONTINUE                                                          0001
      RETURN                                                            0001
C                                                                       0001
  700 DO 800 L=1,2                                                      0001
      IXM(1,L)=1                                                        0001
      IXM(2,L)=1                                                        0001
      DO 750 J=1,NY                                                     0001
  750 IF(Q(J,L).GT.0) GOTO 760                                          0001
      J=NY                                                              0001
  760 IYM(1,L)=J                                                        0001
      DO 770 J=NY,1,-1                                                  0001
  770 IF(Q(J,L).GT.0) GOTO 780                                          0001
      J=1                                                               0001
  780 IYM(2,L)=J                                                        0001
  800 CONTINUE                                                          0001
      RETURN                                                            0001
      END                                                               0001
