C   14/04/87 706021359  MEMBER NAME  GAUSSN   *.FORT     M  FORTRAN77   0000
C******************** GAUSSN *******************************************0000
      SUBROUTINE GAUSSN(IRG,X,N)                                        0000
C  GENERATE GAUSSIAN RANDUM DEVIATES WITH ZERO MEAN AND UNIT S.D.       0000
C  USE INVERSE OF INTEGRATED NORMAL DISTRIBUTION FUNCTION.              0000
C   INPUT: IRG=ODD INTEGER                                              0000
C   OUTPUT: (X(I),I=1,N)  RANDUM DEVIATES. R*4. 
      IMPLICIT REAL*8 (A-H,O-Z)                        
      REAL*4 X(N)                                                    
C                                                                       0000
      DO 100 I=1,N                                                      0000
      IRG=48828125*IRG                                                  0000
      IGA=ABS(IRG)                                                      0000
      IF(IGA.GE.1288490189) GOTO 20                                     0000
      Y=FLOAT(IRG)                                                      0000
      YY=Y*Y                                                            0000
      X(I)=((6.55046498402D-48*YY+3.06310057134D-29)*YY                 0000
     %            +5.84190096639D-10)*Y                                 0000
      GOTO 100                                                          0000
   20 IF(IGA.GE.1997159793) GOTO 40                                     0000
      Y=FLOAT(IGA)                                                      0000
      X(I)=((2.15247545000D9-Y)*Y+5.13646191373D17)                     0000
     %  /((0.448498722421D0*Y-3.55927532674D9)*Y+5.77424700846D18)      0000
      GOTO 80                                                           0000
   40 IF(IGA.GE.2126008812) GOTO 60                                     0000
      Y=FLOAT(IGA)                                                      0000
      X(I)=((Y-5.53451026774D9)*Y+7.30305470154D18)                     0000
     %  /((1.68096862343D0*Y-7.78160540942D9)*Y+8.96788425914D18)       0000
      GOTO 80                                                           0000
   60 T=SQRT(-LOG((2.3283064365387D-10*                                 0000
     %      FLOAT(-IGA-(-2147483647)-(-1)))**2))                        0000
C    %      FLOAT(-IGA-(-2147483648)))**2))                             0000
      X(I)=T-(T+7.0309866D0)/((0.18604881D0*T+3.0556532D0)*T            0000
     %                    +3.2217897D0)                                 0000
   80 IF(IRG.LE.0) X(I)=-X(I)                                           0000
  100 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
