C   25/02/88 909281423  MEMBER NAME  PLZBSZ   *.FORT        FORTRAN77   0000
      SUBROUTINE PLZBSZ(KK,NT,MT1,MT,LZBSZ,DBBSZ,DBBSZ0,DT0,            0000
     %    ZBSZ,NZBSZ,BSZ,IZBSZ,NPIZ,IZMIN,IZMAX,                        0000
     %    XY0,NP,IXY,QBSZ,NBBSZ)                                        0000
      INCLUDE '@CHARCM'
      INCLUDE '@TDCOM'
      REAL*4 QBSZ(NBBSZ)                                                0000
      REAL*4 XY0(NP,2),BSZ(MT1:MT+MT1-1,NZBSZ,2),ZBSZ(NZBSZ)            0000
      INTEGER IXY(NP),IZBSZ(2,NZBSZ),NPIZ(IZMIN:IZMAX+1,2)              0000
      CHARACTER*1 LXYR(3)/'X','Y','R'/                                  0000
      CHARACTER*4 CHWORK                                                0000
      DATA RTPI/1.77245385E0/                                           0000
C                                                                       0000
      IBEAM=1                                                           0000
      IBSZ=MOD(LZBSZ,10)                                                0000
      IDEST=LZBSZ/10                                                    0000
      IF(KK.NE.0) GOTO 500                                              0000
      XY00=-0.5*(NBBSZ+1)*DBBSZ0                                        0000
      DO 400 J=1,NZBSZ                                                  0000
      N1=NPIZ(IZBSZ(1,J),IBEAM)                                         0000
      N2=NPIZ(IZBSZ(2,J)+1,IBEAM)-1                                     0000
      CN=N2-N1+1                                                        0000
      SUM1=0                                                            0000
      SUM2=0                                                            0000
      CALL CLEAR(QBSZ,NBBSZ)                                            0000
      IF(IBSZ.EQ.3) THEN                                                0000
          DO 200 N=N1,N2                                                0000
          RSQ=XY0(N,1)**2+XY0(N,2)**2                                   0000
          SUM1=SUM1+RSQ                                                 0000
  200     IXY(N)=INT(SQRT(RSQ)/DBBSZ0)+1                                0000
          SUM1=SUM1/2.0                                                 0000
        ELSE                                                            0000
          DO 210 N=N1,N2                                                0000
          SUM1=SUM1+XY0(N,IBSZ)**2                                      0000
  210     IXY(N)=INT((XY0(N,IBSZ)-XY00)/DBBSZ0)                         0000
        ENDIF                                                           0000
      BSZ(NT,J,1)=SQRT(SUM1/CN)*DBBSZ/DBBSZ0                            0000
      DO 220 N=N1,N2                                                    0000
      IB=IXY(N)                                                         0000
      IF(IB.GE.1.AND.IB.LE.NBBSZ) QBSZ(IB)=QBSZ(IB)+1.0                 0000
  220 CONTINUE                                                          0000
      IF(IBSZ.LE.2) GOTO 340                                            0000
      SUM2=0.0                                                          0000
      DQ=SQRT(CN)                                                       0000
      IR=1                                                              0000
      QS=0                                                              0000
      R0=0                                                              0000
      Q1=DQ                                                             0000
      SUM2=0                                                            0000
  300 IF(QS+QBSZ(IR).GE.Q1) THEN                                        0000
          IF(IR.EQ.1) THEN                                              0000
              R1=SQRT(Q1/QBSZ(IR))                                      0000
            ELSE                                                        0000
              R1=(IR-1)+(Q1-QS)/QBSZ(IR)                                0000
            ENDIF                                                       0000
          SUM2=SUM2+1.0/((R1-R0)*(R1+R0))                               0000
          R0=R1                                                         0000
          Q1=Q1+DQ                                                      0000
        ELSE                                                            0000
          QS=QS+QBSZ(IR)                                                0000
          IR=IR+1                                                       0000
          IF(IR.GT.NBBSZ) GOTO 320                                      0000
        ENDIF                                                           0000
      GOTO 300                                                          0000
  320 IF(QS.GT.0) SUM2=2.0*DQ/QS/DBBSZ*SQRT(SUM2)                       0000
      IF(SUM2.NE.0) THEN                                                0000
          BSZ(NT,J,2)=1.0/SUM2                                          0000
        ELSE                                                            0000
          BSZ(NT,J,2)=0                                                 0000
        ENDIF                                                           0000
      GOTO 400                                                          0000
  340 SUM2=0                                                            0000
      DO 350 IB=1,NBBSZ-2                                               0000
  350 SUM2=SUM2+(QBSZ(IB+2)-QBSZ(IB))**2                                0000
      SUM2=SUM2/48.0                                                    0000
      DO 360 IB=1,NBBSZ                                                 0000
  360 SUM2=SUM2+QBSZ(IB)**2                                             0000
      IF(SUM2.NE.0) THEN                                                0000
          BSZ(NT,J,2)=DBBSZ*CN**2/(2.0*RTPI*SUM2)                       0000
        ELSE                                                            0000
          BSZ(NT,J,2)=0                                                 0000
        ENDIF                                                           0000
  400 CONTINUE                                                          0000
      RETURN                                                            0000
C-- PRINT AND PLOT                                                      0000
  500 IF(IDEST.LE.0) GOTO 700                                           0000
      WRITE(6,550)                                                      0000
  550 FORMAT(/,' ***** TRANSVERSE BEAMSIZE CHANGE *****')               0000
      IF(IBSZ.EQ.1) WRITE(6,552)                                        0000
  552 FORMAT(10X,'X1= SQRT(AVERAGE(X**2))',/,                           0000
     %     10X,'X2 = 1/(2*SQRT(PI))/(INTEGRAL NX(X)**2*DX)',/,          0000
     %     10X,'FOR EACH Z-ZLICE IN BEAM #1',/,                         0000
     %     10X,'IF GAUSSIAN, X1=X2=SIGX. (UNIT:INITIAL SIGX)')          0000
      IF(IBSZ.EQ.2) WRITE(6,554)                                        0000
  554 FORMAT(10X,'Y1= SQRT(AVERAGE(Y**2))',/,                           0000
     %     10X,'Y2 = 1/(2*SQRT(PI))/(INTEGRAL NY(Y)**2*DY)',/,          0000
     %     10X,'FOR EACH Z-ZLICE IN BEAM #1',/,                         0000
     %     10X,'IF GAUSSIAN, Y1=Y2=SIGY. (UNIT:INITIAL SIGY)')          0000
      IF(IBSZ.EQ.3) WRITE(6,556)                                        0000
  556 FORMAT(10X,'R1 = SQRT(AVERAGE(X**2+Y**2)/2)',/,                   0000
     %     10X,'R2 = 1/SQRT( INTEGRAL 2*NR(R)**2*R*DR )',/,             0000
     %     10X,'FOR EACH Z-ZLICE IN BEAM #1',/,                         0000
     %     10X,'IF GAUSSIAN, R1=R2=SIGX. (UNIT:INITIAL SIGX)')          0000
      WRITE(6,558) (ZBSZ(J),J=1,NZBSZ)                                  0000
  558 FORMAT('   T/SIGZ   ',5('    Z/SIGZ=',F7.3,2X),                   0000
     %    /,('            ',5('    Z/SIGZ=',F7.3,2X)))                  0000
      WRITE(6,560) (NPIZ(IZBSZ(2,J)+1,IBEAM)                            0000
     %             -NPIZ(IZBSZ(1,J),IBEAM),J=1,NZBSZ)                   0000
  560 FORMAT((12X,5('   NP=',I6,8X)))                                   0000
      WRITE(6,570) (LXYR(IBSZ),I=1,2)                                   0000
  570 FORMAT(12X,5('      ',A1,'1       ',A1,'2   '))                   0000
      DO 600 I=MT1,MT+MT1-2                                             0000
      WRITE(6,580) I*DT0,(BSZ(I,J,1),BSZ(I,J,2),J=1,MIN(5,NZBSZ))       0000
  580 FORMAT(1X,F8.5,3X,5(2X,2F9.5))                                    0000
      IF(NZBSZ.GE.6) WRITE(6,590) (BSZ(I,J,1),BSZ(I,J,2),J=6,NZBSZ)     0000
  590 FORMAT((12X,5(2X,2F9.5)))                                         0000
  600 CONTINUE                                                          0000
C                                                                       0000
  700 WRITE(6,705) LXYR(IBSZ),IFLTD,(ZBSZ(J),J=1,NZBSZ)                 0000
  705 FORMAT(' (SUBR.PLZBSZ) PLOT ',A1,'(T) ON FT0',I1,'F001.',/,       0000
     % '    FOR Z=',15F8.4)                                             0000
      KK=2                                                              0000
C       RMS IS PLOTTED, FOR THE TIME BEING                              0000
      TMIN=-2.5                                                         0000
      TMAX=2.5                                                          0000
      FMAX=0                                                            0000
      DO 710 J=1,NZBSZ                                                  0000
      DO 710 I=MT1,MT+MT1-2                                             0000
  710 FMAX=MAX(FMAX,BSZ(I,J,KK))                                        0000
      IF(FMAX.LE.0) RETURN                                              0000
      FMAX=ROUND(FMAX,2)                                                0000
      DO 800 J=0,NZBSZ                                                  0000
      CHWORK='SIGX'                                                     0000
      IF(IBSZ.EQ.2) CHWORK='SIGY'                                       0000
      CALL TDHEAD                                                       0000
      WRITE(IFLTD,720) LXYR(IBSZ),CHWORK,TMIN,TMAX,FMAX                 0000
  720 FORMAT(' SET STORAGE X Y SYMBOL',/,                               0000
     %   ' TITLE BOTTOM ',1H','T/SIGZ',1H',/,                           0000
     %   ' TITLE LEFT ',1H',A1,'/',A4,1H',/,                            0000
     %   ' SET LIMIT X FROM ',F6.3,' TO ',F6.3,/,                       0000
     %   ' SET LIMIT Y FROM 0.0 TO ',F10.4)                             0000
      IF(J.EQ.0) THEN                                                   0000
          J1=1                                                          0000
          J2=NZBSZ                                                      0000
        ELSE                                                            0000
          J1=J                                                          0000
          J2=J                                                          0000
          WRITE(IFLTD,740) ZBSZ(J)                                      0000
  740     FORMAT(' TITLE TOP ',1H','   Z=',F6.3,1H')                    0000
        ENDIF                                                           0000
      DO 780 JJ=J1,J2                                                   0000
      WRITE(IFLTD,750) (I*DT0,BSZ(I,JJ,KK),I=MT1,MT+MT1-2)              0000
  750 FORMAT(3(F11.5,F12.8,';'))                                        0000
      WRITE(IFLTD,770)                                                  0000
  770 FORMAT(' JOIN 1')                                                 0000
  780 CONTINUE                                                          0000
  800 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
