C   14/04/87 910032137  MEMBER NAME  PRTIME   *.FORT     M  FORTRAN77
C******************** PRTIME *******************************************
      SUBROUTINE PRTIME(K,NC,CHAR)
C K=-2: INITIALISE THE CLOCK FOR THE RUN (DEFINE TIME00)
C  =-1: INITIALISE THE CLOCK FOR THE STEP (DEFINE TIME0 & CLEAR TIME(K))
C  =0 : RESET TIME1 (FOR THE NEXT LAP TIME MESUREMENT)
C   1 TO 8 : SUM THE LAP TIME SINCE THE LAST CALL TO K-TH CLOCK TIME(K)
C   9      : UNUSED
C   20: PRINT CPU-TIME FROM THE RUN START.
C        ( NC CHARACTERS CHAR ARE PRINTED )
C   30: PRINT TOTAL CPU TIME FOR ALL K CLOCKS IN THIS STEP
C   40: RUN END
      PARAMETER (NA=10)
      COMMON/TIMCOM/TIME(NA),TIME1,TIME0,TIME00
      CHARACTER*12 A(NA)/'INITIAL','DISTRIBUTION','LUMINOSITY','FIELD',
     %    'FORCE','COULMB','MOTION','GENERT(LEP)','MOTION(LEP)',
     %    'GRAPHIC ETC'/
      CHARACTER*1 CHAR(NC)
      IF(K.LE.-2) CALL CLOCK1(DUMMY,0)
      CALL CLOCK1(TIME2,1)
      IF(K.GT.NA) GOTO 140
      IF(K.GE.1) TIME(K)=TIME(K)+(TIME2-TIME1)
      TIME1=TIME2
      IF(K.GE.0) RETURN
      TIME0=TIME1
      DO 120 I=1,NA
  120 TIME(I)=0.0
      IF(K.LE.-2) TIME00=TIME0
      RETURN
  140 IF(K.GE.30) GOTO 200
      WRITE(6,160) TIME2-TIME00,(CHAR(I),I=1,NC)
  160 FORMAT(45X,'CPU-TIME SO FAR =',F8.3,'(SEC)',5X,50A1)
      RETURN
  200 IF(K.GE.40) GOTO 240
      WRITE(6,220)
  220 FORMAT(//,10X,'***** CPU-TIME IN THIS STEP (SEC) *****')
      WRITE(6,230) 'TOTAL',TIME2-TIME0,(A(I),TIME(I),I=1,NA)
  230 FORMAT(2X,A12,F10.3)
C 230 FORMAT(3(2X,A12,F10.3))
      RETURN
  240 WRITE(6,260) TIME2-TIME00
  260 FORMAT(//,10X,'----- TOTAL CPU-TIME IN THIS RUN =',F12.3,
     % '(SEC) -----')
      RETURN
      END
