      SUBROUTINE QTVRTL(RTVRTL,XTV,GAM,X,IRR)
      IMPLICIT REAL*8 ( A-H,O-Z)
       REAL*4 GAM,RTVRTL,RAN,XTV,dummy
C* RTVRTL :Transverse impact parameter of the virtual photon in m.
C* XTV    :Transverse energy of the virtual photon in unit of el. mass.
C* GAM    :Gamma factor of electrons = Energy/mass
C* X      :Scaled energy of the virtual photon(Egamma/E)
C* IRR    :seed for random number generator.
      DATA EMASS/0.5110034D-3/,CNVRT/0.197327D-15/
      DATA FNORM/0.3248D0/,XMAX/50.D0/
C---  XMAX ->only consider the large impact parameters > 5x10**(-11) m.
      RTVRTL = 0.
      XTMIN  = 1.D0/DBLE(GAM)
CCC      XTMIN  = XTMIN/SQRT(1.D0-X)
      XTMIN2 = 1.D0 + XTMIN**2
      XTMAX  = 1.D0/X
      XTMAX2 = 1.D0 + XTMAX**2
      XMAX2  = 1.D0 + XMAX**2
C***
      IF( XTMAX.GT.XMAX) THEN
C***
ccc       RLRG   = DLOG(XMAX2)+1.D0/XMAX2 -1.D0
       RLRG   = DLOG(XTMAX2/XMAX2)+1.D0/XTMAX2 -1.D0/XMAX2
       RLRG   = RLRG/(DLOG(XTMAX2/XTMIN2)+1.D0/XTMAX2-1.D0/XTMIN2)
C---
        IF(RAN(IRR).LT.RLRG) THEN
C---
         XT = XMAX*(XTMAX/XMAX)**RAN(IRR)
C---
         ELSE
C---
C--- Max. peak  is   sqrt(3)
CCC      XKMAX  = 1.7321D0 and FNORM  = 0.3248
         XTRNG  = XMAX - XTMIN
         NLOOP = 0
1        CONTINUE
         NLOOP = NLOOP + 1
         IF(NLOOP.GT.40000) THEN
          PRINT *,' FNORM in RTVRTL=',FNORM,' ETX,RAN =',ETX,RAN(IRR)
          PRINT *,' -1- X, XTMAX   =',X,XTMAX
          RETURN
         ENDIF
         XT     = RAN(IRR)*XTRNG + XTMIN
         XT2    = XT*XT
         ETX    = XT2*XT/(XT2+1.D0)/(XT2+1.D0)/FNORM
         IF(RAN(IRR).GT.ETX) GO TO 1
C---
        ENDIF
C---
C***
      ELSE
C***
         XTRNG  = XTMAX - XTMIN
         NLOOP = 0
11       CONTINUE
         NLOOP = NLOOP + 1
         IF(NLOOP.GT.40000) THEN
          PRINT *,' FNORM in RTVRTL=',FNORM,' ETX,RAN =',ETX,RAN(IRR)
          PRINT *,' -2- X, XTMAX   =',X,XTMAX
          RETURN
         ENDIF
         XT     = RAN(IRR)*XTRNG + XTMIN
         XT2    = XT*XT
         ETX    = XT2*XT/(XT2+1.D0)/(XT2+1.D0)/FNORM
         IF(RAN(IRR).GT.ETX) GO TO 11
C***
      ENDIF
C***
      XT     = XT*EMASS*X
      RTVRTL = SNGL( CNVRT/XT )
      XTV    = XT/EMASS
C---
       dummy = XTV/X
      CALL HCUM1('XTVR',dummy,1.)
      CALL HCUM1('RTVR',RTVRTL*1.E+09,1.)
      CALL HCUM1('RLRG',SNGL(RLRG),1.)
C---
      RETURN
      END












