C   27/09/89 910041451  MEMBER NAME  TDSCTP   *.FORT        FORTRAN77   0000
      SUBROUTINE TDSCTP(IFLTD,N,X,Y,SCAL,TTLT,TTLB,TTLL)                0000
C  SCATTER PLOT OF (X(I),Y(I),I=1,N)  BY TOPDRAWER                      0000
C  SCAL IS AN ARRAY OF LENGTH (4,2).                                    0000
C   SCAL(1,J): IF>0, LOG SCALE.  (J=X AND Y)                            0000
C   SCAL(2,J): LEFT(BOTTOM) LIMIT.  IF>=1E59, FREE SCALE.               0000
C   SCAL(3,J): RIGHT(TOP) LIMIT.  IF>=1E59, FREE SCALE.                 0000
C             (IN CASE OF FREE SCALE, THE ACTUALLY USED VALUES WILL     0000
C              BE STORED ON RETURN)                                     0000
C   SCAL(4,J): IF >0, INPUT VALUES OF X(Y) ARE MULTIPLIED BY SCAL(4).   0000
C            SCAL(2) AND SCAL(3) ARE ASSUMED TO HAVE ALREADY BEEN       0000
C            MULTIPLIED.                                                0000
C  TTL'S ARE TITLES.  STRING FOR 'CASE' CAN BE PUT IN AFTER SEMICOLON.  0000
C    @ MUST BE PLACED AT THE END OF WHOLE STRING.                       0000
      DIMENSION X(N),Y(N),SCAL(4,2)                                     0000
      CHARACTER*(*) TTLT,TTLB,TTLL                                      0000
      CHARACTER*80 TTL                                                  0000
      CHARACTER*1 LXY(2)/'X','Y'/                                       0000
      CHARACTER*6 LTL(3)/'TOP','BOTTOM','LEFT'/                         0000
      DIMENSION LENG(3,2),XYMAX(2),XYMIN(2),FACT(2)                     0000
C                                                                       0000
      IF(N.LE.0) RETURN                                                 0000
      XYMAX(1)=X(1)                                                     0000
      XYMIN(1)=X(1)                                                     0000
      XYMAX(2)=Y(1)                                                     0000
      XYMIN(2)=Y(1)                                                     0000
      DO 180 I=1,N                                                      0000
      XYMAX(1)=MAX(XYMAX(1),X(I))                                       0000
C      XYMIN(1)=MIN(XYMIN(1),X(I))                                       0000
       IF(X(I).LT.XYMIN(1)) XYMIN(1)=X(I)
      XYMAX(2)=MAX(XYMAX(2),Y(I))                                       0000
C      XYMIN(2)=MIN(XYMIN(2),Y(I))   
       IF(Y(I).LT.XYMIN(2)) XYMIN(2)=Y(I)
      
  180 CONTINUE
                                    
      
      DO 340 J=1,2                                                      0000
      FACT(J)=1                                                         0000
      IF(SCAL(4,J).GT.0) THEN                                           0000
          FACT(J)=SCAL(4,J)                                             0000
          XYMAX(J)=FACT(J)*XYMAX(J)                                     0000
          XYMIN(J)=FACT(J)*XYMIN(J)                                     0000
        ENDIF                                                           0000
      IF(SCAL(2,J).GE.1E29) GOTO 220                                    0000
      IF(SCAL(3,J).GE.1E29) GOTO 240                                    0000
      XYMAX(J)=SCAL(3,J)                                                0000
      XYMIN(J)=SCAL(2,J)                                                0000
      GOTO 280                                                          0000
  220 IF(SCAL(3,J).GE.1E29) GOTO 260                                    0000
      IF(SCAL(3,J).GE.XYMIN(J)) THEN                                    0000
          SCAL(2,J)=XYMIN(J)                                            0000
        ELSE                                                            0000
          SCAL(2,J)=XYMAX(J)                                            0000
        ENDIF                                                           0000
      GOTO 280                                                          0000
  240 IF(SCAL(2,J).LE.XYMAX(J)) THEN                                    0000
          SCAL(3,J)=XYMAX(J)                                            0000
        ELSE                                                            0000
          SCAL(3,J)=XYMIN(J)                                            0000
        ENDIF                                                           0000
      GOTO 280                                                          0000
  260 SCAL(2,J)=XYMIN(J)                                                0000
      SCAL(3,J)=XYMAX(J)                                                0000
  280 IF(SCAL(2,J).EQ.SCAL(3,J)) GOTO 920                               0000
      IF(SCAL(1,J).GT.0.AND.(SCAL(2,J).LE.0.OR.SCAL(3,J).LE.0)) THEN    0000
          WRITE(6,300) LXY(J)                                           0000
  300     FORMAT(' (SUBR.TDSCTP) NON-POSITIVE VALUE IN ',A1,' AXIS ',   0000
     %             'FOR LOG SCALE.  LINEAR SCALE ASSUMED.')             0000
          SCAL(1,J)=0                                                   0000
        ENDIF                                                           0000
  340 CONTINUE                                                          0000
      DO 400 L=1,3                                                      0000
      LENG(L,1)=0                                                       0000
      LENG(L,2)=0                                                       0000
      IF(L.EQ.1) LEN1=LEN(TTLT)                                         0000
      IF(L.EQ.2) LEN1=LEN(TTLB)                                         0000
      IF(L.EQ.3) LEN1=LEN(TTLL)                                         0000
      IF(LEN1.LE.0) GOTO 400                                            0000
      LEN1=MIN(LEN1,80)                                                 0000
      IF(L.EQ.1) TTL=TTLT                                               0000
      IF(L.EQ.2) TTL=TTLB                                               0000
      IF(L.EQ.3) TTL=TTLL                                               0000
      IC=1                                                              0000
      DO 360 I=1,LEN1                                                   0000
      IF(TTL(I:I).EQ.';') THEN                                          0000
          IC=IC+1                                                       0000
          IF(IC.GE.3) GOTO 400                                          0000
          GOTO 360                                                      0000
        ENDIF                                                           0000
      IF(TTL(I:I).EQ.'@') GOTO 400                                      0000
      LENG(L,IC)=LENG(L,IC)+1                                           0000
  360 CONTINUE                                                          0000
      LENG(L,2)=MIN(LENG(L,1),LENG(L,2))                                0000
  400 CONTINUE                                                          0000
C
      CALL TDHEAD 
      WRITE(IFLTD,420) (SCAL(2,J),SCAL(3,J),J=1,2)                      0000
  420 FORMAT(' SET LIMIT X FROM ',1PE11.4,' TO ',1PE11.4,/,             0000
     % ' SET LIMIT Y FROM ',1PE11.4,' TO ',1PE11.4)                     0000
      DO 440 J=1,2                                                      0000
      IF(SCAL(1,J).GT.0) WRITE(IFLTD,430) LXY(J)                        0000
  430 FORMAT(' SET SCALE ',A1,' LOG')                                   0000
  440 CONTINUE                                                          0000
      DO 500 L=1,3                                                      0000
      IF(LENG(L,1).LE.0) GOTO 500                                       0000
      IF(L.EQ.1) TTL=TTLT                                               0000
      IF(L.EQ.2) TTL=TTLB                                               0000
      IF(L.EQ.3) TTL=TTLL                                               0000
      WRITE(IFLTD,460) LTL(L),TTL(1:LENG(L,1))                          0000
  460 FORMAT(' TITLE ',A6,/,' MORE ',2H' ,A,1H')                        0000
      IF(LENG(L,2).LE.0) GOTO 500                                       0000
      WRITE(IFLTD,480) TTL(LENG(L,1)+2:LENG(L,1)+LENG(L,2)+1)           0000
  480 FORMAT(' CASE  ',1H',A,1H')                                       0000
  500 CONTINUE                                                          0000
C--
      I2=0                                                              0000
  520 I1=I2+1                                                           0000
      I2=MIN(N,I1+1000)                                                 0000
      WRITE(IFLTD,540) (X(I)*SCAL(4,1),Y(I)*SCAL(4,2),I=I1,I2)          0000
  540 FORMAT(3(1PE11.4,',',1PE11.4,';'))                                0000
      WRITE(IFLTD,560)                                                  0000
  560 FORMAT(' PLOT ')                                                  0000
      IF(I2.LT.N) GOTO 520                                              0000
      RETURN                                                            0000
C                                                                       0000
  920 WRITE(6,930) LXY(J)                                               0000
  930 FORMAT(' (SUBR.TDSCTP) WRONG ',A1,'-AXIS. PLOT IGNORED.')         0000
      RETURN                                                            0000
      END                                                               0000
