C   23/02/88 802231150  MEMBER NAME  THEOR2   *.FORT        FORTRAN77   0000
      SUBROUTINE THEOR2(GZI0,AVNPH)                                     0000
C  HIGH ENERGY EDGE OF ELECTRON SPECTRUM. THEORY.                       0000
      IMPLICIT REAL*8 (A-H,O-Z)                                         0000
      DIMENSION GZI0(2),AVNPH(2)
      DIMENSION U0(2),F(2),FF(2)                          
C      REAL*8 UQRAD,GZI1                                                 0000
      CHARACTER*1 CH(2)                                                 0000
C                                                                       0000
      NDE=10                                                            0000
      DE=0.02                                                           0000
      WRITE(6,200)                                                      0000
  200 FORMAT(/,'  **** HIGH ENERGY EDGE OF ELECTRON SPECTRUM ',         0000
     %  '(THEORY) ****',/,                                              0000
     %  10X,'* : INACCURATE BECAUSE OUT OF VALID RANGE OF FORMULA',/,   0000
     % 27X,'BEAM#1',17X,'BEAM#2',/,                                     0000
     % 9X,'E1    E2',2('     N(E1<E<E2) N(E1<E)'))                      0000
      DO 220 L=1,2                                                      0000
      GZI1=GZI0(L)                                                      0000
      U0(L)=UQRAD(0,GZI1)                                               0000
  220 FF(L)=0.0                                                         0000
      FAC=SQRT(3.0)*2.0**(5.0/3.0)/5.0                                  0000
      DO 400 I=0,NDE                                                    0000
      DE1=I*DE                                                          0000
      E1=1.0-DE1                                                        0000
      E2=E1+DE                                                          0000
      IF(I.EQ.0) E2=E1                                                  0000
      DO 280 L=1,2                                                      0000
      CH(L)=' '                                                         0000
      IF(DE1.GE.0.3*MIN(0.5D0,GZI0(L)/(GZI0(L)+1.0D0))) CH(L)='*'           0000
      X=FAC*(DE1/GZI0(L))**(1.0/3.0)*AVNPH(L)/U0(L)                     0000
      FF1=EXP(FESPEC(X)-AVNPH(L))                                       0000
      F(L)=FF1-FF(L)                                                    0000
      FF(L)=FF1                                                         0000
  280 CONTINUE                                                          0000
      WRITE(6,300) E1,E2,(CH(L),F(L),FF(L),L=1,2)                       0000
  300 FORMAT(5X,2F6.3,2(2X,A1,2F10.5))                                  0000
  400 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
